/*
 *	(c) Copyright 1992 North Valley Research, Inc.
 *		All Rights Reserved
 *
 *	Confidential -- All proprietary rights reserved.
 *	Licensed Material -- Property of North Valley Research, Inc.
 *
 *	This program is the property of North Valley Research, Inc. or others
 *	from whom North Valley Research has obtained a licensing right, and is
 *	considered by North Valley Research to be confidential.  It is protected
 *	by U.S. copyright law as an unpublished work and is
 *	furnished pursuant to a written license agreement.  It may
 *	not be used, copied or otherwise reproduced, or disclosed to
 *	others except in accordance with the terms and conditions of
 *	that agreement.
 *
 *	NAME
 *		MpegControl.H -- Include file for MpegControl.C routines.
 *
 *	DESCRIPTION
 *		
 *
 *	REVISION
 *		$Header: /usr/local/src/nvrToMIT/RCS/MpegControl.h,v 1.3 1994/07/15 03:32:40 toddb Exp $
 */
#ifndef _MpegControl_H_
#define _MpegControl_H_

#include "nvrImage.h"
#include "MpegDisplay.h"
#include "fileContent.h"

#ifdef debug
# define	INTERNAL_ERROR(m)	InternalError(m)
#else
# define	INTERNAL_ERROR(m)
#endif


/*
 *	DEFINES
 */
#define MIN_VIDEODISPLAY_WIDTH	320
#define MIN_VIDEODISPLAY_HEIGHT	240

#define MAX_PATH_LEN  160


/*
 *	TYPEDEFS
 */

typedef enum {
    DestX,
    DestScreenFb,
    DestYcFb,
    DestFile
} MpegDestination;

typedef struct _mpegDecodeResources {
    char		*displayDevice;
    RgbDepthType 	depth;
    float		gamma;
    char		*destName;
    MpegDestination	destType;
    Boolean		mpegBig;
} MpegDecodeResources;

extern char *MpegDestNames[4];
/*
 * Mpeg control functions
 */
extern void MpegSetFile(char *video, ImageFileInfo *vInfo,
			char *audio, FileInfo *aInfo);
extern void MpegSetAudioQuality(int value);
extern void MpegSetDest(MpegDestination);
extern void MpegSetBitServer(char *serverName);
extern void MpegSetFrameSize(void);
extern void MpegInit(void);
extern void MpegPlay(void);

/*
 * UI functions
 */
extern void SetUIMpegSelectionPath(char *path);
extern void SetUIMpegFilePath(char *path);

#endif /* _MpegControl_H_ */
