/* $Header: /usr/local/src/nvrToMIT/RCS/buildverify.c,v 3.1 1993/10/22 23:53:29 russ Exp $ */

#define NeedFunctionPrototypes 1

#include <stdio.h>
#include <sys/types.h>

typedef u_char	boolean;

#define True	1
#define False	0

char	*Program;

typedef struct {
    int binary;
    int decimal;
} Comparison;

void Error();
void Fatal();
void Usage();
void Msg();

char *TestProgram = "\n\
#include \"decoder.h\"\n\
#include \"huffman.h\"\n\
#include <stdio.h>\n\
\n\
typedef struct {\n\
    int binary;\n\
    int decimal;\n\
} Comparison;\n\
\n\
extern Comparison Data[];\n\
extern int ComparisonSize;\n\
\n\
main()\n\
{\n\
    int i, nFailures;\n\
\n\
    nFailures = 0;\n\
    for (i = 0; i < ComparisonSize; i++) {\n\
	if (Data[i].binary != Data[i].decimal) {\n\
	    fprintf(stderr, \"mismatch, cell %d: %d(0x%x) vs. %d(0x%x)\\n\",\n\
		i,\n\
		Data[i].binary, Data[i].binary,\n\
		Data[i].decimal, Data[i].decimal);\n\
	    if (++nFailures > 15) {\n\
		fprintf(stderr, \"...\\n\");\n\
		exit (1);\n\
	    }\n\
	}\n\
    }\n\
    exit(0);\n\
}";

char *NtoBinary(int value, int stringLen, int nBits)
{
    int i, bitsPrinted;
    static char buf[ BUFSIZ ];
    char *p;

    sprintf(buf, "Binary%d(", stringLen);
    p = buf + strlen(buf);
    bitsPrinted = 0;
    for (i = stringLen-1; i >= 0; i--) {
	*p++ = '0' + ((value & (1<<i)) != 0);
	if ((++bitsPrinted & 0x3) == 0)
	    *p++ = ',';
    }
    if (bitsPrinted & 0x3)
	*p++ = ',';
    *p = '\0';

    sprintf(p, "%*s%d),", 25 - strlen(buf), "", nBits);
    return (buf);
}

main(int argc, char **argv)
{
    int	    argcnt = 0;
    int     cell = 0;
    int	    maxBits, stringLen, nBits, value;

    Program = *argv;
    if (argc != 2)
	Usage();

    maxBits = atoi(argv[1]);
    printf("%s\n", TestProgram);
    printf("Comparison Data[] = {\n"); 
    for (nBits = 1; nBits <= maxBits; nBits++) {
	for (stringLen = 1; stringLen <= nBits; stringLen++) {
	    for (value = 1; value <= (1<<(stringLen-1)); value++) {
		printf("/\* #%-6d*\/ { %-25s%6d },  /\* 0x%x *\/\n",
		    cell++,
		    NtoBinary(value, stringLen, nBits),
		    value << (nBits-stringLen),
		    value << (nBits-stringLen));
	    }
	}
    }
    printf("};\n"); 
    printf("int ComparisonSize = sizeof(Data)/sizeof(Data[0]);\n"); 
    exit(0);
}

void Msg(char *fmt,int x0,int x1,int x2,int x3,int x4,int x5,int x6,
	 int x7,int x8,int x9)
{
    fprintf(stderr, fmt, x0,x1,x2,x3,x4,x5,x6,x7,x8,x9);
}

void Usage()
{
    Msg("Usage: %s nbits\n", Program);
    exit (1);
}

void Error(cgar *fmt,int x0,int x1,int x2,int x3,int x4,int x5,int x6,
	   int x7,int x8,int x9)
    char    *fmt;
{
    extern char	    *sys_errlist[];
    extern int	    errno;

    Msg("%s: ", Program);
    if (errno)
	Msg("%s: ", sys_errlist[ errno ]);
    Msg(fmt, x0,x1,x2,x3,x4,x5,x6,x7,x8,x9);
}

void Fatal(char *fmt,int x0,int x1,int x2,int x3,int x4,int x5,int x6,
	   int x7,int x8,int x9)
{
    Error(fmt, x0,x1,x2,x3,x4,x5,x6,x7,x8,x9);
    exit(1);
}
