/*
 * Copyright (c) 1992,1993,1994 North Valley Research, Inc.
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	<file name> - <one-line description of file contents>
 *
 * DESCRIPTION
 *	<overall description of what the c code does>
 *
 * $Header: /usr/local/src/nvrToMIT/RCS/gcc-motion.c,v 4.7 1994/01/27 23:20:22 toddb Exp $
 */

#define NeedFunctionPrototypes 1

#include "vmpegdecomp.h"
#include "idct.h"
#include "motion.h"

GlobalRegister(MacroBlockInfo *Pmb, "%g7");

void NoMotionAndClamp0Dc(long in)
{
    long clamped;
    OctWord final;
    UChar *out = Pmb->pTo;

    IntraClamp(clamped, in);
    final.l.low = final.l.high =
	(clamped << 24) | (clamped << 16) | (clamped << 8) | clamped;
    *OctWordP(out+MAX_X*0) = final;
    *OctWordP(out+MAX_X*1) = final;
    *OctWordP(out+MAX_X*2) = final;
    *OctWordP(out+MAX_X*3) = final;
    *OctWordP(out+MAX_X*4) = final;
    *OctWordP(out+MAX_X*5) = final;
    *OctWordP(out+MAX_X*6) = final;
    *OctWordP(out+MAX_X*7) = final;
}

void NoMotionAndClamp()
{
    OctWord final;
    Get9Arguments(
	long, in0,
	long, in1,
	long, in2,
	long, in3,
	long, in4,
	long, in5,
	long, in6,
	long, in7,
	long, row)

    IntraClampOp(final.l.high,  =, in0); final.l.high <<= 8;
    IntraClampOp(final.l.high, |=, in1); final.l.high <<= 8;
    IntraClampOp(final.l.high, |=, in2); final.l.high <<= 8;
    IntraClampOp(final.l.high, |=, in3);
    IntraClampOp(final.l.low,   =, in4); final.l.low <<= 8;
    IntraClampOp(final.l.low,  |=, in5); final.l.low <<= 8;
    IntraClampOp(final.l.low,  |=, in6); final.l.low <<= 8;
    IntraClampOp(final.l.low,  |=, in7);
    *OctWordP(Pmb->pTo+row*MAX_X) = final;
}

void MotionHalfVertAndClamp0Dc(long in)
{
    long value, i;
    OctWord final;
    UChar *pTime = Pmb->pFuture;
    UChar *out = Pmb->pTo;

    /*
     * Process one row at a time
     */
    in = PreNonIntraClamp(in);
    for (i = 8; i > 0; i--) {
	value = in;
	MotionHalfVert(FastNonIntraClamp, final.l.high,  =, value, pTime);
	value = in; final.l.high <<= 8;
	MotionHalfVert(FastNonIntraClamp, final.l.high, |=, value, pTime+1);
	value = in; final.l.high <<= 8;
	MotionHalfVert(FastNonIntraClamp, final.l.high, |=, value, pTime+2);
	value = in; final.l.high <<= 8;
	MotionHalfVert(FastNonIntraClamp, final.l.high, |=, value, pTime+3);
	value = in;
	MotionHalfVert(FastNonIntraClamp, final.l.low,  =, value, pTime+4);
	value = in; final.l.low <<= 8;
	MotionHalfVert(FastNonIntraClamp, final.l.low, |=, value, pTime+5);
	value = in; final.l.low <<= 8;
	MotionHalfVert(FastNonIntraClamp, final.l.low, |=, value, pTime+6);
	value = in; final.l.low <<= 8;
	MotionHalfVert(FastNonIntraClamp, final.l.low, |=, value, pTime+7);
	*OctWordP(out) = final;
	out += MAX_X;
	pTime += MAX_X;
    }
}

void MotionHalfVertAndClamp()
{
    UChar *pTime;
    OctWord final;
    Get9Arguments(
	long, in0,
	long, in1,
	long, in2,
	long, in3,
	long, in4,
	long, in5,
	long, in6,
	long, in7,
	long, row)

    pTime = Pmb->pFuture+row*MAX_X;

    MotionHalfVert(NonIntraClampOp, final.l.high,  =, in0, pTime);
    final.l.high <<= 8;
    MotionHalfVert(NonIntraClampOp, final.l.high, |=, in1, pTime+1);
    final.l.high <<= 8;
    MotionHalfVert(NonIntraClampOp, final.l.high, |=, in2, pTime+2);
    final.l.high <<= 8;
    MotionHalfVert(NonIntraClampOp, final.l.high, |=, in3, pTime+3);

    MotionHalfVert(NonIntraClampOp, final.l.low,  =, in4, pTime+4);
    final.l.low <<= 8;
    MotionHalfVert(NonIntraClampOp, final.l.low, |=, in5, pTime+5);
    final.l.low <<= 8;
    MotionHalfVert(NonIntraClampOp, final.l.low, |=, in6, pTime+6);
    final.l.low <<= 8;
    MotionHalfVert(NonIntraClampOp, final.l.low, |=, in7, pTime+7);

    *OctWordP(Pmb->pTo+row*MAX_X) = final;
}

void MotionHalfHorizAndClamp0Dc(long in)
{
    long value, i;
    OctWord final;
    UChar *pTime = Pmb->pFuture;
    UChar *out = Pmb->pTo;

    /*
     * Process one row at a time
     */
    in = PreNonIntraClamp(in);
    for (i = 8; i > 0; i--) {
	value = in;
	MotionHalfHoriz(FastNonIntraClamp, final.l.high, =, value, pTime)
	value = in; final.l.high <<= 8;
	MotionHalfHoriz(FastNonIntraClamp, final.l.high, |=, value, pTime+1)
	value = in; final.l.high <<= 8;
	MotionHalfHoriz(FastNonIntraClamp, final.l.high, |=, value, pTime+2)
	value = in; final.l.high <<= 8;
	MotionHalfHoriz(FastNonIntraClamp, final.l.high, |=, value, pTime+3)
	value = in;
	MotionHalfHoriz(FastNonIntraClamp, final.l.low,  =, value, pTime+4)
	value = in; final.l.low <<= 8;
	MotionHalfHoriz(FastNonIntraClamp, final.l.low, |=, value, pTime+5)
	value = in; final.l.low <<= 8;
	MotionHalfHoriz(FastNonIntraClamp, final.l.low, |=, value, pTime+6)
	value = in; final.l.low <<= 8;
	MotionHalfHoriz(FastNonIntraClamp, final.l.low, |=, value, pTime+7)
	*OctWordP(out) = final;
	out += MAX_X;
	pTime += MAX_X;
    }
}

void MotionHalfHorizAndClamp()
{
    OctWord final;
    UChar *pTime;
    Get9Arguments(
	long, in0,
	long, in1,
	long, in2,
	long, in3,
	long, in4,
	long, in5,
	long, in6,
	long, in7,
	long, row)

    pTime = Pmb->pFuture+row*MAX_X;

    MotionHalfHoriz(NonIntraClampOp, final.l.high,  =, in0, pTime);
    final.l.high <<= 8;
    MotionHalfHoriz(NonIntraClampOp, final.l.high, |=, in1, pTime+1);
    final.l.high <<= 8;
    MotionHalfHoriz(NonIntraClampOp, final.l.high, |=, in2, pTime+2);
    final.l.high <<= 8;
    MotionHalfHoriz(NonIntraClampOp, final.l.high, |=, in3, pTime+3);

    MotionHalfHoriz(NonIntraClampOp, final.l.low,   =, in4, pTime+4);
    final.l.low <<= 8;
    MotionHalfHoriz(NonIntraClampOp, final.l.low,  |=, in5, pTime+5);
    final.l.low <<= 8;
    MotionHalfHoriz(NonIntraClampOp, final.l.low,  |=, in6, pTime+6);
    final.l.low <<= 8;
    MotionHalfHoriz(NonIntraClampOp, final.l.low,  |=, in7, pTime+7);

    *OctWordP(Pmb->pTo+row*MAX_X) = final;
}

void MotionHalfAndClamp0Dc(long in)
{
    long value, i;
    OctWord final;
    UChar *pTime = Pmb->pFuture;
    UChar *out = Pmb->pTo;

    /*
     * Process one row at a time
     */
    in = PreNonIntraClamp(in);
    for (i = 8; i > 0; i--) {
	value = in;
	MotionHalf(FastNonIntraClamp, final.l.high, =, value, pTime)
	value = in; final.l.high <<= 8;
	MotionHalf(FastNonIntraClamp, final.l.high, |=, value, pTime+1)
	value = in; final.l.high <<= 8;
	MotionHalf(FastNonIntraClamp, final.l.high, |=, value, pTime+2)
	value = in; final.l.high <<= 8;
	MotionHalf(FastNonIntraClamp, final.l.high, |=, value, pTime+3)
	value = in;
	MotionHalf(FastNonIntraClamp, final.l.low,   =, value, pTime+4)
	value = in; final.l.low <<= 8;
	MotionHalf(FastNonIntraClamp, final.l.low,  |=, value, pTime+5)
	value = in; final.l.low <<= 8;
	MotionHalf(FastNonIntraClamp, final.l.low,  |=, value, pTime+6)
	value = in; final.l.low <<= 8;
	MotionHalf(FastNonIntraClamp, final.l.low,  |=, value, pTime+7)
	*OctWordP(out) = final;
	out += MAX_X;
	pTime += MAX_X;
    }
}

void MotionHalfAndClamp()
{
    OctWord final;
    UChar *pTime;
    Get9Arguments(
	long, in0,
	long, in1,
	long, in2,
	long, in3,
	long, in4,
	long, in5,
	long, in6,
	long, in7,
	long, row)

    pTime = Pmb->pFuture+row*MAX_X;

    MotionHalf(NonIntraClampOp, final.l.high,  =, in0, pTime);
    final.l.high <<= 8;
    MotionHalf(NonIntraClampOp, final.l.high, |=, in1, pTime+1);
    final.l.high <<= 8;
    MotionHalf(NonIntraClampOp, final.l.high, |=, in2, pTime+2);
    final.l.high <<= 8;
    MotionHalf(NonIntraClampOp, final.l.high, |=, in3, pTime+3);

    MotionHalf(NonIntraClampOp, final.l.low,   =, in4, pTime+4);
    final.l.low <<= 8;
    MotionHalf(NonIntraClampOp, final.l.low,  |=, in5, pTime+5);
    final.l.low <<= 8;
    MotionHalf(NonIntraClampOp, final.l.low,  |=, in6, pTime+6);
    final.l.low <<= 8;
    MotionHalf(NonIntraClampOp, final.l.low,  |=, in7, pTime+7);

    *OctWordP(Pmb->pTo+row*MAX_X) = final;
}

void MotionAndClamp0Dc(long in)
{
    long value, i;
    OctWord final;
    UChar *pTime = Pmb->pFuture;
    UChar *out = Pmb->pTo;

    /*
     * Process one row at a time
     */
    in = PreNonIntraClamp(in);
    for (i = 8; i > 0; i--) {
	value = in;
	FastNonIntraClamp(final.l.high, =, pTime[0], value);
	value = in; final.l.high <<= 8;
	FastNonIntraClamp(final.l.high, |=, pTime[1], value);
	value = in; final.l.high <<= 8;
	FastNonIntraClamp(final.l.high, |=, pTime[2], value);
	value = in; final.l.high <<= 8;
	FastNonIntraClamp(final.l.high, |=, pTime[3], value);
	value = in;
	FastNonIntraClamp(final.l.low, =, pTime[4], value);
	value = in; final.l.low <<= 8;
	FastNonIntraClamp(final.l.low, |=, pTime[5], value);
	value = in; final.l.low <<= 8;
	FastNonIntraClamp(final.l.low, |=, pTime[6], value);
	value = in; final.l.low <<= 8;
	FastNonIntraClamp(final.l.low, |=, pTime[7], value);
	*OctWordP(out) = final;
	out += MAX_X;
	pTime += MAX_X;
    }
}

void MotionAndClamp()
{
    OctWord final;
    UChar *pTime;
    Get9Arguments(
	long, in0,
	long, in1,
	long, in2,
	long, in3,
	long, in4,
	long, in5,
	long, in6,
	long, in7,
	long, row)

    pTime = Pmb->pFuture+row*MAX_X;

    NonIntraClampOp(final.l.high,  =, pTime[0], in0); final.l.high <<= 8;
    NonIntraClampOp(final.l.high, |=, pTime[1], in1); final.l.high <<= 8;
    NonIntraClampOp(final.l.high, |=, pTime[2], in2); final.l.high <<= 8;
    NonIntraClampOp(final.l.high, |=, pTime[3], in3);

    NonIntraClampOp(final.l.low,   =, pTime[4], in4); final.l.low <<= 8;
    NonIntraClampOp(final.l.low,  |=, pTime[5], in5); final.l.low <<= 8;
    NonIntraClampOp(final.l.low,  |=, pTime[6], in6); final.l.low <<= 8;
    NonIntraClampOp(final.l.low,  |=, pTime[7], in7);

    *OctWordP(Pmb->pTo+row*MAX_X) = final;
}

void FwdBackMotionAndClamp0Dc(long in)
{
    long value, i;
    OctWord f;
    UChar *pFut = Pmb->pFuture;
    UChar *pPast = Pmb->pPast;
    UChar *out = Pmb->pTo;

    /*
     * Process one row at a time
     */
    in = PreNonIntraClamp(in);
    for (i = 8; i > 0; i--) {
	value = in;
	FwdBackMotion(FastNonIntraClamp, f.l.high, =, value, pPast, pFut)
	value = in; f.l.high <<= 8;
	FwdBackMotion(FastNonIntraClamp, f.l.high, |=, value, pPast+1, pFut+1)
	value = in; f.l.high <<= 8;
	FwdBackMotion(FastNonIntraClamp, f.l.high, |=, value, pPast+2, pFut+2)
	value = in; f.l.high <<= 8;
	FwdBackMotion(FastNonIntraClamp, f.l.high, |=, value, pPast+3, pFut+3)
	value = in;
	FwdBackMotion(FastNonIntraClamp, f.l.low,  =, value, pPast+4, pFut+4)
	value = in; f.l.low <<= 8;
	FwdBackMotion(FastNonIntraClamp, f.l.low, |=, value, pPast+5, pFut+5)
	value = in; f.l.low <<= 8;
	FwdBackMotion(FastNonIntraClamp, f.l.low, |=, value, pPast+6, pFut+6)
	value = in; f.l.low <<= 8;
	FwdBackMotion(FastNonIntraClamp, f.l.low, |=, value, pPast+7, pFut+7)
	*OctWordP(out) = f;
	out += MAX_X;
	pPast += MAX_X;
	pFut += MAX_X;
    }
}

void FwdBackMotionAndClamp()
{
    OctWord f; /* "f" for final */
    UChar *pFuture;
    UChar *pPast;
    Get9Arguments(
	long, in0,
	long, in1,
	long, in2,
	long, in3,
	long, in4,
	long, in5,
	long, in6,
	long, in7,
	long, row)

    pFuture = Pmb->pFuture+row*MAX_X;
    pPast = Pmb->pPast+row*MAX_X;

    FwdBackMotion(NonIntraClampOp, f.l.high,  =, in0, pPast, pFuture);
    f.l.high <<= 8;
    FwdBackMotion(NonIntraClampOp, f.l.high, |=, in1, pPast+1, pFuture+1);
    f.l.high <<= 8;
    FwdBackMotion(NonIntraClampOp, f.l.high, |=, in2, pPast+2, pFuture+2);
    f.l.high <<= 8;
    FwdBackMotion(NonIntraClampOp, f.l.high, |=, in3, pPast+3, pFuture+3);

    FwdBackMotion(NonIntraClampOp, f.l.low,   =, in4, pPast+4, pFuture+4);
    f.l.low <<= 8;
    FwdBackMotion(NonIntraClampOp, f.l.low,  |=, in5, pPast+5, pFuture+5);
    f.l.low <<= 8;
    FwdBackMotion(NonIntraClampOp, f.l.low,  |=, in6, pPast+6, pFuture+6);
    f.l.low <<= 8;
    FwdBackMotion(NonIntraClampOp, f.l.low,  |=, in7, pPast+7, pFuture+7);

    *OctWordP(Pmb->pTo+row*MAX_X) = f;
}

void IllegalMotionAndClamp()
{
    Fatal("Illegal motion and clamp\n");
    /*NOTREACHED*/
}

void (*MotionAndClampTable[64])() = {
    NoMotionAndClamp,
    NoMotionAndClamp,
    NoMotionAndClamp,
    NoMotionAndClamp,
    NoMotionAndClamp,
    NoMotionAndClamp,
    NoMotionAndClamp,
    NoMotionAndClamp,
    NoMotionAndClamp,
    NoMotionAndClamp,
    NoMotionAndClamp,
    NoMotionAndClamp,
    NoMotionAndClamp,
    NoMotionAndClamp,
    NoMotionAndClamp,
    NoMotionAndClamp,
    MotionAndClamp,
    MotionHalfHorizAndClamp,
    MotionHalfVertAndClamp,
    MotionHalfAndClamp,
    MotionHalfHorizAndClamp,
    IllegalMotionAndClamp,
    IllegalMotionAndClamp,
    IllegalMotionAndClamp,
    MotionHalfVertAndClamp,
    IllegalMotionAndClamp,
    IllegalMotionAndClamp,
    IllegalMotionAndClamp,
    MotionHalfAndClamp,
    IllegalMotionAndClamp,
    IllegalMotionAndClamp,
    IllegalMotionAndClamp,
    MotionAndClamp,
    MotionHalfHorizAndClamp,
    MotionHalfVertAndClamp,
    MotionHalfAndClamp,
    MotionHalfHorizAndClamp,
    IllegalMotionAndClamp,
    IllegalMotionAndClamp,
    IllegalMotionAndClamp,
    MotionHalfVertAndClamp,
    IllegalMotionAndClamp,
    IllegalMotionAndClamp,
    IllegalMotionAndClamp,
    MotionHalfAndClamp,
    IllegalMotionAndClamp,
    IllegalMotionAndClamp,
    IllegalMotionAndClamp,
    FwdBackMotionAndClamp,
    FwdBackMotionAndClamp,
    FwdBackMotionAndClamp,
    FwdBackMotionAndClamp,
    FwdBackMotionAndClamp,
    FwdBackMotionAndClamp,
    FwdBackMotionAndClamp,
    FwdBackMotionAndClamp,
    FwdBackMotionAndClamp,
    FwdBackMotionAndClamp,
    FwdBackMotionAndClamp,
    FwdBackMotionAndClamp,
    FwdBackMotionAndClamp,
    FwdBackMotionAndClamp,
    FwdBackMotionAndClamp,
    FwdBackMotionAndClamp,
};

void (*MotionAndClamp0DcTable[64])() = {
    NoMotionAndClamp0Dc,
    NoMotionAndClamp0Dc,
    NoMotionAndClamp0Dc,
    NoMotionAndClamp0Dc,
    NoMotionAndClamp0Dc,
    NoMotionAndClamp0Dc,
    NoMotionAndClamp0Dc,
    NoMotionAndClamp0Dc,
    NoMotionAndClamp0Dc,
    NoMotionAndClamp0Dc,
    NoMotionAndClamp0Dc,
    NoMotionAndClamp0Dc,
    NoMotionAndClamp0Dc,
    NoMotionAndClamp0Dc,
    NoMotionAndClamp0Dc,
    NoMotionAndClamp0Dc,
    MotionAndClamp0Dc,
    MotionHalfHorizAndClamp0Dc,
    MotionHalfVertAndClamp0Dc,
    MotionHalfAndClamp0Dc,
    MotionHalfHorizAndClamp0Dc,
    IllegalMotionAndClamp,
    IllegalMotionAndClamp,
    IllegalMotionAndClamp,
    MotionHalfVertAndClamp0Dc,
    IllegalMotionAndClamp,
    IllegalMotionAndClamp,
    IllegalMotionAndClamp,
    MotionHalfAndClamp0Dc,
    IllegalMotionAndClamp,
    IllegalMotionAndClamp,
    IllegalMotionAndClamp,
    MotionAndClamp0Dc,
    MotionHalfHorizAndClamp0Dc,
    MotionHalfVertAndClamp0Dc,
    MotionHalfAndClamp0Dc,
    MotionHalfHorizAndClamp0Dc,
    IllegalMotionAndClamp,
    IllegalMotionAndClamp,
    IllegalMotionAndClamp,
    MotionHalfVertAndClamp0Dc,
    IllegalMotionAndClamp,
    IllegalMotionAndClamp,
    IllegalMotionAndClamp,
    MotionHalfAndClamp0Dc,
    IllegalMotionAndClamp,
    IllegalMotionAndClamp,
    IllegalMotionAndClamp,
    FwdBackMotionAndClamp0Dc,
    FwdBackMotionAndClamp0Dc,
    FwdBackMotionAndClamp0Dc,
    FwdBackMotionAndClamp0Dc,
    FwdBackMotionAndClamp0Dc,
    FwdBackMotionAndClamp0Dc,
    FwdBackMotionAndClamp0Dc,
    FwdBackMotionAndClamp0Dc,
    FwdBackMotionAndClamp0Dc,
    FwdBackMotionAndClamp0Dc,
    FwdBackMotionAndClamp0Dc,
    FwdBackMotionAndClamp0Dc,
    FwdBackMotionAndClamp0Dc,
    FwdBackMotionAndClamp0Dc,
    FwdBackMotionAndClamp0Dc,
    FwdBackMotionAndClamp0Dc,
};
