/* $Header: /usr/local/src/nvrToMIT/RCS/listcolors.c,v 3.1 1993/10/22 23:53:29 russ Exp $ */

#define NeedFunctionPrototypes 1

#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>

/*VARARGS1*/
void Msg(char *fmt,int int x0,int x1,int x2,int x3,int x4,int x5,int x6,
	 int x7,int x8,int x9)
{
    fprintf(stderr, fmt, x0,x1,x2,x3,x4,x5,x6,x7,x8,x9);
}

static CantFreeColor(Display *dpy, int event)
{
    Msg("locked ");
}

TryToFreeCell(Display *dpy, Colormap cmap, int pixel)
{
    XErrorHandler lastHandler;

    lastHandler = XSetErrorHandler(CantFreeColor);
    XFreeColors(dpy, cmap, &pixel, 1, 0);
    XSync(dpy, False);
    (void) XSetErrorHandler(lastHandler);
}

main()
{
    Display *dpy;
    Colormap cmap;
    int screen;
    int pixel;
    int lastAllocated, currentFree, lastFree, firstFree;
    XColor colorDef;

    if ((dpy = XOpenDisplay(NULL)) == NULL) {
	Msg("Can't open display\n");
	exit(1);
    }

    screen = DefaultScreen(dpy);
    cmap   = DefaultColormap(dpy, screen);
    printf("colormap 0x%x\n", cmap);

    firstFree = lastAllocated = 0;
    lastFree = -1;
    while (XAllocColorCells(dpy, cmap, 0, NULL, 0, &pixel, 1)) {
	colorDef.red   = pixel<<8;
	colorDef.green = pixel<<8;
	colorDef.blue  = pixel<<8;
	colorDef.pixel = pixel;
	colorDef.flags = DoRed | DoGreen | DoBlue;
	currentFree = pixel;
	if (!XStoreColor(dpy, cmap, &colorDef))	/* give it a gray ramp */
	    Msg("StoreColor failed\n");
	XQueryColor(dpy, cmap, &colorDef);
	if (colorDef.red>>8 != pixel
	 || colorDef.blue>>8 != pixel
	 || colorDef.green>>8 != pixel)
	    printf("%3d: %02x %02x %02x not %02x %02x %02x\n",
                colorDef.pixel,
                colorDef.red >> 8,
                colorDef.green >> 8,
                colorDef.blue >> 8,
		pixel, pixel, pixel);

	if (currentFree == lastFree+1) {
	    lastAllocated = currentFree+1;
	    lastFree++;
	    continue;
	} else {
	    if (lastFree - firstFree > 1)
		printf("%3d-%3d: free\n", firstFree, lastFree);
	    else if (lastFree - firstFree == 1)
		printf("%3d: free\n", firstFree);
	    firstFree = lastFree = currentFree;
	}

	while (lastAllocated < currentFree) {
	    colorDef.pixel = lastAllocated++;
	    XQueryColor(dpy, cmap, &colorDef);
    	    TryToFreeCell(dpy, cmap, colorDef.pixel);
	    printf("%3d: %02x %02x %02x\n",
		colorDef.pixel,
		colorDef.red >> 8,
		colorDef.green >> 8,
		colorDef.blue >> 8);
	}
    }
    if (lastFree - firstFree > 1)
	printf("%3d-%3d: free\n", firstFree, lastFree);
    else if (lastFree - firstFree == 1)
	printf("%3d: free\n", firstFree);
    while (lastAllocated < 256) {
	colorDef.pixel = lastAllocated++;
	XQueryColor(dpy, cmap, &colorDef);
	printf("%3d: %02x %02x %02x\n",
	    colorDef.pixel,
	    colorDef.red >> 8,
	    colorDef.green >> 8,
	    colorDef.blue >> 8);
    }
}
