/*
 * Copyright (c) 1992,1993,1994 North Valley Research, Inc.
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	<file name> - <one-line description of file contents>
 *
 * DESCRIPTION
 *	<overall description of what the c code does>
 *
 * $Header: /usr/local/src/nvrToMIT/RCS/mips-gcc-idct.c,v 1.5 1994/01/27 23:20:22 toddb Exp $
 */

#define NeedFunctionPrototypes 1

#ifdef sgi
#include "vmpegdecomp.h"
#include "idct.h"
#include "motion.h"
#include "dctdef.h"

#include "machdep.h"

#define DebugP(args)	/* nothing */

#define SaveColumnCoeff(c0, c1, c2, c3, c4, c5, c6, c7, index)	\
    Pmb->dctRecon[index+0*8] = c0;				\
    Pmb->dctRecon[index+1*8] = c1;				\
    Pmb->dctRecon[index+2*8] = c2;				\
    Pmb->dctRecon[index+3*8] = c3;				\
    Pmb->dctRecon[index+4*8] = c4;				\
    Pmb->dctRecon[index+5*8] = c5;				\
    Pmb->dctRecon[index+6*8] = c6;				\
    Pmb->dctRecon[index+7*8] = c7


GlobalRegister(MacroBlockInfo *Pmb, "%g7");

static void
IDctOneRow(int index, VoidFuncPtr motionAndClamp, int columns)
{
    long *ptr = &Pmb->dctRecon[8*index];
    long c0, c1, c2, c3, c4, c5, c6, c7;

    switch (columns) {
    case 0x1:
	c0 = ptr[ 0 ];
	{
	    _IDctBody(c0, 0,0,0,0,0,0,0);
	    Pass9VarFunc((*motionAndClamp),
			 p0 + p1, p2 + p3, p4 + p5, p6 + p7,
			 p6 - p7, p4 - p5, p2 - p3, p0 - p1,
			 index);
	}
	break;

    case 0x2:
	c1 = ptr[ 1 ];
	{
	    _IDctBody(0,c1,0,0,0,0,0,0);
	    Pass9VarFunc((*motionAndClamp),
			 p0 + p1, p2 + p3, p4 + p5, p6 + p7,
			 p6 - p7, p4 - p5, p2 - p3, p0 - p1,
			 index);
	}
	break;

    case 0x3:
	c0 = ptr[ 0 ];
	c1 = ptr[ 1 ];
	{
	    _IDctBody(c0,c1,0,0,0,0,0,0);
	    Pass9VarFunc((*motionAndClamp),
			 p0 + p1, p2 + p3, p4 + p5, p6 + p7,
			 p6 - p7, p4 - p5, p2 - p3, p0 - p1,
			 index);
	}
	break;

    case 0x4: case 0x5: case 0x6: case 0x7:
	c2 = ptr[ 2 ];
	c3 = 0;
	goto fourCoeff;

    case 0x8: case 0x9: case 0xa: case 0xb:
	c2 = 0;
	c3 = ptr[ 3 ];
	goto fourCoeff;

    case 0xc: case 0xd: case 0xe: case 0xf:
	c2 = ptr[ 2 ];
	c3 = ptr[ 3 ];

    fourCoeff:
	c0 = (columns & (1<<0)) ? ptr[ 0 ] : 0;
	c1 = (columns & (1<<1)) ? ptr[ 1 ] : 0;
	{
	    _IDctBody(c0,c1,c2,c3,0,0,0,0);
	    Pass9VarFunc((*motionAndClamp),
			 p0 + p1, p2 + p3, p4 + p5, p6 + p7,
			 p6 - p7, p4 - p5, p2 - p3, p0 - p1,
			 index);
	}
	break;

    default:
	c0 = (columns & (1<<0)) ? ptr[ 0 ] : 0;
	c1 = (columns & (1<<1)) ? ptr[ 1 ] : 0;
	c2 = (columns & (1<<2)) ? ptr[ 2 ] : 0;
	c3 = (columns & (1<<3)) ? ptr[ 3 ] : 0;
	c4 = (columns & (1<<4)) ? ptr[ 4 ] : 0;
	c5 = (columns & (1<<5)) ? ptr[ 5 ] : 0;
	c6 = (columns & (1<<6)) ? ptr[ 6 ] : 0;
	c7 = (columns & (1<<7)) ? ptr[ 7 ] : 0;
	{
	    _IDctBody(c0,c1,c2,c3,c4,c5,c6,c7);
	    Pass9VarFunc((*motionAndClamp),
			 p0 + p1, p2 + p3, p4 + p5, p6 + p7,
			 p6 - p7, p4 - p5, p2 - p3, p0 - p1,
			 index);
	}
	break;
    }
}

static void IDctOneCol(int index)
{
    long *ptr = &Pmb->dctCoeff[index];
    long c0, c1, c2, c3, c4, c5, c6, c7;

    c0 = ptr[0*8];
    c1 = ptr[1*8];
    c2 = ptr[2*8];
    c3 = ptr[3*8];
    c4 = ptr[4*8];
    c5 = ptr[5*8];
    c6 = ptr[6*8];
    c7 = ptr[7*8];

    if (c1+c2+c3+c4+c5+c6+c7 == 0) {
	_IDctBody(c0, 0,0,0,0,0,0,0);
	SaveColumnCoeff(p0 + p1, p2 + p3, p4 + p5, p6 + p7,
		        p6 - p7, p4 - p5, p2 - p3, p0 - p1, index);
    } else if (c0+c2+c3+c4+c5+c6+c7 == 0) {
	_IDctBody(0,c1,0,0,0,0,0,0);
	SaveColumnCoeff(p0 + p1, p2 + p3, p4 + p5, p6 + p7,
		        p6 - p7, p4 - p5, p2 - p3, p0 - p1, index);
    } else if (c0+c1+c3+c4+c5+c6+c7 == 0) {
	_IDctBody(0,0,c2,0,0,0,0,0);
	SaveColumnCoeff(p0 + p1, p2 + p3, p4 + p5, p6 + p7,
		        p6 - p7, p4 - p5, p2 - p3, p0 - p1, index);
    } else if (c2+c3+c4+c5+c6+c7 == 0) {
	_IDctBody(c0, c1, 0,0,0,0,0,0);
	SaveColumnCoeff(p0 + p1, p2 + p3, p4 + p5, p6 + p7,
		        p6 - p7, p4 - p5, p2 - p3, p0 - p1, index);
    } else if (c3+c4+c5+c6+c7 == 0) {
	_IDctBody(c0, c1, c2, 0,0,0,0,0);
	SaveColumnCoeff(p0 + p1, p2 + p3, p4 + p5, p6 + p7,
		        p6 - p7, p4 - p5, p2 - p3, p0 - p1, index);
    } else {
	_IDctBody(c0, c1, c2, c3, c4, c5, c6, c7);
	SaveColumnCoeff(p0 + p1, p2 + p3, p4 + p5, p6 + p7,
		        p6 - p7, p4 - p5, p2 - p3, p0 - p1, index);
    }
}

void IDct(MacroBlockInfo *pMb, UChar *pPast, UChar *pTo, UChar *pFuture,
	  int halfPixel)
{
    long dc;
    UChar motionAndClampIndex;
    ULong cells1, cells2;
    ULong columns;
    VoidFuncPtr motionAndClamp;

    Pmb = pMb;
    cells1 = Pmb->cellsInBlock1;
    cells2 = Pmb->cellsInBlock2;
    motionAndClampIndex = MotionAndClampToIndex(halfPixel,pFuture,pPast);

    DebugTask(N_CoeffValues, PrintMb(1<<Pmb->blockIndex, cells1, cells2));

    if (pPast && pFuture) {
	Pmb->pPast = pPast;
	Pmb->pFuture = pFuture;
    } else if (pPast)
	Pmb->pFuture = pPast;	/* this is the "pTime" value */
    else if (pFuture)
	Pmb->pFuture = pFuture;	/* this is the "pTime" value */
    Pmb->pTo = pTo;

    /*
     * Very special case.  Catch the 8x8 matrix with only the
     * dc constant.
     */
    if (cells1 == 0 && cells2 == 1) {
	/*
	 * this repeats any inaccuracy in the calculations normally
	 * done in the idct routines.  Otherwise, a more "correct"
	 * calculation done here sticks out like a sore thumb on the screen
	 */
	dc = *Pmb->dctCoeff;
	HalfSqrt2_2_Times(dc, dc, );
	HalfSqrt2_2_Times(dc, dc, );
	/*
	 * Finally, clamp it and do motion compensation.
	 */
	motionAndClamp = MotionAndClamp0DcTable[ motionAndClampIndex ];
	(*motionAndClamp)(dc);
	return;
    }

    /*
     * do the regular IDCT
     */
    motionAndClamp = MotionAndClampTable[ motionAndClampIndex ];

    /*
     * Find out the occupancy of each column...
     */
    columns = cells1 | cells2;
    columns |= columns>>16;
    columns |= columns>>8;
    columns &= 0xff;

    if (columns & 0x01) IDctOneCol(0);
    if (columns & 0x02) IDctOneCol(1);
    if (columns & 0x04) IDctOneCol(2);
    if (columns & 0x08) IDctOneCol(3);
    if (columns & 0x10) IDctOneCol(4);
    if (columns & 0x20) IDctOneCol(5);
    if (columns & 0x40) IDctOneCol(6);
    if (columns & 0x80) IDctOneCol(7);
	
    IDctOneRow(0, motionAndClamp, columns);
    IDctOneRow(1, motionAndClamp, columns);
    IDctOneRow(2, motionAndClamp, columns);
    IDctOneRow(3, motionAndClamp, columns);
    IDctOneRow(4, motionAndClamp, columns);
    IDctOneRow(5, motionAndClamp, columns);
    IDctOneRow(6, motionAndClamp, columns);
    IDctOneRow(7, motionAndClamp, columns);
}
#endif /* sgi */
