/* $Header: /usr/local/src/nvrToMIT/RCS/reconstruct.h,v 4.3 1993/11/17 01:28:33 toddb Exp $ */

#define Sign(value) /* as per protocol spec */				\
    ((value) ? (((value) > 0) ? 1 : -1) : 0)

#ifdef FAST_INT_MULT

#define ReconstructIntraCoeff(index, reconMatrix, qMatrix, level, negative) \
    {									\
	int _recon = (level * qMatrix[ index ]) >> 3;			\
	_recon -= ((~_recon) & 1);/* no even coefficients; per protocol */\
	_recon &= 0xfff;	/* clamp to -2047 to 2047 */		\
	if (negative)							\
	    _recon = - _recon;						\
	reconMatrix[ index ] = _recon << FIXED_PT_BITS;			\
    }

/*
 * This is optimized from the protocol, in that the Sign() function
 * need not be evaluated for 0 because the reconstruction level is
 * never zero
 * XXX this doesn't allow -2048 
 */
#define ReconstructNonIntraCoeff(index, reconMatrix, qMatrix, level, negative) \
    {									\
	int _recon = (((level<<1) + 1) * qMatrix[ index ]) >> 4;	\
	_recon -= ((~_recon) & 1);/* no even coefficients; per protocol */\
	_recon &= 0xfff;	/* clamp to -2047 to 2047 */		\
	if (negative)							\
	    _recon = - _recon;						\
	reconMatrix[ index ] = _recon << FIXED_PT_BITS;			\
    }

#else

/*
 * See discussion in reconstruct.c
 */
#define N_DCT_ZZ_BITS		5
#define N_INTRA_QUANT_BITS	5

#endif
