#include <stdio.h>

#define B_STARTCODE             0x00000100/* 24-bit byte-align start code */
#define B_PICTURE_START_CODE    (B_STARTCODE | 0x00)   /* picture start code */
#define B_SLICE_START_MIN       (B_STARTCODE | 0x01)   /* Minimum slice start */
#define B_SLICE_START_MAX       (B_STARTCODE | 0xAF)   /* Maximum slice start */
#define B_USER_DATA_START_CODE  (B_STARTCODE | 0xB2)   /* user data start */
#define B_SEQUENCE_HEADER_CODE  (B_STARTCODE | 0xB3)   /* sequence header */
#define B_SEQUENCE_ERROR_CODE   (B_STARTCODE | 0xB4)   /* sequence error */
#define B_EXTENSION_START_CODE  (B_STARTCODE | 0xB5)   /* extension start */
#define B_SEQUENCE_END_CODE     (B_STARTCODE | 0xB7)   /* sequence end code */
#define B_GROUP_START_CODE      (B_STARTCODE | 0xB8)   /* group start code */

main()
{
    long code;
    int byte;
    int offset;

    code = 0;
    for (offset = -3;; offset++) {
	byte = getc(stdin);
	if (byte == EOF)
	    break;
	code = ((code & 0xffff) << 8) | byte;

	switch (code) {
	case B_PICTURE_START_CODE:
	    printf("%d: %3x picture start\n", offset, code);
	    break;
	case B_USER_DATA_START_CODE:
	    printf("%d: %3x user data\n", offset, code);
	    break;
	case B_SEQUENCE_HEADER_CODE:
	    printf("%d: %3x sequence header\n", offset, code);
	    break;
	case B_SEQUENCE_ERROR_CODE:
	    printf("%d: %3x sequence error\n", offset, code);
	    break;
	case B_EXTENSION_START_CODE:
	    printf("%d: %3x extension start\n", offset, code);
	    break;
	case B_SEQUENCE_END_CODE:
	    printf("%d: %3x sequence end\n", offset, code);
	    break;
	case B_GROUP_START_CODE:
	    printf("%d: %3x group start\n", offset, code);
	    break;

	default:
	    if ((code & (~0xff)) != 0x100)
		break;
	    if (code <= B_SLICE_START_MAX && code >= B_SLICE_START_MIN) {
		/*
		 * printf("%d: %3x slice start %d\n",
		 *	offset, code, code & 0xff);
		 */
		;
	    } else
		printf("%d: %3x ?\n", offset, code);
	    break;
	}
    }
}
