/*
 * Copyright (c) 1992,1993,1994 North Valley Research, Inc.
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	<file name> - <one-line description of file contents>
 *
 * DESCRIPTION
 *	<overall description of what the c code does>
 *
 * $Header: /usr/local/src/nvrToMIT/RCS/sparc-idct.c,v 4.9 1994/05/09 05:56:46 toddb Exp $
 */

#define NeedFunctionPrototypes 1

#ifdef sun
#include "vmpegdecomp.h"
#include "idct.h"
#include "motion.h"
#include "dctdef.h"

#include "machdep.h"

#define DebugP(args)	/* nothing */

#if 0
#define PutBackCoeff(c0, c1, c2, c3, c4, c5, c6, c7, index)	\
    Pmb->dctCoeff[index+0*8] = c0;				\
    Pmb->dctCoeff[index+1*8] = c1;				\
    Pmb->dctCoeff[index+2*8] = c2;				\
    Pmb->dctCoeff[index+3*8] = c3;				\
    Pmb->dctCoeff[index+4*8] = c4;				\
    Pmb->dctCoeff[index+5*8] = c5;				\
    Pmb->dctCoeff[index+6*8] = c6;				\
    Pmb->dctCoeff[index+7*8] = c7
#else
#define PutBackCoeff(c0, c1, c2, c3, c4, c5, c6, c7, index) /* nothing */
#endif


GlobalRegister(MacroBlockInfo *Pmb, "%g7");
GlobalRegister(long C01, "%g6");
GlobalRegister(long C11, "%g5");

static EightValues IDctOneRow(long c0, long c1, int index, int columns)
{
    long *ptr = &Pmb->dctRecon[8*index];
    long c2, c3, c4, c5, c6, c7;
    _IDctDeclarations;

    switch (columns) {
    case 0x1:
	DebugP(("row %d in: %d %d %d %d %d %d %d %d\n",
	    index, c0, 0,0,0,0,0,0,0));
	_IDctCode(c0, 0,0,0,0,0,0,0);
	break;

    case 0x2:
	DebugP(("row %d in: %d %d %d %d %d %d %d %d\n",
	    index, 0,c1,0,0,0,0,0,0));
	_IDctCode(0,c1,0,0,0,0,0,0);
	break;

    case 0x3:
	DebugP(("row %d in: %d %d %d %d %d %d %d %d\n",
	    index, c0,c1,0,0,0,0,0,0));
	_IDctCode(c0,c1,0,0,0,0,0,0);
	break;

    case 0x4: case 0x5: case 0x6: case 0x7:
	c2 = ptr[ 2 ];
	c3 = 0;
	goto fourCoeff;

    case 0x8: case 0x9: case 0xa: case 0xb:
	c2 = 0;
	c3 = ptr[ 3 ];
	goto fourCoeff;

    case 0xc: case 0xd: case 0xe: case 0xf:
	c2 = ptr[ 2 ];
	c3 = ptr[ 3 ];

    fourCoeff:
	DebugP(("row %d in: %d %d %d %d %d %d %d %d\n",
	    index, c0,c1,c2,c3,0,0,0,0));
	_IDctCode(c0,c1,c2,c3,0,0,0,0);
	break;

    default:
	c2 = (columns & (1<<2)) ? ptr[ 2 ] : 0;
	c3 = (columns & (1<<3)) ? ptr[ 3 ] : 0;
	c4 = (columns & (1<<4)) ? ptr[ 4 ] : 0;
	c5 = (columns & (1<<5)) ? ptr[ 5 ] : 0;
	c6 = (columns & (1<<6)) ? ptr[ 6 ] : 0;
	c7 = (columns & (1<<7)) ? ptr[ 7 ] : 0;
	DebugP(("row %d in: %d %d %d %d %d %d %d %d\n",
	    index, c0,c1,c2,c3,c4,c5,c6,c7));
	_IDctCode(c0,c1,c2,c3,c4,c5,c6,c7);
	break;
    }
    DebugTask(N_YCValues,
	Msg("row %d:%4d%4d%4d%4d%4d%4d%4d%4d\n", index,
	    RoundToInteger(DctX0), RoundToInteger(DctX1),
	    RoundToInteger(DctX2), RoundToInteger(DctX3),
	    RoundToInteger(DctX4), RoundToInteger(DctX5),
	    RoundToInteger(DctX6), RoundToInteger(DctX7))
    )

    Return8(DctX0,DctX1,DctX2,DctX3,DctX4,DctX5,DctX6,DctX7);
}

static EightValues IDctOneCol(int index)
{
    long *ptr = &Pmb->dctCoeff[index];
    long c0, c1, c2, c3, c4, c5, c6, c7;
    _IDctDeclarations;

    c0 = ptr[0*8];
    c1 = ptr[1*8];
    c2 = ptr[2*8];
    c3 = ptr[3*8];
    c4 = ptr[4*8];
    c5 = ptr[5*8];
    c6 = ptr[6*8];
    c7 = ptr[7*8];

    if (c1+c2+c3+c4+c5+c6+c7 == 0) {
	_IDctCode(c0, 0,0,0,0,0,0,0);
    } else if (c0+c2+c3+c4+c5+c6+c7 == 0) {
	_IDctCode(0,c1,0,0,0,0,0,0);
    } else if (c0+c1+c3+c4+c5+c6+c7 == 0) {
	_IDctCode(0,0,c2,0,0,0,0,0);
    } else if (c2+c3+c4+c5+c6+c7 == 0) {
	_IDctCode(c0, c1, 0,0,0,0,0,0);
    } else if (c3+c4+c5+c6+c7 == 0) {
	_IDctCode(c0, c1, c2, 0,0,0,0,0);
    } else {
	_IDctCode(c0, c1, c2, c3, c4, c5, c6, c7);
    }
    PutBackCoeff(DctX0,DctX1,DctX2,DctX3,DctX4,DctX5,DctX6,DctX7, index);
    Return8(DctX0,DctX1,DctX2,DctX3,DctX4,DctX5,DctX6,DctX7);
}

void IDct(MacroBlockInfo *pMb,
	  UChar *pPast,
	  UChar *pTo,
	  UChar *pFuture,
	  int halfPixel)
{
    long dc;
    UChar motionAndClampIndex;
    ULong cells1, cells2;
    ULong column, columns;
    VoidFuncPtr motionAndClamp;
    long *ptr;
    long c0, c1, c2, c3, c4, c5, c6, c7;
    long c00;
    long c10;
    long c20, c21;
    long c30, c31;
    long c40, c41;
    long c50, c51;
    long c60, c61;
    long c70, c71;

    Pmb = pMb;
    cells1 = Pmb->cellsInBlock1;
    cells2 = Pmb->cellsInBlock2;
    motionAndClampIndex = MotionAndClampToIndex(halfPixel,pFuture,pPast);

    DebugTask(N_CoeffValues, PrintMb(1<<Pmb->blockIndex, cells1, cells2));

    if (pPast && pFuture) {
	Pmb->pPast = pPast;
	Pmb->pFuture = pFuture;
    } else if (pPast)
	Pmb->pFuture = pPast;	/* this is the "pTime" value */
    else if (pFuture)
	Pmb->pFuture = pFuture;	/* this is the "pTime" value */
    Pmb->pTo = pTo;

    /*
     * Very special case.  Catch the 8x8 matrix with only the
     * dc constant.
     */
    if (cells1 == 0 && cells2 == 1) {
	/*
	 * this repeats any inaccuracy in the calculations normally
	 * done in the idct routines.  Otherwise, a more "correct"
	 * calculation done here sticks out like a sore thumb on the screen
	 */
	dc = *Pmb->dctCoeff;
	HalfSqrt2_2_Times(dc, dc, );
	HalfSqrt2_2_Times(dc, dc, );
	/*
	 * Finally, clamp it and do motion compensation.
	 */
	motionAndClamp = MotionAndClamp0DcTable[ motionAndClampIndex ];
	(*motionAndClamp)(dc);
	return;
    }

    /*
     * do the regular IDCT
     */
    motionAndClamp = MotionAndClampTable[ motionAndClampIndex ];

    /*
     * Find out the occupancy of each column...
     */
    columns = cells1 | cells2;
    columns |= columns>>16;
    columns |= columns>>8;
    columns &= 0xff;

    ptr = &Pmb->dctRecon[7];
    for (column = 7; column > 1; column--) {
	if (columns & (1<<column)) {
	    DebugP(("col %d in: %d %d %d %d %d %d %d %d\n",
		column,
		Pmb->dctCoeff[0*8+column],
		Pmb->dctCoeff[1*8+column],
		Pmb->dctCoeff[2*8+column],
		Pmb->dctCoeff[3*8+column],
		Pmb->dctCoeff[4*8+column],
		Pmb->dctCoeff[5*8+column],
		Pmb->dctCoeff[6*8+column],
		Pmb->dctCoeff[7*8+column]));
	    Accept8(c0, c1, c2, c3, c4, c5, c6, c7,
		IDctOneCol(column));
	    ptr[ 0*8 ] = c0;
	    ptr[ 1*8 ] = c1;
	    ptr[ 2*8 ] = c2;
	    ptr[ 3*8 ] = c3;
	    ptr[ 4*8 ] = c4;
	    ptr[ 5*8 ] = c5;
	    ptr[ 6*8 ] = c6;
	    ptr[ 7*8 ] = c7;
	    DebugP(("col %d out: %d %d %d %d %d %d %d %d\n",
		column, c0, c1, c2, c3, c4, c5, c6, c7));
	}
	ptr--;
    }
    if (columns & (1<<1)) {
	DebugP(("col 1 in: %d %d %d %d %d %d %d %d\n",
	    Pmb->dctCoeff[0*8+1],
	    Pmb->dctCoeff[1*8+1],
	    Pmb->dctCoeff[2*8+1],
	    Pmb->dctCoeff[3*8+1],
	    Pmb->dctCoeff[4*8+1],
	    Pmb->dctCoeff[5*8+1],
	    Pmb->dctCoeff[6*8+1],
	    Pmb->dctCoeff[7*8+1]));
	Accept8(C01, C11, c21, c31, c41, c51, c61, c71,
		IDctOneCol(1));
	DebugP(("col 1 out: %d %d %d %d %d %d %d %d\n",
	    C01,C11,c21,c31,c41,c51,c61,c71));
    } else {
	C01 = C11 = c21 = c31 = c41 = c51 = c61 = c71 = 0;
    }
	
    if (columns & (1<<0)) {
	DebugP(("col 0 in: %d %d %d %d %d %d %d %d\n",
	    Pmb->dctCoeff[0*8+0],
	    Pmb->dctCoeff[1*8+0],
	    Pmb->dctCoeff[2*8+0],
	    Pmb->dctCoeff[3*8+0],
	    Pmb->dctCoeff[4*8+0],
	    Pmb->dctCoeff[5*8+0],
	    Pmb->dctCoeff[6*8+0],
	    Pmb->dctCoeff[7*8+0]));
	Accept8(c00, c10, c20, c30, c40, c50, c60, c70,
		IDctOneCol(0));
	DebugP(("col 0 out: %d %d %d %d %d %d %d %d\n",
	    c00,c10,c20,c30,c40,c50,c60,c70));
    } else {
	c00 = c10 = c20 = c30 = c40 = c50 = c60 = c70 = 0;
    }

    Accept8(c0, c1, c2, c3, c4, c5, c6, c7,
	IDctOneRow(c00, C01, 0, columns));
    DebugP(("row 0 out: %d %d %d %d %d %d %d %d\n",
	c0, c1, c2, c3, c4, c5, c6, c7));
    Pass9VarFunc((*motionAndClamp), c0, c1, c2, c3, c4, c5, c6, c7, 0);

    Accept8(c0, c1, c2, c3, c4, c5, c6, c7,
	IDctOneRow(c10, C11, 1, columns));
    DebugP(("row 1 out: %d %d %d %d %d %d %d %d\n",
	c0, c1, c2, c3, c4, c5, c6, c7));
    Pass9VarFunc((*motionAndClamp), c0, c1, c2, c3, c4, c5, c6, c7, 1);

    Accept8(c0, c1, c2, c3, c4, c5, c6, c7,
	IDctOneRow(c20, c21, 2, columns));
    DebugP(("row 2 out: %d %d %d %d %d %d %d %d\n",
	c0, c1, c2, c3, c4, c5, c6, c7));
    Pass9VarFunc((*motionAndClamp), c0, c1, c2, c3, c4, c5, c6, c7, 2);

    Accept8(c0, c1, c2, c3, c4, c5, c6, c7,
	IDctOneRow(c30, c31, 3, columns));
    DebugP(("row 3 out: %d %d %d %d %d %d %d %d\n",
	c0, c1, c2, c3, c4, c5, c6, c7));
    Pass9VarFunc((*motionAndClamp), c0, c1, c2, c3, c4, c5, c6, c7, 3);

    Accept8(c0, c1, c2, c3, c4, c5, c6, c7,
	IDctOneRow(c40, c41, 4, columns));
    DebugP(("row 4 out: %d %d %d %d %d %d %d %d\n",
	c0, c1, c2, c3, c4, c5, c6, c7));
    Pass9VarFunc((*motionAndClamp), c0, c1, c2, c3, c4, c5, c6, c7, 4);

    Accept8(c0, c1, c2, c3, c4, c5, c6, c7,
	IDctOneRow(c50, c51, 5, columns));
    DebugP(("row 5 out: %d %d %d %d %d %d %d %d\n",
	c0, c1, c2, c3, c4, c5, c6, c7));
    Pass9VarFunc((*motionAndClamp), c0, c1, c2, c3, c4, c5, c6, c7, 5);

    Accept8(c0, c1, c2, c3, c4, c5, c6, c7,
	IDctOneRow(c60, c61, 6, columns));
    DebugP(("row 6 out: %d %d %d %d %d %d %d %d\n",
	c0, c1, c2, c3, c4, c5, c6, c7));
    Pass9VarFunc((*motionAndClamp), c0, c1, c2, c3, c4, c5, c6, c7, 6);

    Accept8(c0, c1, c2, c3, c4, c5, c6, c7,
	IDctOneRow(c70, c71, 7, columns));
    DebugP(("row 7 out: %d %d %d %d %d %d %d %d\n",
	c0, c1, c2, c3, c4, c5, c6, c7));
    Pass9VarFunc((*motionAndClamp), c0, c1, c2, c3, c4, c5, c6, c7, 7);

    DebugTask(N_YCValues,
	Msg("final:\n");
	Msg(" %3d %3d %3d %3d %3d %3d %3d %3d\n",
	    Pmb->pTo[0], Pmb->pTo[1], Pmb->pTo[2], Pmb->pTo[3],
	    Pmb->pTo[4], Pmb->pTo[5], Pmb->pTo[6], Pmb->pTo[7]);
	Msg(" %3d %3d %3d %3d %3d %3d %3d %3d\n",
	    Pmb->pTo[MAX_X*1+0], Pmb->pTo[MAX_X*1+1],
	    Pmb->pTo[MAX_X*1+2], Pmb->pTo[MAX_X*1+3],
	    Pmb->pTo[MAX_X*1+4], Pmb->pTo[MAX_X*1+5],
	    Pmb->pTo[MAX_X*1+6], Pmb->pTo[MAX_X*1+7]);
	Msg(" %3d %3d %3d %3d %3d %3d %3d %3d\n",
	    Pmb->pTo[MAX_X*2+0], Pmb->pTo[MAX_X*2+1],
	    Pmb->pTo[MAX_X*2+2], Pmb->pTo[MAX_X*2+3],
	    Pmb->pTo[MAX_X*2+4], Pmb->pTo[MAX_X*2+5],
	    Pmb->pTo[MAX_X*2+6], Pmb->pTo[MAX_X*2+7]);
	Msg(" %3d %3d %3d %3d %3d %3d %3d %3d\n",
	    Pmb->pTo[MAX_X*3+0], Pmb->pTo[MAX_X*3+1],
	    Pmb->pTo[MAX_X*3+2], Pmb->pTo[MAX_X*3+3],
	    Pmb->pTo[MAX_X*3+4], Pmb->pTo[MAX_X*3+5],
	    Pmb->pTo[MAX_X*3+6], Pmb->pTo[MAX_X*3+7]);
	Msg(" %3d %3d %3d %3d %3d %3d %3d %3d\n",
	    Pmb->pTo[MAX_X*4+0], Pmb->pTo[MAX_X*4+1],
	    Pmb->pTo[MAX_X*4+2], Pmb->pTo[MAX_X*4+3],
	    Pmb->pTo[MAX_X*4+4], Pmb->pTo[MAX_X*4+5],
	    Pmb->pTo[MAX_X*4+6], Pmb->pTo[MAX_X*4+7]);
	Msg(" %3d %3d %3d %3d %3d %3d %3d %3d\n",
	    Pmb->pTo[MAX_X*5+0], Pmb->pTo[MAX_X*5+1],
	    Pmb->pTo[MAX_X*5+2], Pmb->pTo[MAX_X*5+3],
	    Pmb->pTo[MAX_X*5+4], Pmb->pTo[MAX_X*5+5],
	    Pmb->pTo[MAX_X*5+6], Pmb->pTo[MAX_X*5+7]);
	Msg(" %3d %3d %3d %3d %3d %3d %3d %3d\n",
	    Pmb->pTo[MAX_X*6+0], Pmb->pTo[MAX_X*6+1],
	    Pmb->pTo[MAX_X*6+2], Pmb->pTo[MAX_X*6+3],
	    Pmb->pTo[MAX_X*6+4], Pmb->pTo[MAX_X*6+5],
	    Pmb->pTo[MAX_X*6+6], Pmb->pTo[MAX_X*6+7]);
	Msg(" %3d %3d %3d %3d %3d %3d %3d %3d\n",
	    Pmb->pTo[MAX_X*7+0], Pmb->pTo[MAX_X*7+1],
	    Pmb->pTo[MAX_X*7+2], Pmb->pTo[MAX_X*7+3],
	    Pmb->pTo[MAX_X*7+4], Pmb->pTo[MAX_X*7+5],
	    Pmb->pTo[MAX_X*7+6], Pmb->pTo[MAX_X*7+7]);
    )
}
#endif /* sun */
