
static short ComputeMotion(size, code, r, pastMotion, maxMotion, minMotion)
    short size;
    short code;
    short r;
    short pastMotion;
    short maxMotion, minMotion;
{
    short motion;
    short complementR;
    short big, little;

    /*
     * compute the motion vector
     */
    if (size == 0) {        /* same as forward_f == 1 */
        complementR = 0;
        /*
         * same code as below, except takes advantage of size==0
         */
        if (little = code) {
            if (little > 0)
                big = little - (1<<5);
            else
                big = little + (1<<5);
        } else
            big = 0;
    } else {
        if (code == 0)
            complementR = 0;
        else
            complementR = (1<<size) - 1 - r;

        if (little = code << size) {
            if (little > 0) {
                little -= complementR;
                big = little - (1<<size+5);
            } else {
                little += complementR;
                big = little + (1<<size+5);
            }
        } else
            big = 0;
    }

    motion = pastMotion + little;
    if (motion < minMotion || motion > maxMotion)
        motion += big - little;

    return (motion);
}

main(int argc, char **argv)
{
    short size;
    short code;
    short r;
    short motion;
    short maxMotion, minMotion;
    short pastMotion;

    for (size = 0; size < 6; size++) {
	maxMotion = (1<<size+4) - 1;
	minMotion = -(maxMotion+1);

	printf("size %d, min/max=%d/%d:\n", size, minMotion, maxMotion);
	printf(" code  r     motion w/ past=%d, %d ... -1,0,1 ... %d, %d\n",
	    minMotion, minMotion+1, maxMotion-1, maxMotion);

	for (r = 0; r < (1<<size); r++) {
	    for (code = -16; code <= 16; code++) {
		printf("  %3d %2d -> ", code, r);
		printf("%3d, ",
		    ComputeMotion(size, code, r,
				  minMotion, maxMotion, minMotion));
		printf("%3d, ",
		    ComputeMotion(size, code, r,
				  minMotion+1, maxMotion, minMotion));
		printf(" ... %3d, ",
		    ComputeMotion(size, code, r, -1, maxMotion, minMotion));
		printf("%3d, ",
		    ComputeMotion(size, code, r, 0, maxMotion, minMotion));
		printf("%3d ... ",
		    ComputeMotion(size, code, r, 1, maxMotion, minMotion));
		printf("%3d, ",
		    ComputeMotion(size, code, r,
				  maxMotion-1, maxMotion, minMotion));
		printf("%3d\n",
		    ComputeMotion(size, code, r,
				  maxMotion, maxMotion, minMotion));
	    }
	}
    }
}
