/* $Header: /usr/local/src/nvrToMIT/RCS/videodebug.h,v 4.18 1994/12/19 19:47:37 toddb Exp $ */

/*
 * These asserts are used in different places.
 * - LanguageAssert() is used to confirm data alignment or sizes
 * - InitAssert is used assertions during startup.
 * - GeneralAssert() is used anywhere else
 */
#ifdef INIT_ASSERT
#define InitAssert(mustBeTrue)		_DoAssert(mustBeTrue)
#else
#define InitAssert(mustBeTrue)		/* nothing */
#endif

#ifdef LANGUAGE_ASSERT
#define LanguageAssert(mustBeTrue)	_DoAssert(mustBeTrue)
#else
#define LanguageAssert(mustBeTrue)	/* nothing */
#endif

#ifdef GENERAL_ASSERT
#define GeneralAssert(mustBeTrue)	_DoAssert(mustBeTrue)
#else
#define GeneralAssert(mustBeTrue)	/* nothing */
#endif

/*
 * Debug bit indices
 */
typedef enum {
    N_NoLabel = DBI_Vmpegdecomp,
    N_BackwardFCode,
    N_BitRate,
    N_GopInfo,
    N_CodedBlockPattern,
    N_Constrained,
    N_DataAndStartcode,
    N_DcChromaDiff,
    N_DcLumaDiff,
    N_DcSizeChrominance,
    N_DcSizeLuminance,
    N_DctCoeffFirst,
    N_DctCoeffNext,
    N_EndOfBlock,
    N_EndOfMacroblock,
    N_ExtensionData,
    N_ExtraPictureInfo,
    N_ExtraSliceInfo,
    N_ForwardFCode,
    N_FullPelBakVector,
    N_FullPelFwdVector,
    N_GroupStartCode,
    N_HorizBakCode,
    N_HorizFwdCode,
    N_HorizontalSize,
    N_LoadIQM,
    N_LoadNIQM,
    N_MacroblockStuffing,
    N_MacroblockEscape,
    N_MacroblockAddrInc,
    N_Marker,
    N_MbQuant,
    N_MbType,
    N_MotionHorizBakR,
    N_MotionHorizFwdR,
    N_MotionVertBakR,
    N_MotionVertFwdR,
    N_PadBits,
    N_PadByte,
    N_PadAndStartcodeBytes,
    N_PelAspectRatio,
    N_PictureCodingType,
    N_PictureRate,
    N_PictureStart,
    N_QuantizerScale,
    N_SequenceEndCode,
    N_SequenceHeaderCode,
    N_SliceStartCode,
    N_TemporalReference,
    N_Timecode,
    N_UserData,
    N_VbvBufSize,
    N_VbvDelay,
    N_VertBakCode,
    N_VertFwdCode,
    N_VerticalSize,

    N_SequenceMark,
    N_PictureMark,
    N_SliceMark,
    N_MacroBlockMark,
    N_BlockMark,
    N_CoeffMark,

    N_MotionVariables,
    N_CoeffValues,
    N_YCValues,
    N_MotionVectors,
    N_AnimateSrcMB,
    N_AnimateDstMB,
    N_QueueInfo,
    N_GeometryInfo,
    N_Protocol,
    N_CommandLine,
    N_DisplayTimecode,
    N_SkippedFrames,
    N_PerformanceSummary,
    N_AudioActivity,
    N_SeekActivity,
    N_WindowEvents
} DebugBitIndices;

/*
 * Timer bit indices
 */
#define N_TimePictures		0
#define N_TimeGOP		1
#define N_TimeDisplay		2

#ifdef DEBUG_ENABLED

extern char *BlockNames[];
extern boolean HexPixels;
extern ULong BreakAtTc;
extern ULong BreakAtPic;

CExternal boolean VmpegDebugFormat(
    char *buf, 
    int whatIsIt, 
    ULong value
);

#endif /* DEBUG_ENABLED */

extern char IPBDchars[5];

#include "nvrTimer.h"
