/*
 *      (c) Copyright 1992,1993,1994 North Valley Research, Inc.
 *              All Rights Reserved
 *
 *      Confidential -- All proprietary rights reserved.
 *      Licensed Material -- Property of North Valley Research, Inc.
 *
 *      This program is the property of North Valley Research, Inc. or others
 *      from whom North Valley Research has obtained a licensing right, and is
 *      considered by North Valley Research to be confidential.  It is protected
 *      by U.S. copyright law as an unpublished work and is
 *      furnished pursuant to a written license agreement.  It may
 *      not be used, copied or otherwise reproduced, or disclosed to
 *      others except in accordance with the terms and conditions of
 *      that agreement.
 *
 *      NAME
 *              general.h
 *
 *      DESCRIPTION
 *              <overall description of what the package does>
 *
 *      REVISION
 * 		$Header: /usr/local/src/nvrToMIT/RCS/vmpegdecomp.h,v 4.7 1994/07/11 01:25:04 toddb Exp $
 */

#ifdef FLOAT_AVAILABLE

#define FixedToFloat(real)	(real)
#ifdef TRUNCATE_REAL
#define RoundToInteger(val)	(val + .5)
#else /* TRUNCATE_REAL */
#define RoundToInteger(val)	(val)
#endif /* TRUNCATE_REAL */

#else /* FLOAT_AVAILABLE */

#define OneHalf	(1<<(FIXED_PT_BITS-1))
#ifdef TRUNCATE_REAL
#define RoundToInteger(val)	((val) >> FIXED_PT_BITS)
#else /* TRUNCATE_REAL */
#define RoundToInteger(val)	((val + OneHalf) >> FIXED_PT_BITS)
#endif /* TRUNCATE_REAL */

#define FloatToIntScale		(1<<FIXED_PT_BITS)
#define FixedToFloat(fixed)	((float)(fixed) / FloatToIntScale)

#endif /* FLOAT_AVAILABLE */

/*
 * The Unroll*() macros abbreviate many operations.
 */
#define Unroll8(op) op; op; op; op; op; op; op; op;
#define Unroll16(op) Unroll8(op); Unroll8(op)
#define Unroll64(op) Unroll8( Unroll8(op) )

extern char	*ProgramName;

/*
 * System-wide pointer types
 */
typedef struct _dpyInfo DisplayInfo, *DisplayInfoPtr;
typedef struct _sequence SequenceInfo, *SequenceInfoPtr;
typedef struct _picinfo PictureInfo, *PictureInfoPtr;

#include "nvrTypes.h"
#include "nvrDebug.h"
#include "nvrImage.h"
#include "osio.h"
#include "nvrAlloc.h"
#include "nvrString.h"

/*
 * MCS includes
 */
#include "protoparseP.h"
#include "mcs-server.h"
#include "mpegdecomp.h"

#include "videodebug.h"
#include "decoder.h"
#include "display.h"

