/*
 *	Copyright (c) 1993  North Valley Research, Inc.
 *	Confidential -- All proprietary rights reserved.
 *	Licensed Material -- Property of North Valley Research, Inc.
 *
 *	This program is the property of North Valley Research, Inc. or others
 *	from whom North Valley Research, Inc. has obtained a licensing right, and is
 *	considered by North Valley Research, Inc. to be confidential.  It is protected
 *	by U.S. copyright law as an unpublished work and is
 *	furnished pursuant to a written license agreement.  It may
 *	not be used, copied or otherwise reproduced, or disclosed to
 *	others except in accordance with the terms and conditions of
 *	that agreement.
 *
 *	NAME
 *		licxt.c
 *
 *	DESCRIPTION
 *		
 *
 *
 */
#ifdef RCS_ID
static char *rcsid=  "$Header: /usr/local/src/nvrToMIT/RCS/NvrLmXt.c,v 1.11 1994/12/17 13:03:12 russ Exp $";
#endif /* RCS_ID */


/*
 *      INTERNAL INCLUDES
 *              Include files for local use only, therefore, NOT exported
 *		to any package or program using this package.
 */
#include <X11/Intrinsic.h>
#include <elm.h>
#include <process.h>

/*
 *      EXTERNAL INCLUDES
 *              Include files that must be exported to any package or
 *              program using this package.
 */
#include <NvrLmFeatures.h>


/*
 *      EXTERNS
 *              External declarations required locally to this package
 *              that are not already declared in any of the included header
 *		files (external includes or internal includes).
 */

/*
 *      GLOBALS
 */


/*
 *      LOCAL DEFINES
 */

/*
 *      LOCAL TYPEDEFS
 */

/*
 *      LOCALS VARIABLES
 */
extern int NvrLmInitialized;
extern int _NvrLmInit(LmConfigPtr config);


/************************************************************************
 *									*
 *			PUBLIC ROUTINES					*
 *									*
 ************************************************************************/


#ifndef LM_DISABLED

int
NvrXtGetLicense(XtAppContext app_context, LmConfigPtr config)
{
    int code;

    if (!NvrLmInitialized) {
	/* init */
	if ((code = _NvrLmInit(config)) < 0) {
	    return(code);
	}

	/* start elm heartbeat */
	elm_xtheartbeat(app_context, BEAT, config->exceptionCB);
    }

    /* get a license */
    code = elm_getlicense(config->featureUsed,
	    ELM_GETLIC | (config->shared ? ELM_SHARED : 0),
	    0);
    if (code != ELM_OK) {
	elm_bye();
	NvrLmInitialized = 0;
    }

    return(code);
}


void
NvrLmXtClose()
{
    if (NvrLmInitialized) {
	elm_bye();
    }
    NvrLmInitialized = 1;
}

#endif /* LM_DISABLED */
