/*
 * Copyright (c) 1993  North Valley Research, Inc.
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research, Inc. has obtained a licensing right, and is
 * considered by North Valley Research, Inc. to be confidential.
 * It is protected by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 * 	NvrNoLm.c - functions used with or without license manager
 *
 * $Header: /usr/local/src/nvrToMIT/RCS/NvrNoLm.c,v 1.2 1994/08/30 16:49:46 toddb Exp $
 */
#define NeedFunctionPrototypes 1

#include "NvrLmFeatures.h"
#include "nvrTimer.h"
#include "osio.h"

void
NvrCopyrightMsg(long bitMask, ULong timebomb)
{
    TimeSpec now;

    if (bitMask & NvrCopyright) {
	Msg("Copyright %s North Valley Research.\n", PRODUCT_COPYRIGHT);
	Msg("All Rights Reserved.  Product release %s.\n", PRODUCT_STRING);
    }
    if (bitMask & TekCopyright) {
	Msg("Portions are Copyright 1992, 1993 Tektronix, Inc.  ");
	Msg("All Rights Reserved.\n");
    }
    if (bitMask & LmCopyright) {
	Msg("License management portions are Copyright %s Elan\n",
	    LM_COPYRIGHT);
	Msg("    Computer Group, Inc.  All Rights Reserved.\n");
    }
    if (timebomb) {
	TimeNow(&now);
	if ((ULong)now.seconds < timebomb) {
	    ProgMsg("This sofware will expire in %.1f days\n",
		(timebomb - (ULong)now.seconds)/(60*60*24.0));
	}
    }
}
