/*
 * (c) Copyright 1992 North Valley Research, Inc.
 *         All Rights Reserved
 *
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 * 	nvrCrypt.h
 *
 * DESCRIPTION
 *
 * REVISION
 *	$Header: /usr/local/src/nvrToMIT/RCS/nvrCrypt.h,v 1.1 1994/08/30 16:49:46 toddb Exp $
 */
#ifndef NVRCRYPT_H
#define NVRCRYPT_H

#include "nvrTypes.h"

typedef char CryptKey[16][8];
typedef char CryptBlock[8];
typedef char CryptSalt[8];

CExternal boolean CryptInit(long mode);
CExternal void SetCryptKey(CryptKey key, CryptSalt salt);
CExternal void Encrypt(CryptKey key, CryptBlock block);
CExternal void Decrypt(CryptKey key, CryptBlock block);
CExternal long EncryptString(CryptKey key, char *src, char *dst);
CExternal boolean DecryptString(CryptKey key, char *src, char *dst, long length);
CExternal boolean EncryptData(CryptKey key, char *src, char *dst, long length);
CExternal void DecryptData(CryptKey key, char *src, char *dst, long length);
CExternal void CryptComplete(void);

#endif /* NVRCRYPT_H */
