/*
 *	(c) Copyright 1992 North Valley Research, Inc.
 *		All Rights Reserved
 *
 *	Confidential -- All proprietary rights reserved.
 *	Licensed Material -- Property of North Valley Research, Inc.
 *
 *	This program is the property of North Valley Research, Inc. or others
 *	from whom North Valley Research has obtained a licensing right, and is
 *	considered by North Valley Research to be confidential.  It is protected
 *	by U.S. copyright law as an unpublished work and is
 *	furnished pursuant to a written license agreement.  It may
 *	not be used, copied or otherwise reproduced, or disclosed to
 *	others except in accordance with the terms and conditions of
 *	that agreement.
 *
 *	NAME
 *		MAdecoder.h - Include file the MPEG Audio Decoder
 *
 *	DESCRIPTION
 *		
 *
 *	REVISION
 *		$Header: /usr/local/src/nvrToMIT/RCS/MAdecoder.h,v 1.1 1994/04/17 01:39:28 toddb Exp $
 */
#ifndef _MPEG_AUDIO_DECODER_H_
#define _MPEG_AUDIO_DECODER_H_

#include "nvrTypes.h"
#include "bitstream.h"


/*
 *	DEFINES
 */
#define   VAL_SYNCWORD		0xfffL
#define   BITS_SYNCWORD		12


/*
 *	EXTERNS
 */


/*
 *	TYPEDEFS
 */
typedef struct _FrameDecodeContext {
    /*
     * Audio Frame Decode Context
     */
    short layer;		/* 3 = Layer1, 2 = 2, 1 = 3, 0 = reserved */
    short sampling_frequency;	/* index into MA_SamplingFrequencyTable */
    short mode;			/* MODE_STEREO, MODE_JOINT_STEREO, */
				/*   MODE_DUAL_CHANNEL, MODE_SINGLE_CHANNEL */
    short mode_extension;	/* Layer I & II: for Joint Stereo mode */
				/*	see MODE_EXT_# and MA_Bound[]  */
				/* Layer III: encoding for intensity_stereo */
				/*   (bit 1) and ms_stereo (bit 0). 	*/
    unsigned char *nbal_table;	/* Layer II */
    char *alloc_table;		/* Layer II */
    int	sblimit;		/* Layer II */
    CacheReturnValue (*decode_proc)();
} FrameDecodeContext, *pFrameDecodeContext;


#endif /* _MPEG_AUDIO_DECODER_H_ */

