#include "osio.h"
#include "nvrAlloc.h"
#include <math.h>

#ifdef sun
double atof(char *);
#endif

char *ProgramName;

main(int argc, char **argv)
{
    float frequency = 440;	/* an 'A' */
    ULong rate = 32000;
    ULong volume = 0x3fff;
    long i;
    float length = 1;		/* 1 second */
    short *samples;
    ULong nSamples;
    float increment, angle;

    ProgramName = argv[0];
    for (argc--, argv++; argc; argc--, argv++) {
	if (strncmp(*argv, "freq=", 5) == 0)
	    frequency = atof(*argv+5);
	else if (strncmp(*argv, "volume=", 7) == 0)
	    volume = atof(*argv+7) * 32000;
	else if (strncmp(*argv, "length=", 7) == 0)
	    length = atof(*argv+7);
	else if (strncmp(*argv, "rate=", 5) == 0)
	    rate = atoi(*argv+5);
	else
	    Fatal("unknown arg=%s\n", *argv);
    }

    increment = (2 * M_PI) / (32000 / frequency);
    nSamples = rate * length;
    samples = (short *)SecureAlloc(nSamples * sizeof(short));

    angle = 0.0;
    Msg("%.2f seconds of %.1f cycle sine wave, %dhz, volume %.1f%% (%d)\n",
	length, frequency, rate, volume / (0x7fff/100.0), volume);
    for (i = 0; i < nSamples; i++) {
	samples[ i ] = volume * sin(angle);
	angle += increment;
    }

    (void)WriteData(1, samples, nSamples * sizeof(short));
}
