/*
 * (c) Copyright 1992, 1993 North Valley Research, Inc.
 * 	All Rights Reserved
 *
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	mu-law.h - conversion macros to and from mu-law
 *
 * DESCRIPTION
 *	that's about it
 *
 * $Header: /usr/local/src/nvrToMIT/RCS/mu-law.h,v 1.2 1994/07/08 03:20:52 toddb Exp $
 */
#ifndef _MU_LAW_H_
#define _MU_LAW_H_

/*
 * mu-law logarithmic to 8,16,32-bit linear
 */
#define MulawToPcmLong(X)	(((long)_MulawToLinear[(UChar) (X)]) << 16)
#define MulawToPcmShort(X)	(_MulawToLinear[(UChar) (X)])
#define MulawToPcmByte(X)	((char)(_MulawToLinear[(UChar) (X)] >> 8))

/*
 * PCM linear to mu-law conversion macros
 */
#define PcmByteToMulaw(X)	(_LinearToMulaw[(((short)(X)) << 5) + 0xf])
#define PcmShortToMulaw(X)	(_LinearToMulaw[((short)(X)) >> 3])
#define PcmLongToMulaw(X)	(_LinearToMulaw[((long)(X)) >> 19])

/*
 * PCM linear to mu-law conversion tables
 */
extern short	_MulawToLinear[];	/* 8-bit mu-law to 16-bit PCM */
extern UChar	*_LinearToMulaw;	/* 13-bit PCM to 8-bit mu-law */

#endif /* _MU_LAW_H_ */
