/*
 * Copyright (c) 1992,1993, North Valley Research, Inc.
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	noCddaio.c - fuctions when no cdda is available
 *
 * DESCRIPTION
 *
 * $Header: /usr/local/src/nvrToMIT/RCS/noCddaio.c,v 1.1 1995/08/18 18:37:45 toddb Exp $
 */
#include "nvrAudioI.h"

static InternalReason NoCddaRead = {
    "CDDA audio input not available.\n", IR_NotImplemented
};
static InternalReason NoCddaWrite = {
    "Can't write to CDDA audio.\n", IR_NotImplemented
};
 
static void
CloseCddaAudio(AudioFilePtr auFile)
{
}

static boolean
CreateCddaAudio(AudioFilePtr auFile)
{
    SetAudioReason(auFile, &NoCddaWrite);
    return(False);
}

static boolean
OpenCddaAudio(AudioFilePtr auFile, AudioQualityPtr quality)
{
    SetAudioReason(auFile, &NoCddaRead);
    return(False);
}

static long
ReadCddaSamples(AudioFilePtr auFile, UChar *buffer, ULong nSamples)
{
    SetAudioReason(auFile, &NoCddaRead);
    return(-1);
}

static long
WriteCddaSamples(AudioFilePtr auFile, UChar *buffer, ULong nSamples)
{
    SetAudioReason(auFile, &NoCddaWrite);
    return(-1);
}

static InternalReasonPtr
SeekCddaSamples(AudioFilePtr auFile, ULong nSamples)
{
    return(&NoCddaRead);
}

AudioOpFunc AudioLibCddaFuncs = {
    OpenCddaAudio,
    CreateCddaAudio,
    ReadCddaSamples,
    WriteCddaSamples,
    SeekCddaSamples,
    CloseCddaAudio
};
