/*
 * Copyright (c) 1992,1993, North Valley Research, Inc.
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	mpegio.c - functions for reading/writing mpeg audio
 *
 * DESCRIPTION
 *
 * $Header: /usr/local/src/nvrToMIT/RCS/noMpegio.c,v 1.2 1994/12/18 03:39:22 toddb Exp $
 */
#define NeedFunctionPrototypes 1

#include "nvrAudioI.h"
#include "nvrAlloc.h"
#include "nvrString.h"

static InternalReason CantDecode = {
    "Mpeg audio decoding not available.\n", IR_NotImplemented
};
static InternalReason CantSeek = {
    "Can't seek on MPEG audio yet.\n", IR_NotImplemented
};
static InternalReason CantEncode = {
    "Can't encode MPEG audio yet.\n", IR_NotImplemented
};
 
static void
CloseMpegAudio(AudioFilePtr auFile)
{
}

static boolean
CreateMpegAudio(AudioFilePtr auFile)
{
    SetAudioReason(auFile, &CantEncode);
    return(False);
}

static boolean
OpenMpegAudio(AudioFilePtr auFile, AudioQualityPtr quality)
{
    SetAudioReason(auFile, &CantDecode);
    return(False);
}

static long
ReadMpegSamples(AudioFilePtr auFile, UChar *buffer, ULong nSamples)
{
    SetAudioReason(auFile, &CantDecode);
    return(-1);
}

static long
WriteMpegSamples(AudioFilePtr auFile, UChar *buffer, ULong nSamples)
{
    SetAudioReason(auFile, &CantEncode);
    return(-1);
}

static InternalReasonPtr
SeekMpegSamples(AudioFilePtr auFile, ULong nSamples)
{
    return(&CantSeek);
}

AudioOpFunc AudioLibMpegFuncs = {
    OpenMpegAudio,
    CreateMpegAudio,
    ReadMpegSamples,
    WriteMpegSamples,
    SeekMpegSamples,
    CloseMpegAudio
};
