/*
 * Copyright (c) 1992,1993, North Valley Research, Inc.
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	nodevice.c - interface to represent no hardware
 *
 * DESCRIPTION
 *
 * $Header: /usr/local/src/nvrToMIT/RCS/nodevice.c,v 1.1 1995/12/02 12:46:37 toddb Exp $
 */
#define NeedFunctionPrototypes 1

#include 	"nvrAudioI.h"
 

InternalReason IRCantOpen =
    { "no audio device supported\n", IR_CantWrite };

/*
 * Function Prototypes
 */

static boolean
noOpenDevice(AudioFilePtr auFile)
{
    SetAudioReason(auFile, &IRCantOpen);
    return(False);
}

static void
noAudioClose(AudioFilePtr auFile)
{
}

static long
noAudioSamplesQueued(AudioFilePtr auFile)
{
    return(0);	/* don't know how to do this yet */
}

static void
noAudioFlush(AudioFilePtr auFile)
{
    /* not implemented */
}

static boolean
noAudioOpen(AudioFilePtr auFile)
{
    SetAudioReason(auFile, &IRCantOpen);
    return(False);
}

static boolean
noAudioMode(AudioFilePtr auFile, long devCommand)
{
    return(False);
}


static boolean
noAudioInit(AudioFilePtr auFile)
{
    SetAudioReason(auFile, &IRCantOpen);
    return(False);
}

static long
noAudioReadSamples(AudioFilePtr auFile, UChar *buffer, ULong nSamples)
{
    SetAudioReason(auFile, &IRCantOpen);
    return(-1);
}

static long
noAudioWriteSamples(AudioFilePtr auFile, UChar *buffer, ULong nSamples)
{
    SetAudioReason(auFile, &IRCantOpen);
    return(-1);
}

/*		External Linkage				*/

AudioDevOpFunc NoDevFuncs = {
    noAudioOpen,
    noAudioInit,
    noAudioMode,
    noAudioReadSamples,
    noAudioWriteSamples,
    noAudioSamplesQueued,
    noAudioFlush,
    noAudioClose
};
