/*
 * Copyright (c) 1992,1993, North Valley Research, Inc.
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	prlxAudio.c - The audio part for a Parallax board
 *
 * DESCRIPTION
 *	This is the guts of the audio extractor for the Parallax board.
 *	It translates the 8-bit ulaw audio into 16-bit linear audio.
 *
 * $Header: /usr/local/src/nvrToMIT/RCS/nojmovieio.c,v 1.2 1995/02/22 02:17:41 toddb Exp $
 */

#define NeedFunctionPrototypes 1

#include 	"nvrAudioI.h"
 
static InternalReason NotInstalled = {
    "jmovie files not installed.\n", IR_NotImplemented
};

static void
CloseJmovieAudio(AudioFilePtr auFile)
{
}

static boolean
CreateJmovieAudio(AudioFilePtr auFile)
{
    SetAudioReason(auFile, &NotInstalled);
    return(False);
}

static boolean
OpenJmovieAudio(AudioFilePtr auFile, AudioQualityPtr quality)
{
    SetAudioReason(auFile, &NotInstalled);
    return(False);
}

static long
ReadJmovieSamples(AudioFilePtr auFile, UChar *buffer, ULong nSamples)
{
    return(0);
}

static long
WriteJmovieSamples(AudioFilePtr auFile, UChar *buffer, ULong nSamples)
{
    return(-1); /* we can't */
}

static InternalReasonPtr
SeekJmovieSamples(AudioFilePtr auFile, ULong nSamples)
{
    return( &NotInstalled );
}

AudioOpFunc AudioLibJmovieFuncs = {
    OpenJmovieAudio,
    CreateJmovieAudio,
    ReadJmovieSamples,
    WriteJmovieSamples,
    SeekJmovieSamples,
    CloseJmovieAudio
};
