/* $Header: /usr/local/src/nvrToMIT/RCS/bitstreamDebug.c,v 1.3 1994/10/09 18:48:00 toddb Exp $ */
#define DEBUG_ENABLED
#define NeedFunctionPrototypes 1

#include "nvrTypes.h"
#include "nvrDebug.h"
#include "nvrString.h"
#include "bitstream.h"
#include "osio.h"
#include <stdio.h>

static void
FormatLabel(char *label, BitStream *pBuf, int nBits, int whatIsIt)
{
    BitByteOffset current = BitStreamOffset(pBuf, nBits);
    int length;
    static int longestName;
    char *name = FindDebugFlagName(whatIsIt);

    if ((length = strlen( name )) > longestName)
	longestName = length;

    sprintf(label, "%d+%d %*s: ",
	    current.bytes, current.bits, longestName, name);
}

void
PrintLabel(BitStream *pBuf, int nBits, int whatIsIt)
{
    char buf[ 1024 ];

    FormatLabel(buf, pBuf, nBits, whatIsIt);
    Msg("%s", buf);
}

void
PrintBits(BitStream *pBuf, ULong value, ULong nBits, int whatIsIt)
{
    char buf[ 1024 ], *p = buf;
    boolean formatted;

    FormatLabel(p, pBuf, nBits, whatIsIt);
    if (pBuf->dbgFormat) {
	formatted = (*pBuf->dbgFormat)(buf, whatIsIt, value);
    } else {
	formatted = False;
    }
    if (! formatted) {
	p += strlen(p);
	sprintf(p, "%s", BitString(value, nBits));
	p += strlen(p);
	if (nBits == 1)
	    sprintf(p, "\n");
	else
	    sprintf(p, ", 0x%x, %d\n", value, value);
    }
    Msg("%s", buf);
}
