/*
 *	(c) Copyright 1992 North Valley Research, Inc.
 *		All Rights Reserved
 *
 *	Confidential -- All proprietary rights reserved.
 *	Licensed Material -- Property of North Valley Research, Inc.
 *
 *	This program is the property of North Valley Research, Inc. or others
 *	from whom North Valley Research has obtained a licensing right, and is
 *	considered by North Valley Research to be confidential.  It is protected
 *	by U.S. copyright law as an unpublished work and is
 *	furnished pursuant to a written license agreement.  It may
 *	not be used, copied or otherwise reproduced, or disclosed to
 *	others except in accordance with the terms and conditions of
 *	that agreement.
 *
 *	NAME
 *		c++system.H - c++ c library declaration
 *
 *	DESCRIPTION
 *		silence the c++ compiler about c libraries
 *
 *	REVISION
 *		$Header: /usr/local/src/nvrToMIT/RCS/c++system.H,v 1.19 1994/12/17 13:02:44 russ Exp $
 */
#ifndef _CPLUSPLUSSYSTEM_H_
#define _CPLUSPLUSSYSTEM_H_

#if defined(sgi)
extern "C" {
    int    close    (int);
    unsigned int    usleep   (unsigned);
    int    vfork    ();
    int    atoi     (const char *);
    void   exit     (int);
    int    sprintf  (char *, const char *, ...);
    int    sscanf   (const char *, const char *, ...);
    int    system   (const char *);
    int    printf   (const char* ...);
    int	   ioctl    (int, int, ...);
    int    execvp   (const char *, char *const *);
    int	   read     (int, void *, unsigned);
    int    unlink   (const char *);
    int    write    (int, const void *, unsigned);
    void   free     (void *);
    long   fork     (void);
    char   *rindex  (char *,int);
}
#endif /* sgi */

#if defined(sun)

#ifdef Solaris1
extern "C" {
    int    close    (int);
    unsigned int    usleep   (unsigned);
    int    vfork    ();
    int    atoi     (const char *);
    void   exit     (int);
    int    printf   (const char* ...);
    char  *sprintf  (char *, const char *, ...);
    int    sscanf   (char*, const char* ...);
    void   system   (char*);
    int    wait     (int*);
    int    wait3    ();
    char * realloc  (char *, int);
    int    ioctl    ();
    int    execvp   (const char *, const char**);    
    int    read     (int, char *, int);
    int    unlink   (char*);
    int    write    (int, char *, int);
    int    free     (char *);
    char * malloc   (int);
    int    fork     (void);
    int    sleep    (unsigned);
}
#endif	/* Solaris1 */

#ifdef Solaris2
# include <stdio.h>
# include <unistd.h>
# include <stdlib.h>
#endif	/* Solaris2 */

#endif /* sun */

#ifdef _HPUX_SOURCE
extern "C" {
    int    close    (int);
    unsigned int    usleep   (unsigned);
    int    vfork    ();
    int    atoi     (const char *);
    void   exit     (int);
    int    printf   (const char* ...);
    int    sprintf  (char *, const char *,...);
    void   system   (char*);
    char * realloc  (char *, int);
    int    ioctl    ();
    int    execvp   (const char *, const char**);
    int    read     (int, char *, int);
    int    unlink   (char*);
    int    write    (int, char *, int);
    int    free     (char *);
    char * malloc   (int);
    int    fork     (void);
    int    sleep    (unsigned);
}
#endif /* _HPUX_SOURCE */

#ifdef VXWORKS
#endif /* VXWORKS */

#endif /* _CPLUSPLUSSYSTEM_H_ */
