/*
 *	(c) Copyright 1992 North Valley Research, Inc.
 *		All Rights Reserved
 *
 *	Confidential -- All proprietary rights reserved.
 *	Licensed Material -- Property of North Valley Research, Inc.
 *
 *	This program is the property of North Valley Research, Inc. or others
 *	from whom North Valley Research has obtained a licensing right, and is
 *	considered by North Valley Research to be confidential.  It is protected
 *	by U.S. copyright law as an unpublished work and is
 *	furnished pursuant to a written license agreement.  It may
 *	not be used, copied or otherwise reproduced, or disclosed to
 *	others except in accordance with the terms and conditions of
 *	that agreement.
 *
 *	NAME
 *		macExtension.h
 *
 *	DESCRIPTION
 *		structures, etc. for loadable functions
 *
 *	REVISION
 *		$Header: /usr/local/src/nvrToMIT/RCS/codeExtension.h,v 1.2 1994/02/17 16:36:05 toddb Exp $
 */
#ifndef _CODEEXTENSION_H_
#define _CODEEXTENSION_H_

#include "nvrTypes.h"

/*
 * Extension file types
 */
#define MultiChar(c1,c2,c3,c4)				\
	    ((c1 << 24) | (c2<<16) | (c3 << 8) | c4)

#define VMpegCompExtension	\
	    MultiChar('V','M','P','C')	/* video mpeg 1 comp. */
#define	AMpegCompExtension	\
	    MultiChar('A','M','P','C')	/* audio mpeg 1 comp. */
#define VMpegDecompExtension	\
	    MultiChar('V','M','P','D')	/* video mpeg 1 comp. */
#define	AMpegDecompExtension	\
	    MultiChar('A','M','P','D')	/* audio mpeg 1 comp. */
#define	ImageProcExtension	\
	    MultiChar('I','M','A','G')	/* image proc ext. */

/*
 * For macintosh: file creator types
 */
#define NvrFileCreator		MultiChar('N','V','R','D')

CExternal int LoadPlugIns(	/* returns the number of code resources loaded from plug-ins */
    PrivPointer,		/* environment (known to loaded functions) */
    ULong,			/* file type to use */
    ULong			/* file creator to use */
);

CExternal int LoadDynamicCode(	/* returns the number of code resources loaded from file */
    char *, 			/* resource file name */
    PrivPointer			/* environment (known to loaded functions) */
);

#endif /* _CODEEXTENSION_H_ */
