/*
 * (c) Copyright 1992, 1993 North Valley Research, Inc.
 * 	All Rights Reserved
 *
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	fileAccess.h - os- independent abstractions of file status queries
 *
 * DESCRIPTION
 *
 * $Header: /usr/local/src/nvrToMIT/RCS/fileAccess.h,v 1.16 1995/07/06 22:22:17 toddb Exp $
 */
#ifndef _FILEACCESS_H_
#define _FILEACCESS_H_

#include "nvrTypes.h"
#include "nvrReason.h"

/*
 * These are for Node.type below, but note that the file types
 * are what the file *should* be; i.e. the file type is gotten from
 * the 'from' directory.
 */
#define FILE_DIRECTORY	0x0001	/* true if the file is a directory */
#define FILE_BLOCK	0x0002	/* true if the file is a block special file */
#define FILE_CHAR	0x0004	/* true if the file is a char special file */
#define FILE_REGULAR	0x0008	/* true if the file is a regular file */
#define FILE_FIFO	0x0010	/* true if the file is a fifo (sysv) */
#define FILE_SYMLINK	0x0020	/* true if the file is a symbolic link */
#define FILE_SOCKET	0x0040	/* true if the file is a socket (bsd) */

CExternal char *TypeName(
    int
);

CExternal ULong FileSize(
    char *	/* file name */
);

CExternal ULong FdFileSize(
    int		/* file descriptor */
);

CExternal ULong ModTime(
    char *
);

CExternal ULong FdModTime(
    int
);

CExternal ULong FsBlockSize(
    int
);

CExternal boolean FdValid(
    int
);

CExternal long FdFileType(
    int
);

CExternal long FileType(
    char *
);

CExternal ULong FilePermission(
    char *
);

CExternal boolean FileReadable(
    char *
);

CExternal boolean FileWritable(
    char *
);

CExternal boolean FileCreatable(
    char *
);

CExternal boolean GetLinkName(
    char *,
    char *,
    int
);

CExternal InternalReasonPtr UnlinkFile(
    char *
);

CExternal boolean UnlinkPath(
    char *,
    boolean
);

CExternal char *ExtractPathPrefix(
    char *
);

CExternal char *ExtractPathSuffix(
    char *path
);

CExternal char *GetCurrentDir(
    void
);

CExternal void *OpenDir(
    char *
);

CExternal void CloseDir(
    void *
);

CExternal char *ReadDir(
    void *
);

#endif /* _FILEACCESS_H_ */
