
/*
 *	(c) Copyright 1992 North Valley Research, Inc.
 *		All Rights Reserved
 *
 *	Confidential -- All proprietary rights reserved.
 *	Licensed Material -- Property of North Valley Research, Inc.
 *
 *	This program is the property of North Valley Research, Inc. or others
 *	from whom North Valley Research has obtained a licensing right, and is
 *	considered by North Valley Research to be confidential.  It is protected
 *	by U.S. copyright law as an unpublished work and is
 *	furnished pursuant to a written license agreement.  It may
 *	not be used, copied or otherwise reproduced, or disclosed to
 *	others except in accordance with the terms and conditions of
 *	that agreement.
 *
 *	NAME
 *		ioutil.h - RS-232 control routines
 *
 *	DESCRIPTION
 *		Library of routines for opening and operating an RS-232 connection.
 *
 *	REVISION
 *		$Header: /usr/local/src/nvrToMIT/RCS/ioutil.h,v 1.2 1992/12/01 18:31:09 chrisj Exp $
 */

#ifndef _ioutil_h_
#define _ioutil_h_

/*
 *	DEFINES
 */

/* Type of communication protocol */
#define IOU_TTY    1
#define IOU_TELNET 2
#define IOU_RLOGIN 3

/* TTY Flags */
#define IOU_17BIT		1
#define IOU_ODDPARITY	2
#define IOU_EVENPARITY	4
#define IOU_BUFSIZE 512

/* Useful Globals */
#define IOU_FALSE	0
#define IOU_TRUE	1

/*
 *	TYPEDEFS
 */

typedef struct
{
	int					fd;
	char*				dev_path;  /* pointer to device path name */
	int					protocol;
	unsigned long       timeout_sec;
	unsigned long       timeout_usec;
} IOUInfo;

/*
 *	EXTERNS
 */

extern int iouOpenTty();
extern void iouClose();
extern int iouFlushInput();
extern int iouSend();
extern int iouSendBuf();
extern int iouReceive();
extern void iouSendChar();

#endif /* _ioutil_h_ */
