/*
 * (c) Copyright 1992 North Valley Research, Inc.
 *	All Rights Reserved
 *
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	longjump.h
 *
 * DESCRIPTION
 *	This tries to genericise the longjump process.
 *
 * REVISION
 *	$Header: /usr/local/src/nvrToMIT/RCS/longjump.h,v 1.10 1994/10/22 18:36:45 toddb Exp $
 */
#ifndef _LONGJUMP_H_
#define _LONGJUMP_H_

/*
 * This pulls in the longjmp definitions for a given architecture.
 * The decoder uses longjumps to unroll its stack when there is an
 * error in the bitstream, or when it is pre-loading a set of frames.
 */
#if defined(sun) || defined(sgi) || defined(_HPUX_SOURCE)
#define OkForThisOs 1
#elif defined(VXWORKS) || defined(THINK_C) || defined(__MWERKS__)
#define OkForThisOs 1
#else
#define OkForThisOs 0
#endif

#if OkForThisOs

#   include <setjmp.h>

    typedef jmp_buf StackInfo;

#   define SaveContext(p)	setjmp(p)

#endif
#undef OkForThisOs

#endif /* _LONGJUMP_H_ */
