/*
 * (c) Copyright 1992, 1993 North Valley Research, Inc.
 * 	All Rights Reserved
 *
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	<name> - <one-line description of header file>
 *
 * DESCRIPTION
 *	<overall description of what the header file does>
 *
 * $Header: /usr/local/src/nvrToMIT/RCS/mipsmachdep.h,v 1.3 1994/02/08 21:03:08 toddb Exp $
 */
#ifndef _MIPSMACHDEP_H_
#define _MIPSMACHDEP_H_

#define GlobalRegister(declare, regName)	declare
#define LocalRegister(declare, regName)		declare

#define StoreTwoLongs(address, r1, r2)                                  \
    {                                                                   \
        register ULong *ptr = (ULong *)(address);                       \
	ptr[0] = r1;							\
	ptr[1] = r2;							\
    }

#ifdef MIPS_GCC
/*
 *	DEFINES
 */

#define MCOMMENT	"# "	/* mips assembler comment */

#define InReg1	"$4"
#define InReg2	"$5"
#define InReg3	"$6"
#define InReg4	"$7"
#define InReg5	"$8"
#define InReg6	"$9"
#define InReg7	"$10"
#define InReg8	"$11"
#define InReg9	"$12"
#define InReg10	"$13"

#define OutReg1	"$4"
#define OutReg2	"$5"
#define OutReg3	"$6"
#define OutReg4	"$7"
#define OutReg5	"$8"
#define OutReg6	"$9"
#define OutReg7	"$10"
#define OutReg8	"$11"
#define OutReg9	"$12"
#define OutReg10	"$13"

#define _Pass9(f, fConstraint, a1, a2, a3, a4, a5, a6, a7, a8, a9)	\
    {									\
	Declare9OutRegisters(reg1,reg2,reg3,reg4,reg5,reg6,reg7,reg8,reg9) \
									\
	reg1 = (long)a1;						\
	reg2 = (long)a2;						\
	reg3 = (long)a3;						\
	reg4 = (long)a4;						\
	reg5 = (long)a5;						\
	reg6 = (long)a6;						\
	reg7 = (long)a7;						\
	reg8 = (long)a8;						\
	reg9 = (long)a9;						\
	asm volatile ("# start generated call" ::			\
	    "r" (reg1), "r" (reg2), "r" (reg3),				\
	    "r" (reg4), "r" (reg5), "r" (reg6),				\
	    "r" (reg7), "r" (reg8), "r" (reg9));			\
	f();								\
	asm volatile ("# end generated call" ::				\
	    "r" (reg1), "r" (reg2), "r" (reg3),				\
	    "r" (reg4), "r" (reg5), "r" (reg6),				\
	    "r" (reg7), "r" (reg8), "r" (reg9));			\
    }

#else /* MIPS_GCC */

typedef void TenValues;
typedef void NineValues;
typedef void EightValues;
typedef void SevenValues;
typedef void SixValues;
typedef void FiveValues;
typedef void FourValues;
typedef void ThreeValues;
typedef void TwoValues;

#undef Inline
#define Inline	/* as nothing */

#endif /* MIPS_GCC */

#endif /* _MIPSMACHDEP_H_ */
