
/*
 *      (c) Copyright 1992 North Valley Research, Inc.
 *              All Rights Reserved
 *
 *      Confidential -- All proprietary rights reserved.
 *      Licensed Material -- Property of North Valley Research, Inc.
 *
 *      This program is the property of North Valley Research, Inc. or others
 *      from whom North Valley Research has obtained a licensing right, and is
 *      considered by North Valley Research to be confidential.  It is protected
 *      by U.S. copyright law as an unpublished work and is
 *      furnished pursuant to a written license agreement.  It may
 *      not be used, copied or otherwise reproduced, or disclosed to
 *      others except in accordance with the terms and conditions of
 *      that agreement.
 *
 *      NAME
 *              nvrAlloc.h
 *
 *      DESCRIPTION
 *              <overall description of what the package does>
 *
 *      REVISION
 * 		$Header: /usr/local/src/nvrToMIT/RCS/nvrAlloc.h,v 1.19 1995/08/21 04:46:12 toddb Exp $
 */

#ifndef _ALLOC_H
#define _ALLOC_H

#include "nvrTypes.h"
#include "nvrReason.h"

CExternal char *SecureAllocAligned(
    int,		/* alignment */
    int			/* size */
);

CExternal char *InsecureAlloc(
    int			/* size */
);

CExternal char *AllocNamedMem(
    int size,
    char *name,
    InternalReasonPtr *pIrp
);

CExternal char *SecureAlloc(
    int			/* size */
);

CExternal char *InsecureNullRealloc(
    char *,		/* old pointer */
    unsigned		/* size */
);

CExternal char *NullRealloc(
    char *,		/* old pointer */
    unsigned		/* size */
);

CExternal char *CopyOfString(
    char *		/* string to copy */
);

CExternal int PageInMemory(
    void
);

CExternal void CheckPointerBounds(
    char * base,
    char * ptr,
    ULong length
);

#ifndef __cplusplus
# ifdef	sgi

#   if !defined(_SIZE_T) && !defined(_SIZE_T_)
#   define _SIZE_T
#    if (_MIPS_SZLONG == 32)
      typedef unsigned int    size_t;
#    endif
#    if (_MIPS_SZLONG == 64)
      typedef unsigned long   size_t;
#    endif
#   endif

  CExternal void *malloc(size_t size);
  CExternal void *realloc(void *ptr, size_t size);
  CExternal void *calloc(size_t nelem, size_t elsize);
  CExternal void free(void *);

# endif	/* sgi */

# ifdef sun

#if 0
#ifdef Solaris1
  CExternal char *malloc(unsigned);
  CExternal char *realloc(char *, unsigned);
  CExternal char *calloc(unsigned, unsigned);
  CExternal int free(char *);
#endif

#ifdef Solaris2
  CExternal void *malloc(unsigned);
  CExternal void *realloc(void *, unsigned);
  CExternal void *calloc(unsigned, unsigned);
  CExternal void free(void *);
#endif
#else
#include <stdlib.h>
#endif


# endif	/* sun */

# if defined(THINK_C) || defined(__MWERKS__)

  CExternal void *malloc(size_t);
  CExternal void *realloc(void *, size_t);
  CExternal void *calloc(size_t, size_t);
  CExternal void free(void *);
  CExternal char *memalign(ULong alignment, ULong size);

# endif	/* THINK_C || __MWERKS__ */

#endif /* __cplusplus */

#endif /* _ALLOC_H */
