/* $Header: /usr/local/src/nvrToMIT/RCS/nvrBitTest.c,v 1.4 1995/02/12 22:46:26 toddb Exp $ */

#include "nvrTypes.h"
#include "nvrBitTest.h"

/*
** Compare bit mask 1 to bit mask 2
*	if bm1 has all the bits of bm2
**	set then True else False
*/
boolean
BM_ALLSET(BitMask *bm1, BitMask *bm2)
{
    int i = sizeof(bm1->bits) / sizeof(bm1->bits[0]);
    do {
	i--;
	if( bm1->bits[i] & bm2->bits[i] != bm2->bits[i] ) {
	    return(False);
	}
    } while(i > 0);
    return(True);
}

/*
** See if any bits are set in bm
*/
boolean
AnyBitsSet(BitMask *bm)
{
    int i = sizeof(bm->bits) / sizeof(bm->bits[0]);

    do {
	i--;
	if( bm->bits[i] ) {
	    return(True);
	}
    } while(i > 0);
    return(False);
}

/*
** Compare bit mask 1 to bit mask 2
*	if bm1 has any one bits in common with bm2,
**	then return True else False
*/
boolean
AnyBitsCommon(BitMask *bm1, BitMask *bm2)
{
    int i = sizeof(bm1->bits) / sizeof(bm1->bits[0]);

    do {
	i--;
	if( bm1->bits[i] & bm2->bits[i] ) {
	    return(True);
	}
    } while(i > 0);
    return(False);
}
