/* $Header: /usr/local/src/nvrToMIT/RCS/nvrBitTest.h,v 1.7 1995/02/14 06:17:45 toddb Exp $ */
#ifndef _bitTest_h
#define _bitTest_h
#ifndef BitmaskNElems
#define BitmaskNElems	4
#endif
#define BitmaskElemBits	32
typedef struct {
    long    	bits[BitmaskNElems];
} BitMask, *BitMaskPtr;

#define BM_ISSET(bm, symbol)					        \
	(((bm)->bits[(symbol)/BitmaskElemBits] & 			\
  		(1L<<((symbol)%BitmaskElemBits))) != 0)

#define BM_SET(bm, symbol)						\
    	((bm)->bits[(symbol)/BitmaskElemBits] |=			\
		(1L<<((symbol)%BitmaskElemBits)))

#define BM_UNSET(bm, symbol)						\
    	((bm)->bits[(symbol)/BitmaskElemBits] &=			\
		~(1L<<(symbol%BitmaskElemBits)))

#define BM_SETALL(bm)							\
    { (bm)->bits[0] = (bm)->bits[1] = (bm)->bits[2] = (bm)->bits[3] = ~0; }

#define BM_ZERO(bm)							\
    { (bm)->bits[0] = (bm)->bits[1] = (bm)->bits[2] = (bm)->bits[3] = 0; }

#define BM_COPY(bm1, bm2)						\
    { *(bm1) = *(bm2); }

#define BM_OR(bm1, bm2)							\
    {									\
	(bm1)->bits[0] |= (bm2)->bits[0];				\
	(bm1)->bits[1] |= (bm2)->bits[1];				\
	(bm1)->bits[2] |= (bm2)->bits[2];				\
	(bm1)->bits[3] |= (bm2)->bits[3];				\
    }

CExternal boolean BM_ALLSET(
    BitMask *bm1,
    BitMask *bm2
);

CExternal boolean AnyBitsCommon(
    BitMask *bm1,
    BitMask *bm2
);

CExternal boolean AnyBitsSet(
    BitMask *bm
);

#endif /* _bitTest_h */
