/*
 *      (c) Copyright 1992 North Valley Research, Inc.
 *              All Rights Reserved
 *
 *      Confidential -- All proprietary rights reserved.
 *      Licensed Material -- Property of North Valley Research, Inc.
 *
 *      This program is the property of North Valley Research, Inc. or others
 *      from whom North Valley Research has obtained a licensing right, and is
 *      considered by North Valley Research to be confidential.  It is protected
 *      by U.S. copyright law as an unpublished work and is
 *      furnished pursuant to a written license agreement.  It may
 *      not be used, copied or otherwise reproduced, or disclosed to
 *      others except in accordance with the terms and conditions of
 *      that agreement.
 *
 *      NAME
 *              nvrClockI.h - internal clock interfaces
 *
 *      DESCRIPTION
 *              internal clock handling stuff
 *
 *      REVISION
 *              $Header: /usr/local/src/nvrToMIT/RCS/nvrClockI.h,v 1.3 1996/01/03 02:34:41 toddb Exp $
 */
#ifndef _NVRCLOCKI_H_
#define _NVRCLOCKI_H_

#include "nvrClock.h"

#define PubClockSize	sizeof(ClockKeep)
#define PrivClockSize	sizeof(PrivClockKeep)

#define PubClockToPrivClock(super) \
    (PrivClockKeepPtr)(UCharP(super) - (PrivClockSize - PubClockSize))

/*
 * Note that since pub->clocks[] is an array of unknown length we can't
 * do the normal priv-data-follows-pub-data layout of the private
 * structure.  Instead, its laid out exactly opposite, like this:
 *
 *   ------------------
 *   | os-specific    |
 *   ------------------
 *   | private        |
 *   ------------------
 *   | pub            |
 *   ------------------
 */
typedef struct _privClockKeep PrivClockKeep, *PrivClockKeepPtr;
struct _privClockKeep {
    ULong nativeResolution;	/* os-specific clock resolution in ticks/sec */

    ULong elapsed;		/* elapsed time since (*->init)() */
    short nClocks;		/* number of clocks in super->clocks */
    ClockKeep pub;		/* must be last */
};

#endif /* _NVRCLOCKI_H_ */
