/* $Header: /usr/local/src/nvrToMIT/RCS/nvrPlx.c,v 1.5 1994/10/02 17:25:34 toddb Exp $ */
#include "nvrPlx.h"
#include "nvrString.h"
#include "osio.h"
#include "XPlxExt.h"
#include "xextension.h"

#ifdef PARALLAX_LICENSE
ULong ConfirmParallax(Display *dpy, int screenIndex, ULong abilities)
{
    extern plx_IO *XPlxQueryConfig();
    plx_IO *plxio;

    plxio = XPlxQueryConfig(dpy,
			    RootWindow(dpy, screenIndex),
			    DefaultGC(dpy, screenIndex));

    if (plxio->inputs == NULL)
	return (abilities &= ~VDPY_PARALLAX);

    /*
     * XXX check to see if JPEG is available
     * This is not sufficient, but there doesn't appear to be any code
     * examples that can really test for the existence of the JPEG chip
     */
    if (plxio->hardware == NVRPLX_XVIDEO_24)
	abilities |= VDPY_PLX_JPEG;
    return (abilities);
}

#else /* PARALLAX_LICENSE */

ULong ConfirmParallax(Display *dpy, int screenIndex, ULong abilities)
{

    return (abilities &= ~VDPY_PARALLAX);

}

#endif /* PARALLAX_LICENSE */

boolean
ZeroMovieFile(char *path)
{
    boolean success = True;
    nvrPlxMovieHdr fileHeader;
    FileHandle fd;

    if ((fd = OpenFileForWriting(path)) < 0)
	return(False);

    /*
     * Initialize the file header.
     */
    memset((char *)&fileHeader, 0, sizeof(fileHeader));
    strcpy(fileHeader.magic, "j_movie");
    fileHeader.version = 2;
    fileHeader.indexbuf = sizeof(nvrPlxMovieHdr);

    success = WriteData(fd, (char *)&fileHeader, sizeof(fileHeader));
    CloseFile(fd);
    return (success);
}

