/* $Header: /usr/local/src/nvrToMIT/RCS/nvrPlx.h,v 1.13 1995/04/12 23:09:22 russ Exp $ */
#ifndef _NVRPLX_H
#define _NVRPLX_H

#include "nvrTypes.h"
#include "SunAudioStruct.h"

#define NVRPLXJPEG_VERSION_1		  1
#define NVRPLXJPEG_VERSION_2		  2
#define NVRPLXJPEG_VERSION_3		  3

/*
 * Bytes 200-255 are reserved as code words by the
 * compression/playback engine
 */

#define NVRPLXLOAD_CMAP			249

#define NVRPLXLOAD_UNIFLIX		239
#define NVRPLXLOAD_JPEG			236

#define NVRPLXCLEAR_FRAME	     	238
#define NVRPLXEND_FRAME			237

#define NVRPLXLOAD_AUDIO_0		229
#define NVRPLXLOAD_AUDIO_1		228
#define NVRPLXLOAD_AUDIO_2		227
#define NVRPLXLOAD_AUDIO_3		226

#define NVRPLXNEW_QFACTOR		230

#define NVRPLXFILLER			40

typedef struct {
    char magic[8];	    /* defined as "j_movie"			*/
    int version;	    /* Version number				*/
    int fps;		    /* frames per second			*/
    int frames;		    /* Number of frames in the sequence		*/
    int width;		    /* Width of each frame			*/
    int height;		    /* Height of each frame			*/
    int bandwidth;	    /* Bandwidth required for playback		*/
    int qfactor;	    /* Quanization factor used in compression	*/
    int mapsize;	    /* Number of colors used in colormap	*/
    int indexbuf;	    /* Offset in file of frame indexes		*/
    int tracks;		    /* Number of audio tracks used		*/
    int volbase;	    /* Baseline for volume control		*/
    int audioslice;	    /* Number of audio bytes per frame		*/
    Audio_hdr audio;	    /* Audio header from input file		*/
    int firstValidFrame;    /* First & last frames of the movie to
			       be played, useful... */
    int lastValidFrame;	    /* ...for trimming a few frames off the ends
			       of movies... */
	
    char filler[NVRPLXFILLER]; /* Pad out this record to 128 bytes	*/
} nvrPlxMovieHdr;

#define nvrplx_IO		plx_IO
#define	NVRPLX_UNKNOWN		PLX_UNKNOWN	/* Unknown configuration */
#define	NVRPLX_1280		PLX_1280	/* 1280 Series	*/	
#define	NVRPLX_VIPER		PLX_VIPER	/* Viper Series	*/
#define	NVRPLX_VIDEOVIEW	PLX_VIDEOVIEW	/* VideoView	*/
#define	NVRPLX_XVIDEO_8		PLX_XVIDEO_8	/* XVideo, 8 plane version */
#define	NVRPLX_XVIDEO_24	PLX_XVIDEO_24	/* XVideo, 24 plane version */

CExternal boolean ZeroMovieFile(
    char *      /* path */
);

#ifdef _XLIB_H_
CExternal ULong ConfirmParallax(
    Display *dpy,
    int screenIndex,
    ULong abilities
);
#endif	/* _XLIB_H_ */

#endif /* _NVRPLX_H */
