/*
 *	(c) Copyright 1992 North Valley Research, Inc.
 *		All Rights Reserved
 *
 *	Confidential -- All proprietary rights reserved.
 *	Licensed Material -- Property of North Valley Research, Inc.
 *
 *	This program is the property of North Valley Research, Inc. or others
 *	from whom North Valley Research has obtained a licensing right, and is
 *	considered by North Valley Research to be confidential.  It is protected
 *	by U.S. copyright law as an unpublished work and is
 *	furnished pursuant to a written license agreement.  It may
 *	not be used, copied or otherwise reproduced, or disclosed to
 *	others except in accordance with the terms and conditions of
 *	that agreement.
 *
 *	NAME
 *		nvrTypes.h - central type declaration
 *
 *	REVISION
 *		$Header: /usr/local/src/nvrToMIT/RCS/nvrTypes.h,v 1.18 1995/08/21 04:46:59 toddb Exp $
 */
#ifndef _TYPES_H_
#define _TYPES_H_
#define _NVR_TYPES_DEFINED_


/*
 *	DEFINES
 */
#if defined(__STDC__) || defined(THINK_C) || defined(__MWERKS__)
#define Concat(s1,s2) s1##s2
#define Concat3(s1,s2,s3) s1##s2##s3
#else
#define Concat(s1,s2) s1/**/s2
#define Concat3(s1,s2,s3) s1/**/s2/**/s3
#endif

#ifndef True
#define True            1
#define False           0
#endif

#undef NULL
#ifdef THINK_C
#define NULL    ((void *) 0)
#else /* THINK_C */
#define NULL    0	/* gcc includes define this as (void *)0 */
#endif /* THINK_C */

#define NumberOfCells(array)	(sizeof(array) / sizeof(array[0]))

#define OctWordP(p)		((OctWord *)(p))
#define ULongP(p)		((ULong *)(p))
#define UShortP(p)		((UShort *)(p))
#define UCharP(p)		((UChar *)(p))

#define OctAligned(p)		((ULong)(p) & 0x7 == 0)
#define LongAligned(p)		((ULong)(p) & 0x3 == 0)
#define ShortAligned(p)		((ULong)(p) & 0x1 == 0)

#if defined(sgi) || defined(sun) || defined(_HPUX_SOURCE)
#define WhenCodingForUnix(statements) { statements }
#define WhenDeclaringForUnix(declarations) declarations
#else
#define WhenCodingForUnix(statements) /* nothing */
#define WhenDeclaringForUnix(declarations) /* nothing */
#endif

#if defined(THINK_C) || defined(__MWERKS__)
#include <yvals.h>
#  ifndef _SIZET
#   define _SIZET
    typedef _Sizet size_t;
#  endif
#define WhenCodingForMac(statements) { statements }
#define WhenDeclaringForMac(declarations) declarations
#  if defined(THINK_C)
#  include "thinkUpp.h"
#  endif
#else
#define WhenCodingForMac(statements) /* nothing */
#define WhenDeclaringForMac(declarations) /* nothing */
#endif

#define MaskOf(nbits)   ((1 << (nbits)) - 1)

/*
 *	TYPEDEFS
 */
typedef unsigned char boolean;
typedef unsigned long ULong;
typedef unsigned int UInt;
typedef unsigned short UShort;
typedef unsigned char UChar;
typedef void (*VoidFuncPtr)();
typedef int (*IntFuncPtr)();
typedef long (*LongFuncPtr)();
typedef void *PrivPointer;

typedef union {
    struct {
        ULong high;
        ULong low;
    } l;
    double f;   /* this forces octword alignment */
} OctWord;

typedef OctWord (*OctWordFuncPtr)();

#ifdef __cplusplus

#define CExternal	extern "C"

# ifndef NeedFunctionPrototypes
# define NeedFunctionPrototypes 1
# endif

#include "c++system.H"

#else /* __cplusplus */

#define CExternal	extern

#endif /* __cplusplus */

#endif /* _TYPES_H_ */
