/*
 * (c) Copyright 1992 North Valley Research, Inc.
 *         All Rights Reserved
 *
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	osioI.h
 *
 * DESCRIPTION
 *	declare internal osio types
 *	OS-DEPENDENT
 *
 * REVISION
 * 	$Header: /usr/local/src/nvrToMIT/RCS/osioI.h,v 1.8 1994/10/22 18:42:25 toddb Exp $
 */

#ifndef _OSIOI_H
#define _OSIOI_H


#if defined(THINK_C) || defined(__MWERKS__)
#include "macOsio.h"
#else
#include <sys/types.h>
#include <sys/time.h>
#endif

#if defined(_HPUX_SOURCE) || defined(THINK_C) || defined(__MWERKS__)
    typedef int *SelectDataPtr;
#else
    typedef fd_set *SelectDataPtr;
#endif

#include "osio.h"

typedef struct _fileDescriptorInfo {
    void (*handler)(int, void*);/* function to call when IO is available */
    void *pointer;		/* data to be passed to handler */
    boolean bypassSelect;	/* ignore select() results; always call */
    boolean isAtty;		/* true if this fd is a tty */
    boolean async;		/* true if we do async notification */
} FileDescriptorInfo;

typedef struct _ioInfo {
    boolean signalHandlerSet;
    struct timeval noWait;
    int pid;
    int lastFd;
    fd_set inReady;
    FileDescriptorInfo *list;
} IoInfo;

extern IoInfo IoData;

CExternal void AllocHandler(int, VoidFuncPtr, boolean, void *);


#endif /* _OSIOI_H */
