/* $Header: /usr/local/src/nvrToMIT/RCS/queue.c,v 1.8 1995/04/23 02:01:38 toddb Exp $ */
#define NeedFunctionPrototypes 1

#include "nvrTypes.h"
#include "nvrQueue.h"
#include "nvrAlloc.h"

InternalReasonPtr
InitQueue(QueuePtr pq, long length)
{
    int allocSize = sizeof(QItem)*length;

    if (pq->array == NULL) {
	pq->array = (QItemPtr)InsecureAlloc(allocSize);
	if (pq->array == NULL)
	    return(AllocReason("queue array", allocSize));
    }
    pq->last = pq->array + length - 1;
    pq->head = pq->tail = pq->array;
    pq->nitems = length;
    pq->nRemoved = pq->nInserted = 0;
    return(NULL);
}

InternalReasonPtr
StretchQueue(QueuePtr pq, long length)
{
    Queue new;
    QItem item;
    InternalReasonPtr reason;

    if (length <= pq->nitems)
	return(NULL); /* don't try to shrink it */

    new.array = NULL;
    if (NULL != (reason = InitQueue(&new, length)))
	return(reason);

    /*
     * transfer the queue from the old to the new
     */
    while (! QueueEmpty(pq)) {
	item = TailOfQueue(pq, QItem);
	RemoveQueueTail(pq);
	InsertQueueHead(&new, item);
    }
    free((char *)pq->array);
    *pq	= new;
    return(NULL);
}

void
UninitQueue(QueuePtr pq)
{
    if (pq->array) {
	free((char *)pq->array);
	pq->array = NULL;
    }
}
