/*
 * (c) Copyright 1992, 1993 North Valley Research, Inc.
 * 	All Rights Reserved
 *
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	<name> - <one-line description of header file>
 *
 * DESCRIPTION
 *	<overall description of what the header file does>
 *
 * $Header: /usr/local/src/nvrToMIT/RCS/sparcmachdep.h,v 1.2 1993/03/30 08:41:19 toddb Exp $
 */
#ifndef _SPARCMACHDEP_H_
#define _SPARCMACHDEP_H_
/*
 *	DEFINES
 */

#define GlobalRegister(declare, regName)	register declare asm(regName)
#define LocalRegister(declare, regName)		register declare asm(regName)

#define MCOMMENT	"! "	/* sparc assembler comment */

#define SevenBitMultiply(result, sevenBitM1, m2)			\
    {									\
	register ULong tmp1 asm ("%g1");				\
	register ULong tmp2 asm ("%g2");				\
									\
	tmp1 = sevenBitM1;						\
	tmp2 = m2;							\
	asm volatile							\
	      ("! %0 <-- %1 * %2\n					\
		mov     %1, %%y\n					\
		andcc	%%g0, %%g0, %1 /* must have delay slot */\n	\
		mulscc  %1, %2, %1\n					\
		mulscc  %1, %2, %1\n					\
		mulscc  %1, %2, %1\n					\
		mulscc  %1, %2, %1\n					\
		mulscc  %1, %2, %1\n					\
		mulscc  %1, %2, %1\n					\
		mulscc  %1, %2, %1\n					\
		mulscc  %1, %%g0, %1\n					\
		rd	%%y, %0\n					\
		sll     %1, 0x7, %1\n					\
		srl     %0, 0x19, %0\n					\
		or	%0, %1, %0\n					\
		"							\
	    : "=r" (result)						\
	    : "r" (tmp1), "r" (tmp2));					\
    }

#define InReg1	"%i0"
#define InReg2	"%i1"
#define InReg3	"%i2"
#define InReg4	"%i3"
#define InReg5	"%i4"
#define InReg6	"%i5"
#define InReg7	"%g2"
#define InReg8	"%g3"
#define InReg9	"%g1"
#define InReg10	"%g4"

#define OutReg1	"%o0"
#define OutReg2	"%o1"
#define OutReg3	"%o2"
#define OutReg4	"%o3"
#define OutReg5	"%o4"
#define OutReg6	"%o5"
#define OutReg7	"%g2"
#define OutReg8	"%g3"
#define OutReg9	"%g1"
#define OutReg10 "%g4"

/*
 * When manufacturing a subroutine call, we must clobber all the
 * %o? and %g registers.
 */
#define ClobberAllRegisters						\
    "%o0", "%o1", "%o2", "%o3", "%o4", "%o5", "%o7",			\
    "%g1", "%g2", "%g3", "%g4", "%g5", "%g6", "%g7"

#define _Pass8(f, fConstraint, a1, a2, a3, a4, a5, a6, a7, a8)		\
    {									\
	Declare8OutRegisters(reg1,reg2,reg3,reg4,reg5,reg6,reg7,reg8)	\
									\
	reg1 = (long)a1;						\
	reg2 = (long)a2;						\
	reg3 = (long)a3;						\
	reg4 = (long)a4;						\
	reg5 = (long)a5;						\
	reg6 = (long)a6;						\
	reg7 = (long)a7;						\
	reg8 = (long)a8;						\
	asm volatile ("call %0,0;nop ! (%1,%2,%3,%4,%5,%6,%7,%8)" ::	\
	    fConstraint (f),						\
	    "r" (reg1), "r" (reg2), "r" (reg3),				\
	    "r" (reg4), "r" (reg5), "r" (reg6),				\
	    "r" (reg7),							\
	    "r" (reg8)							\
	    : ClobberAllRegisters);					\
    }

#define _Pass9Mem12(f, fConstraint, m1,m2,a3,a4,a5,a6,a7,a8,a9)		\
    {									\
	Declare9OutRegisters(reg1,reg2,reg3,reg4,reg5,reg6,reg7,reg8,reg9) \
									\
	asm volatile ("ldd %2,%0 ! (%1 modified)"			\
	    : "=r" (reg1), "=r" (reg2)					\
	    : "o" (m1));						\
	reg3 = (long)a3;						\
	reg4 = (long)a4;						\
	reg5 = (long)a5;						\
	reg6 = (long)a6;						\
	reg7 = (long)a7;						\
	reg8 = (long)a8;						\
	reg9 = (long)a9;						\
	asm volatile ("call %0,0;nop ! (%1,%2,%3,%4,%5,%6,%7,%8,%9)" ::	\
	    fConstraint (f),						\
	    "r" (reg1), "r" (reg2), "r" (reg3),				\
	    "r" (reg4), "r" (reg5), "r" (reg6),				\
	    "r" (reg7),							\
	    "r" (reg8),							\
	    "r" (reg9)							\
	    : ClobberAllRegisters);					\
    }

#define _Pass9Mem1234(f, fConstraint, m1,m2,m3,m4,a5,a6,a7,a8,a9)	\
    {									\
	Declare9OutRegisters(reg1,reg2,reg3,reg4,reg5,reg6,reg7,reg8,reg9) \
									\
	asm volatile ("ldd %2,%0 ! (%1 modified, too)"			\
	    : "=r" (reg1), "=r" (reg2)					\
	    : "o" (m1));						\
	asm volatile ("ldd %2,%0 ! (%1 modified, too)"			\
	    : "=r" (reg3), "=r" (reg4)					\
	    : "o" (m3));						\
	reg5 = (long)a5;						\
	reg6 = (long)a6;						\
	reg7 = (long)a7;						\
	reg8 = (long)a8;						\
	reg9 = (long)a9;						\
	asm volatile ("call %0,0;nop ! (%1,%2,%3,%4,%5,%6,%7,%8,%9)" ::	\
	    fConstraint (f),						\
	    "r" (reg1), "r" (reg2), "r" (reg3),				\
	    "r" (reg4), "r" (reg5), "r" (reg6),				\
	    "r" (reg7),							\
	    "r" (reg8),							\
	    "r" (reg9)							\
	    : ClobberAllRegisters);					\
    }

#define _Pass9(f, fConstraint, a1, a2, a3, a4, a5, a6, a7, a8, a9)	\
    {									\
	Declare9OutRegisters(reg1,reg2,reg3,reg4,reg5,reg6,reg7,reg8,reg9) \
									\
	reg1 = (long)a1;						\
	reg2 = (long)a2;						\
	reg3 = (long)a3;						\
	reg4 = (long)a4;						\
	reg5 = (long)a5;						\
	reg6 = (long)a6;						\
	reg7 = (long)a7;						\
	reg8 = (long)a8;						\
	reg9 = (long)a9;						\
	asm volatile ("call %0,0;nop ! (%1,%2,%3,%4,%5,%6,%7,%8,%9)" ::	\
	    fConstraint (f),						\
	    "r" (reg1), "r" (reg2), "r" (reg3),				\
	    "r" (reg4), "r" (reg5), "r" (reg6),				\
	    "r" (reg7),							\
	    "r" (reg8),							\
	    "r" (reg9)							\
	    : ClobberAllRegisters);					\
    }

#define _Pass10(f, fConstraint, a1, a2, a3, a4, a5, a6, a7, a8, a9, aa)	\
    {									\
	Declare10OutRegisters(reg1,reg2,reg3,reg4,reg5,			\
			      reg6,reg7,reg8,reg9,rega)			\
									\
	reg1 = (long)a1;						\
	reg2 = (long)a2;						\
	reg3 = (long)a3;						\
	reg4 = (long)a4;						\
	reg5 = (long)a5;						\
	reg6 = (long)a6;						\
	reg7 = (long)a7;						\
	reg8 = (long)a8;						\
	reg9 = (long)a9;						\
	rega = (long)aa;						\
	asm volatile ("call %0,0;nop" fConstraint (f));			\
	asm volatile ("! func(%0,%1,%2,%3,%4,%5,%6,%7,%8,%9)" ::	\
	    "r" (reg1), "r" (reg2), "r" (reg3),				\
	    "r" (reg4), "r" (reg5), "r" (reg6),				\
	    "r" (reg7),							\
	    "r" (reg8),							\
	    "r" (reg9)							\
	    "r" (rega)							\
	    : ClobberAllRegisters);					\
    }

#endif /* _SPARCMACHDEP_H_ */
