#include "nvrTimer.h"
#include "osio.h"

char *ProgramName;

double atof(char *);

main(int argc, char **argv)
{
    boolean useMacro = False;
    TimerInc timer;
    float rate;
    long unit, runs, value, i, total;

    ProgramName = *argv++; argc--;

    if (argc > 1 && strcmp(argv[0], "macro") == 0) {
	useMacro = True;
	argv++; argc--;
    }

    if (argc != 2)
	Fatal("Usage: %s rate unit\n", ProgramName);

    rate = atof(argv[0]);
    unit = atoi(argv[1]);
    InitTimerInc(&timer, rate, unit);

    Msg("inc, remainder, denom = %d, %d, %d\n",
	timer.increment, timer.remainder, timer.denom);
    runs = timer.denom / timer.increment + 1;
    if (runs < 10)
	runs = 10;
    for (i = 1; i <= runs; i++) {
	if (useMacro) {
	    value = TimerIncrementMacro(timer);
	} else {
	    value = TimerIncrement(&timer);
	}
	if (i < 10 || i >= runs-2)
	    Msg("%d%s", value, i == 0 ? "" : ",");
	else if (i == 10)
	    Msg("...,");
    }

    Msg("\nacc = %d\n", timer.accumulator);
    Msg("running... ");

    /*
     * Now run it lots
     */
    InitTimerInc(&timer, rate, unit);
    total = 0;
    if (useMacro) {
	for (i = 0; i < 10000; i++) {
	    total += TimerIncrementMacro(timer);
	}
    } else {
	for (i = 0; i < 10000; i++) {
	    total += TimerIncrement(&timer);
	}
    }
    Msg("over %d runs, freq=%f\n", i, (i / (float) total) * unit);
}
