/*
 * Copyright (c) 1992,1993, North Valley Research, Inc.
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	<file name> - <one-line description of file contents>
 *
 * DESCRIPTION
 *	<overall description of what the c code does>
 *
 * $Header: /usr/local/src/nvrToMIT/RCS/testfilec.c,v 1.3 1994/02/19 00:20:01 toddb Exp $
 */
#include "fileAccess.h"
#include "fileContent.h"

char *ProgramName;

main(argc, argv)
    int argc;
    char **argv;
{
    FileInfo finfo;
    int type;

    ProgramName = *argv;

    for (argc--, argv++; argc; argc--, argv++) {
	switch (type = FileType(*argv)) {
	case FILE_REGULAR:
	    break;
	default:
	    Msg("%s is a %s\n", *argv, TypeName(type));
	    continue;
	}

	GetFileInfo(*argv, &finfo);
	Msg("%s: %s", *argv, ContentName(finfo.type));
	
	switch(finfo.type) {
	case FILEC_UNKNOWN:
	case FILEC_MPEG_AUDIO:
	case FILEC_MPEG_SYSTEM:
	case FILEC_SUN_AUDIO:
	case FILEC_AIFC_AUDIO:
	case FILEC_AIFF_AUDIO:
	    break;
	case FILEC_PLX_MOVIE:
	case FILEC_NVR_YUV:
	case FILEC_MPEG_VIDEO:
	    Msg(" %dx%d, %d frames @ %dfps",
		finfo.width,
		finfo.height,
		finfo.frameCount,
		finfo.framesPerSecond);
	    break;
	}
	Msg("\n");
    }
}
