/*
 * Copyright (c) 1992,1993, North Valley Research, Inc.
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	unixFileContent.c - determine the content of a file
 *
 * $Header: /usr/local/src/nvrToMIT/RCS/unixFileContent.c,v 1.2 1995/08/30 02:16:36 russ Exp $
 */

#include "fileAccess.h"
#include "fileContent.h"
#include "osio.h"

InternalReasonPtr
GetFileContentInfo(char *path, FileInfoPtr pFileInfo)
{
    char buffer[4096];
    int fd;
    int bytesIn;
    FileContentType type;

    /* to start with... */
    memset((char *)pFileInfo, 0, sizeof(*pFileInfo));

    if ((fd = OpenFileForReading(path)) < 0) {
      return CreateSysReason("Can't open %s\n",
                             ExtractPathSuffix(path));
    }

    bytesIn = ReadData(fd, buffer, sizeof(buffer));
    CloseFile(fd);
    if (bytesIn < 0) {
      return CreateSysReason("Can't read from %s\n",
                             ExtractPathSuffix(path));
    }
    if (bytesIn < NVRTYPEHDR)
      return(NULL);

    type = GetFileType(buffer,bytesIn);
    if (type == FT_Unknown) {
	if ((fd = OpenFileForReading(path)) < 0) {
	    return CreateSysReason("Can't open %s\n",
				   ExtractPathSuffix(path));
	}

	SeekFile(fd, - NVRTYPETRAILER, SK_End);
	bytesIn = ReadData(fd, buffer, NVRTYPETRAILER);
	CloseFile(fd);
	if (bytesIn < NVRTYPETRAILER){
	    return(NULL);
	}
	type = GetFileType(buffer,bytesIn);
    }
    pFileInfo->type = type;
    pFileInfo->cClass = GetClassFromType(pFileInfo->type);

    return(NULL);
}

