/*
 * (c) Copyright 1992 North Valley Research, Inc.
 *         All Rights Reserved
 *
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	vwFileAcc.c
 *
 * DESCRIPTION
 *	OS-specific access to files (permissions, etc).
 *	OS-DEPENDENT
 *
 * REVISION
 *	$Header: /usr/local/src/nvrToMIT/RCS/vwFileAcc.c,v 1.1 1994/01/17 15:57:57 toddb Exp $
 */

#define NeedFunctionPrototypes 1

#include "fileAccessI.h"

int
lstat(char *path, struct stat *statbuf)
{
    return( stat(path, statbuf) );
}

int
access(char *path, int mode)
{
    NotImplemented("access");
    return(0);
}

int
readlink(char *path, char *buf, int n)
{
    NotImplemented("readlink");
    strcpy(buf, path);
    return (strlen(buf));
}

char *
getcwd(char *path, int size)
{
    strcpy(path, "/");
    return(path);
}

getwd(char *path, int size)
{
    return( getcwd(path, size) );
}
