/*
 * (c) Copyright 1992 North Valley Research, Inc.
 * 	All Rights Reserved
 *
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	vwProcess.c
 *
 * DESCRIPTION
 *	Management of sub-processes
 *	OS-DEPENDENT
 *
 * REVISION
 *	$Header: /usr/local/src/nvrToMIT/RCS/vwProcess.c,v 1.2 1994/12/17 13:02:15 russ Exp $
 */

#define NeedFunctionPrototypes 1

#include "process.h"
#include "osio.h"
#include <sys/types.h>
#include <ioLib.h>
#include <signal.h>
#define PIPE1_NAME	"/pipe/mpegTo"
#define PIPE2_NAME	"/pipe/mpegFrom"
#define PIPE_MSG_SIZE   128                      /* size of each message in
                                                  * pipe */
#define PIPE_MSG_MAX    64                       /* max. number of messages */

int taskId;

TwoWayPipe
PipeToAndFrom(argv, argumentRewriter)
    Argvec *argv;
    void (*argumentRewriter)();
{
    int pid;
    int pipeFdTo[2];
    int pipeFdFrom[2];
    TwoWayPipe result;
    int xt_priority;
    int argc = 0;
    char **tmp;
    int child_stksize = 65000;
    extern Main();
    char **Argv;
    char *SaveArgs;
    int i, l;

    /* create pipes */
    if (pipeDrv() == ERROR ||
        pipeDevCreate(PIPE1_NAME, PIPE_MSG_MAX, PIPE_MSG_SIZE) == ERROR)
    {
        Fatal("can't creat pipes\n");
    }
    if (pipeDrv() == ERROR ||
        pipeDevCreate(PIPE2_NAME, PIPE_MSG_MAX, PIPE_MSG_SIZE) == ERROR)
    {
        Fatal("can't creat pipes\n");
    }
    if ((pipeFdTo[0] = open(PIPE1_NAME, O_WRONLY, 0)) < 0)
    {
        Fatal("can't creat pipes\n");
    }
    if ((pipeFdTo[1] = open(PIPE1_NAME, O_RDONLY, 0)) < 0)
    {
        Fatal("can't creat pipes\n");
    }
    if ((pipeFdFrom[1] = open(PIPE2_NAME, O_WRONLY, 0)) < 0)
    {
        Fatal("can't creat pipes\n");
    }
    if ((pipeFdFrom[0] = open(PIPE2_NAME, O_RDONLY, 0)) < 0)
    {
        Fatal("can't creat pipes\n");
    }
    if (argumentRewriter)
	(*argumentRewriter)(argv, pipeFdTo[1], pipeFdFrom[1]);

    if (taskPriorityGet(taskIdSelf(), &xt_priority))
    {
        Fatal("Can't get task priority\n");
    }
    tmp = argv->argv;
    l = 0;

    do
    {
	l += strlen(*tmp) + 1;
	argc++;
    } while (*tmp++);

    Argv = (char **) malloc(4 * argc);
    SaveArgs = (char *) malloc(l);
    

    for (i = 0; i < argc; i++)
    {
	Argv[i] = SaveArgs;
	memcpy(SaveArgs, argv->argv[i], (l = (strlen(argv->argv[i]) + 1)));
	SaveArgs += l;
    }
    
    pid = taskSpawn(argv->path, xt_priority + 2, 
	VX_STDIO | VX_DEALLOC_STACK | VX_PRIVATE_ENV, child_stksize, 
	(FUNCPTR) Main, argc, Argv, 
	0, 0, 0, 0, 0, 0, 0, 0);
    if (pid == ERROR)
    {
	Fatal("can't spawn child\n");
    }
    /* we still need to consider which pipes should be closed in the following
       situations */

    taskId = pid;
    result.pid = pid;
    result.outFd = pipeFdTo[0];
    result.inFd = pipeFdFrom[0];
    return(result);
}

vwsigTask()
{
	sigRaise(taskId, SIGSTOP, 0);
}

int
getuid()
{
    NotImplemented("getuid");
    return(0);
}

getpwuid()
{
    NotImplemented("getpwuid");
    return(0);
}

void
usleep(count)
{
    (void) taskDelay((count * sysClkRateGet())/1000);
}
