/*
 * (c) Copyright 1992, 1993 North Valley Research, Inc.
 * 	All Rights Reserved
 *
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	xextension.h - include file for xextension.c and programs that use it.
 *
 * DESCRIPTION
 *	X-DEPENDENT
 *
 * $Header: /usr/local/src/nvrToMIT/RCS/xextension.h,v 1.6 1994/01/10 18:48:13 toddb Exp $
 */
#ifndef _XEXTENSION_H_
#define _XEXTENSION_H_

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "nvrTypes.h"

/*
 *	DEFINES
 */

/*
 * bits that represent abilities to do analog video display
 */
#define VDPY_PARALLAX		0x001
#define VDPY_XV			0x002
#define VDPY_MVEX		0x004

/*
 * Bits that represent other interesting X extensions.
 */
#define VDPY_SUN_DGA		0x008
#define VDPY_SUN_WINDOW_GRABBER	0x010
#define VDPY_SUN_ALLPLANES	0x020

/*
 * bits that represent abilities to do digital video display
 */
#define VDPY_PLX_JPEG		0x040
#define VDPY_SWMPEG		0x080
#define VDPY_SWJPEG		0x100

/*
 *	TYPEDEFS
 */
/*
 *	EXTERNS
 */
CExternal ULong FindVideoAbilities(
#if NeedFunctionPrototypes
    Display *,
    int		/* screen index */
#endif
);

#endif /* _XEXTENSION_H_ */
