/*
 *	(c) Copyright 1992,1993,1994 North Valley Research, Inc.
 *		All Rights Reserved
 *
 *	Confidential -- All proprietary rights reserved.
 *	Licensed Material -- Property of North Valley Research, Inc.
 *
 *	This program is the property of North Valley Research, Inc. or others
 *	from whom North Valley Research has obtained a licensing right, and is
 *	considered by North Valley Research to be confidential.  It is protected
 *	by U.S. copyright law as an unpublished work and is
 *	furnished pursuant to a written license agreement.  It may
 *	not be used, copied or otherwise reproduced, or disclosed to
 *	others except in accordance with the terms and conditions of
 *	that agreement.
 *
 *	NAME
 *		idctMotionI.h - motion-related header
 *
 *	REVISION
 *		$Header: /usr/local/src/nvrToMIT/RCS/idctMotionI.h,v 1.2 1995/10/12 20:19:01 toddb Exp $
 */
#ifndef IDCTMOTIONI_H
#define IDCTMOTIONI_H

/************************************************************************
 *
 * Rounding results of motion compensation
 *
 ************************************************************************/
#define DontRoundMotion	1
#define RoundMotion	2

#ifndef MotionRounding
#define MotionRounding RoundMotion
#endif

#if MotionRounding == RoundMotion

#define Rnd1	1
#define Rnd2	2
#define Rnd1x4	0x01010101		/* round 1 bit for four sources */

#else /* MotionRounding != RoundMotion */

#define Rnd1	0
#define Rnd2	0

#endif /* MotionRounding != RoundMotion */

/************************************************************************
 *
 * Methods for storing 4 and 8 byte aligned chunks
 *
 ************************************************************************/
#define Store8bAsOct	1
#define Store8bAs2Long	2
#define Store8bAs8b	3

#ifndef Aligned8bStoreMethod
#define Aligned8bStoreMethod Store8bAs8b
#endif

#if Aligned8bStoreMethod == Store8bAs8b
#define StoreAligned8b(_ptr, _p0,_p1,_p2,_p3,_p4,_p5,_p6,_p7)		\
    (_ptr)[0] = _p0;							\
    (_ptr)[1] = _p1;							\
    (_ptr)[2] = _p2;							\
    (_ptr)[3] = _p3;							\
    (_ptr)[4] = _p4;							\
    (_ptr)[5] = _p5;							\
    (_ptr)[6] = _p6;							\
    (_ptr)[7] = _p7;
#endif /* Aligned8bStoreMethod == Store8bAs8b */

#if Aligned8bStoreMethod == Store8bAs2Long
#define StoreAligned8b(_ptr, _p0,_p1,_p2,_p3,_p4,_p5,_p6,_p7)		\
    ULongP(_ptr)[0] = (_p0<<24) | _p1<<16) | (_p2<<8) | _p3;		\
    ULongP(_ptr)[1] = (_p4<<24) | _p5<<16) | (_p6<<8) | _p7;
#endif /* Aligned8bStoreMethod == Store8bAs8b */

#define Store4bAsLong	1
#define Store4bAs4b	2

#ifndef Aligned4bStoreMethod
#define Aligned4bStoreMethod Store4bAs4b
#endif

#if Aligned4bStoreMethod == Store4bAs4b
#define StoreAligned4b(_ptr, _p0,_p1,_p2,_p3)				\
    (_ptr)[0] = _p0;							\
    (_ptr)[1] = _p1;							\
    (_ptr)[2] = _p2;							\
    (_ptr)[3] = _p3;
#endif /* Aligned4bStoreMethod == Store4bAs4b */

#if Aligned4bStoreMethod == Store4bAs2Long
#define StoreAligned4b(_ptr, _p0,_p1,_p2,_p3)				\
    ULongP(_ptr)[0] = (_p0<<24) | _p1<<16) | (_p2<<8) | _p3;
#endif /* Aligned8bStoreMethod == Store8bAs8b */

#endif /* IDCTMOTIONI_H */

