/*
 * Copyright (c) 1992,1993,1994 North Valley Research, Inc.
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *      noopIdct.c - noop idct function
 *
 * DESCRIPTION
 *
 * $Header: /usr/local/src/nvrToMIT/RCS/noopIdct.c,v 1.1 1995/08/14 22:10:58 toddb Exp $
 */

#include "nvrIdctI.h"

static void
noopInverseDct(IdctParamPtr idctp)
{
    DctListInfoPtr idctList;
    IdctParamPrivPtr priv = (IdctParamPrivPtr)idctp;
    
    for (idctList = idctp->arenaQ; idctList; idctList = idctp->arenaQ) {

        /*
         * Clean up after this one and move to the next.
         */
        idctp->arenaQ = idctList->next;
        idctList->next = priv->arenaFree;
        priv->arenaFree = idctList;
    }

    priv->arenaLast = NULL;
}

static int
noopIdctParamSize(void)
{
    return(sizeof(IdctParamPriv));
}

static InternalReasonPtr
noopCreateIdctParam(IdctParamPtr idctp)
{
    idctp->inverseDct = noopInverseDct;

    return(NULL);
}

/***************************************************************************
 *
 * public method interfaces.
 *
 ***************************************************************************/

static IdctMethod noopIdctMethod = {
    noopIdctParamSize,
    noopCreateIdctParam
};

IdctMethodPtr NoopIdctMethod = &noopIdctMethod;
