:
# @(#)instman.sh	1.6 1/28/93 14:37:44 - Copyright 1992 Elan Computer Group, Inc.
#
# Install man pages:
#	1) Inserts macro file into prologue.
#	2) Converts abridged names to long names if file system supports it.
#
LIST=no
LONGNAMES=no

if [ "x$1" = "x-l" ]; then
	LIST=yes;
	LONGNAMES=yes
	shift
fi

SECT=$1
MANDIR=$2

if [ $LIST = no ]; then
	if [ -z "${MANDIR}" ]; then 
		exit 0
	fi
	if [ ! -d "${MANDIR}" ]; then 
		echo "*** Directory $MANDIR does not exist."
		exit 0
	fi
	NAME17=averylongfilename
	NAME14=averylongfilen

	rm -f $MANDIR/$NAME14 $MANDIR/$NAME17
	cp /dev/null $MANDIR/$NAME17 || exit 1
	if [ ! -f $MANDIR/$NAME14 ]; then
		LONGNAMES=yes
	fi
	rm -f $MANDIR/$NAME14 $MANDIR/$NAME17

	echo ""
	echo "Installing Section ${SECT} ..."

fi

for file in *.${SECT}
do
	DEST=$file
	if [ ${LONGNAMES} = yes ]; then
		case $file in
			elm_chklicen.3)	DEST=elm_chklicense.3;;
			elm_codedeco.3)	DEST=elm_codedecode.3;;
			elm_free_arr.3)	DEST=elm_free_array.3;;
			elm_getlicen.3)	DEST=elm_getlicense.3;;
			elm_getkey.3)	DEST=elm_getkeyfile.3;;
			elm_getserve.3)	DEST=elm_getservers.3;;
			elm_hbeat.3)	DEST=elm_heartbeat.3;;
			elm_keydecod.3)	DEST=elm_keydecode.3;;
			elm_nngencod.3)	DEST=elm_nngencode.3;;
			elm_putkey.3)	DEST=elm_putkeyfile.3;;
			elm_retlicen.3)	DEST=elm_retlicense.3;;
			elm_val_feat.3)	DEST=elm_val_feature.3;;
			elm_val_lice.3)	DEST=elm_val_licenses.3;;
			elm_val_vend.3)	DEST=elm_val_vendordata.3;;
			lsenumprov.3)	DEST=lsenumproviders.3;;
			lsquery.3)	DEST=lsquerylicense.3;;
		esac
	fi
	if [ $LIST = yes ]; then
		echo "$DEST"; 
	else
		echo "$file -> ${MANDIR}/$DEST"; 
		cat macros $file > ${MANDIR}/$DEST; 
	fi
done 
