#ifndef lint
static char SCCSid[] = "@(#)xtclient.c	1.3 12/17/93 ELAN";
#endif

/*
 * Copyright (c) 1993 Elan Computer Group, Inc.
 * All Rights Reserved.
 *
 * This is unpublished proprietary source code of Elan Computer Group, Inc.
 * The copyright notice above does not evidence any actual
 * or intended publication of such source code.
 */

/*
 * Sample X11/Motif application using Elan Licnese Manager
 */

#include <stdio.h>
#include <signal.h>
#include <varargs.h>
#include <Xm/PushB.h>
#include <Xm/Protocols.h>
#include "elm.h"

#define BEAT		60
#define FEATURE		"99"

char server[ELM_HOST_LEN+1];
char *Keydir = elm_keydir;

/*VARARGS*/
void quit(va_alist)
va_dcl
{
	va_list args;
	char *fmt;

	va_start (args);
	fmt = va_arg(args, char *);

	vfprintf (stderr, fmt, args);
	fprintf (stderr, "\n");

	va_end (args);

	elm_bye();
	exit (-1);
}

/*
 * Routine called when process exits.
 *	1. Disconnect from license server (elm_bye).
 *	2. Exit with error code "code".
 */
/*VARARGS*/
void byebye()
{
	printf ("Exiting...\n[%d] PID %ld disconnecting.\n", elm_clientid(), getpid());

	elm_bye();

	printf ("[%d] PID %ld exiting.\n", elm_clientid(), getpid());

	exit (0);
}

/*
 * Catch all normal signals (hangup, interrupt, quit, term)
 * and call "byebye" routine when any of these signals occur.
 */
void
catchem()
{
	signal (SIGHUP, byebye);
	signal (SIGINT, byebye);
	signal (SIGQUIT, byebye);
	signal (SIGTERM, byebye);
}

/*
 * Do all the initialization stuff:
 *	1. Connect with the licenser server (elm_init).
 *	2. Exit if any problems.
 */
void
do_init (feature)
char *feature;
{
	char *h;
	int handle;
	extern char *getenv();

	catchem();			/* Catch signals */

	server[0] = '\0';
	handle = elm_init(server, feature, Keydir, (int (*)())NULL);

	if (handle < 0)
	{
		printf ("%s.\n", elm_message (server, feature, handle));
		exit (1);
	}
	printf ("[%d] Connected with server \"%s\".\n", elm_clientid(), server);
}

Exception (code, feature)
char *feature;
{
	quit ("%s.", elm_message (server, FEATURE, code));
}

void 
pushed(w, client_data, cbs)
Widget w;
XtPointer client_data;
XmPushButtonCallbackStruct *cbs;
{
	printf ("Button pushed!\n");
}

main(argc, argv)
char **argv;
{
	XtAppContext app;
	Widget toplevel, button;
	XmString btn_text;
	int code;
	Atom deleteWindowAtom;

	toplevel = XtVaAppInitialize (&app, "Demo", 
	    NULL, 0, &argc, argv, NULL, NULL);

	do_init(FEATURE);

	elm_xtheartbeat (app, BEAT, Exception);

	if ((code = elm_getlicense (FEATURE, ELM_GETLIC)) < 0)
		quit ("%s.", elm_message (server, FEATURE, code));

	btn_text = XmStringCreateSimple ("Push Me");

	button = XtVaCreateManagedWidget ("button",
	    xmPushButtonWidgetClass, toplevel,
	    XmNlabelString, btn_text,
	    XmNwidth, 50,
	    XmNheight, 25,
	    NULL);

	XmStringFree (btn_text);
	XtAddCallback (button, XmNactivateCallback, pushed, NULL);
	XtRealizeWidget (toplevel);

	/*
	 * Set up handler to exit when quit chosen from window manager.
	 */
	deleteWindowAtom = XmInternAtom(XtDisplay(toplevel),
	    "WM_DELETE_WINDOW", False);
	XmAddWMProtocolCallback(toplevel, deleteWindowAtom, byebye, 0);

	printf ("There should be a window with button on your display.\n");
	XtAppMainLoop (app);
	byebye();		/* In theory, we should never get here */
	exit (0);
}
