#ifndef lint
static char SCCSid[] = "@(#)xvclient.c	1.4 12/17/93 ELAN";
#endif

/*
 * Copyright (c) 1993 Elan Computer Group, Inc.
 * All Rights Reserved.
 *
 * This is unpublished proprietary source code of Elan Computer Group, Inc.
 * The copyright notice above does not evidence any actual
 * or intended publication of such source code.
 */

/*
 * Sample Xview application using Elan Licnese Manager
 */

#include <stdio.h>
#include <signal.h>
#include <xview/xview.h>
#include <xview/frame.h>
#include <xview/panel.h>
#include "elm.h"

#define BEAT		60
#define FEATURE		"99"

char server[ELM_HOST_LEN+1];
char *Keydir = elm_keydir;

/*VARARGS*/
void quit(va_alist)
va_dcl
{
	va_list args;
	char *fmt;

	va_start (args);
	fmt = va_arg(args, char *);

	vfprintf (stderr, fmt, args);
	fprintf (stderr, "\n");

	va_end (args);

	elm_bye();
	exit (-1);
}

/*
 * Routine called when process exits.
 *	1. Disconnect from license server (elm_bye).
 *	2. Exit with error code "code".
 */
/*VARARGS*/
void byebye()
{
	printf ("\n[%d] PID %ld disconnecting.\n", elm_clientid(), getpid());

	elm_bye();

	printf ("[%d] PID %ld exiting.\n", elm_clientid(), getpid());

	exit ();
}

/*
 * Catch all normal signals (hangup, interrupt, quit, term)
 * and call "byebye" routine when any of these signals occur.
 */
void
catchem()
{
	signal (SIGHUP, byebye);
	signal (SIGINT, byebye);
	signal (SIGQUIT, byebye);
	signal (SIGTERM, byebye);
}

/*
 * Do all the initialization stuff:
 *	1. Connect with the licenser server (elm_init).
 *	2. Exit if any problems.
 */
void
do_init (feature)
char *feature;
{
	char *h;
	int handle;
	extern char *getenv();

	catchem();			/* Catch signals */

	server[0] = '\0';
	handle = elm_init(server, feature, Keydir, (int (*)())NULL);

	if (handle < 0)
	{
		printf ("%s.\n", elm_message (server, feature, handle));
		exit (1);
	}
	printf ("[%d] Connected with server \"%s\".\n", elm_clientid(), server);
}

Exception (code, feature)
char *feature;
{
	quit ("%s.", elm_message (server, FEATURE, code));
}

pushed()
{
	printf ("Button pushed!\n");
}

main(argc, argv)
char **argv;
{
	Frame frame;
	Panel panel;
	void quit();
	int code;

	xv_init (XV_INIT_ARGC_PTR_ARGV, &argc, argv, NULL);

	do_init(FEATURE);

	if ((code = elm_getlicense (FEATURE, ELM_GETLIC)) < 0)
		quit ("%s.", elm_message (server, FEATURE, code));

	frame = (Frame) xv_create (NULL, FRAME,
		FRAME_LABEL, argv[0],
		XV_WIDTH, 80,
		XV_HEIGHT, 40,
		NULL);

	elm_xvheartbeat (frame, BEAT, Exception);

	panel = (Panel) xv_create (frame, PANEL, NULL);

	(void) xv_create (panel, PANEL_BUTTON,
		PANEL_LABEL_STRING, "Push Me",
		PANEL_NOTIFY_PROC,   pushed,
		NULL);

	printf ("There should be a window with button on your display.\n");
	xv_main_loop(frame);
	byebye(0);
}
