/*
 * @(#)lsapi.h	1.5 11/5/93 10:21:07 - Elan Computer Group, Inc. (c) 1992
 *
 * Copyright (c) 1993 Elan Computer Group, Inc.
 * All Rights Reserved.
 *
 * This is unpublished proprietary source code of Elan Computer Group, Inc.
 * The copyright notice above does not evidence any actual
 * or intended publication of such source code.
 */

/*
 * LSAPI 1.0 Definitions for use with Elan Licnese Manager r2.2 or above.
 */

/*
 **********************************************************************
 * Generic definitions
 **********************************************************************
 */
#ifndef ELM_UINT
#define ELM_UINT		unsigned int
#endif
#ifndef ELM_ULONG
#define ELM_ULONG		unsigned long
#endif
#ifndef ELM_UCHAR
#define ELM_UCHAR		unsigned char
#endif

/*
 **********************************************************************
 * Type definitions
 **********************************************************************
 */
typedef unsigned long LS_STATUS_CODE;

typedef struct
{
	ELM_ULONG ulReserved;		/* Must be 0 */
	ELM_ULONG ulChallengedSecret;	/* Which secret (1-4) */
	ELM_ULONG ulChallengeSize;	/* 4-255 */
	ELM_UCHAR ChallengeData[256];	/* Size is ulChallengeSize */
} LS_CHALLENGE;

typedef struct
{
	ELM_ULONG ulRersponseSize;	/* 0 or 16 (bytes) */
	ELM_UCHAR ResponseData[16];	/* Size is ulResponseSize */
} LS_CHALLENGERESPONSE;

typedef unsigned long LS_HANDLE;

/*
 **********************************************************************
 * Constant definitions
 **********************************************************************
 */
#define LS_DEFAULT_UNITS	((unsigned long) 0xffffffffL)
#define LS_ANY			((unsigned long) 0L)
#define LS_USE_LAST		((unsigned long) 0x0800ffffL)

#define LS_SUCCESS			0x0
#define LS_BADHANDLE			0xc8001001
#define LS_INSUFFICIENTUNITS		0xc8001002
#define LS_LICENSESYSNOTAVAILABLE	0xc8001003
#define LS_LICENSETERMINATED		0xc8001004
#define LS_NOAUTHORIZATIONAVAILABLE	0xc8001005
#define LS_NOLICENSESAVAILABLE		0xc8001006
#define LS_NORESOURCES			0xc8001007
#define LS_NO_NETWORK			0xc8001008
#define LS_NO_MSG_TEXT			0xc8001009
#define LS_UNKNOWN_STATUS		0xc800100a
#define LS_BAD_INDEX			0xc800100b
#define LS_NO_MORE_UNITS		0xc800100c
#define LS_LICENSE_EXPIRED		0xc800100d
#define	LS_BUFFER_TOO_SMALL		0xc800100e /* Not assigned is LSAPI */

/* 
 * Values not defined in the LSAPI 1.0 document.
 */
#define LS_INFO_NONE		0
#define LS_INFO_SYSTEM		1
#define	LS_INFO_DATA		2
#define	LS_UPDATE_PERIOD	3
#define LS_LICENSE_CONTEXT	4

#ifndef CARGS
#if (defined(__GNUG__) || defined(C_plusplus) || defined(__cplusplus))
						/* C++ */
#define EXTERN		extern "C"
#define ELM_CONST	const
#define CARGS(args)	args
#else

#ifdef __STDC__
						/* ANSI-C */
#define EXTERN		extern
#define ELM_CONST	const
#define CARGS(args)	args

#else
						/* K&R C */
#define EXTERN		extern 
#define ELM_CONST
#define CARGS(args)	()
#endif
#endif
#endif

/*
 **********************************************************************
 * Function Prototype definitions
 **********************************************************************
 */
/*
 * Declaration format...
 *		EXTERN type name	CARGS((arglist))
 * Note: use double parens with CARGS.
 *
 * The declarations below may be sorted with "sort -b -d +2"
 */

EXTERN LS_STATUS_CODE EEXPORT LSEnumProviders CARGS((ELM_ULONG, ELM_UCHAR *));
EXTERN LS_STATUS_CODE EEXPORT LSGetMessage    CARGS((LS_HANDLE, LS_STATUS_CODE, ELM_UCHAR *, ELM_ULONG));
EXTERN LS_STATUS_CODE EEXPORT LSQueryLicense  CARGS((LS_HANDLE, ELM_ULONG, void *, ELM_ULONG));
EXTERN LS_STATUS_CODE EEXPORT LSRequest       CARGS((ELM_UCHAR *, ELM_UCHAR *, ELM_UCHAR *, ELM_UCHAR *, ELM_ULONG *, ELM_UCHAR *, LS_CHALLENGE *, LS_HANDLE *));
EXTERN LS_STATUS_CODE EEXPORT LSRelease       CARGS((LS_HANDLE, ELM_ULONG, ELM_UCHAR *));
EXTERN LS_STATUS_CODE EEXPORT LSUpdate        CARGS((LS_HANDLE, ELM_ULONG, long *, ELM_UCHAR *, LS_CHALLENGE *));
