#ifndef lint
static char SCCSid[] = "@(#)test.c	1.8 1/3/94 ELAN";
#endif

/*
 * Copyright (c) 1993 Elan Computer Group, Inc.
 * All Rights Reserved.
 *
 * This is unpublished proprietary source code of Elan Computer Group, Inc.
 * The copyright notice above does not evidence any actual
 * or intended publication of such source code.
 */

#include <stdio.h>
#include "elm.h"
#include "lsapi.h"

#define FEATURE		"99"

void
pstatus (func, code, handle)
char *func;
LS_STATUS_CODE code;
LS_HANDLE handle;
{
	unsigned char message[128];

	LSGetMessage (handle, code, message, sizeof(message));

	printf ("%s returns %lx (%s); handle=%ld\n",
		func, code, message, handle);
}

main()
{
	LS_STATUS_CODE status;
	unsigned long units = (unsigned long)1L;
	long newunits;
	LS_HANDLE handle = (LS_HANDLE) -1L;
	char buffer[1024];
	struct ls_info
	{
		unsigned long count;
		struct elm_info info;
	} *ls;

	printf ("Test of LSAPI 1.0 and Elan License Manager ...\n\n");

	status = LSRequest (LS_ANY, NULL, 
			(unsigned char *)FEATURE, NULL, &units,
			(unsigned char *)"LSAPI request", NULL, &handle);

	if (status == LS_SUCCESS)
		printf ("LSRequest: License for %s successfully acquired.\n", FEATURE);
	else
		pstatus ("LSRequest", status, handle);
	printf ("\n");

	status = LSQueryLicense(handle, LS_INFO_SYSTEM, buffer, sizeof(buffer));
	if (status == LS_SUCCESS)
		printf ("LSQueryLicense/LS_INFO_SYSTEM: %s\n", buffer);
	else
		pstatus ("LSQueryLicense/LS_INFO_SYSTEM", status, handle);
	printf ("\n");

	status = LSQueryLicense(handle, LS_INFO_DATA, buffer, sizeof(buffer));
	if (status == LS_SUCCESS)
	{
		ls = (struct ls_info *)buffer;
		printf ("LS_INFO_DATA: %ld bytes\n", ls->count);
		printf ("\tFeature:\t%s\n", ls->info.feature);
		printf ("\tAlias:\t%s\n", ls->info.alias);
		printf ("\tVdata:\t%s\n", ls->info.vendordata);
		printf ("\tExpiration:\t%.24s\n",ctime(&(ls->info.expiration)));
		printf ("\tNum licenses:\t%ld\n", ls->info.numlic);
		printf ("\tNum reserved:\t%ld\n", ls->info.numresv);
	}
	else
		pstatus ("LSQueryLicense/LS_INFO_DATA", status, handle);
	printf ("\n");

	status = LSQueryLicense(handle, LS_UPDATE_PERIOD,buffer,sizeof(buffer));
	if (status == LS_SUCCESS)
	{
		ls = (struct ls_info *)buffer;
		printf ("LSQueryLicense/LS_UPDATE_PERIOD: %ld minutes\n", ls->count);
	}
	else
		pstatus ("LSQueryLicense/LS_UPDATE_PERIOD", status, handle);
	printf ("\n");

	status = LSQueryLicense(handle, LS_LICENSE_CONTEXT, 
				buffer, sizeof(buffer));

	if (status == LS_SUCCESS)
	{
		ls = (struct ls_info *)buffer;
		printf ("LSQueryLicense/LS_LICENSE_CONTEXT: %s\n", &(ls->info));
	}
	else
		pstatus ("LSQueryLicense/LS_LICENSE_CONTEXT", status, handle);
	printf ("\n");

	newunits = LS_DEFAULT_UNITS;
	status = LSUpdate (handle, LS_DEFAULT_UNITS, &newunits, NULL, NULL);
	if (status == LS_SUCCESS)
		printf ("LSUpdate succesfull.\n");
	else
		pstatus ("LSUpdate", status, handle);
	printf ("\n");

	status = LSRelease (handle, LS_DEFAULT_UNITS,
				(ELM_UCHAR *)"End of LSAPI test");

	if (status == LS_SUCCESS)
		printf ("LSRelease: License succesfully returned.\n");
	else
		pstatus ("LSRelease", status, handle);

	return (0);
}
