/* $Header: /usr/local/src/nvrToMIT/RCS/extImageProto.h,v 1.3 1995/09/06 22:37:47 russ Exp $ */
/*
 * (c) Copyright 1992-1995 North Valley Research, Inc.
 * 	All Rights Reserved
 *
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	extImageProto.h - public interface to external file protocol
 *
 * DESCRIPTION
 *	external file process - protocol management
 *
 * $Header: /usr/local/src/nvrToMIT/RCS/extImageProto.h,v 1.3 1995/09/06 22:37:47 russ Exp $
 */
#ifndef _EXTIMAGEPROTO_H_
#define _EXTIMAGEPROTO_H_

#define StartProto "NVR_START_PROTO"
#define EndProto   "NVR_END_PROTO"
#define EofProto   "NVR_EOF_PROTO"

#include "process.h"

typedef enum {
    XFP_Unknown,
    XFP_Type,
    XFP_Sample,
    XFP_Size,
    XFP_ColorSpace,
    XFP_ILayout,
    XFP_PLayout,
    XFP_LinePadding,
    XFP_LinesReversed,
    XFP_SubImageOrg,
    XFP_FrameCount,
    XFP_FramesPerSec
} ExtImageFileParam;


typedef struct {
    BufFileHndl fpData;
    BufFileHndl fpControl;
    BufFileHndl fpError;
    int pid;
}  ExtProcCtl, *ExtProcCtlPtr;
    
CExternal InternalReasonPtr ExtInitProto(ExtProcCtlPtr, Argvec *);
CExternal InternalReasonPtr ExtReadProto(BufFileHndl in, ExtImageInfoPtr);
CExternal InternalReasonPtr ExtContinueProto(ExtProcCtlPtr);
CExternal void ExtEndProto(ExtProcCtlPtr);

extern NameEnumPair ExtPixelLayoutNames[];
extern NameEnumPair ExtFileParamNames[];
extern NameEnumPair ExtPaddingNames[];
extern NameEnumPair ExtSubImageOrgNames[];
extern NameEnumPair ExtColorSpaceNames[];
extern NameEnumPair ExtSampleTypeNames[];
extern NameEnumPair ExtInterlaceLayoutNames[];
extern NameEnumPair ExtBooleanNames[];

#endif /* _EXTIMAGEPROTO_H_ */
