/*
 * (c) Copyright 1992, 1993 North Valley Research, Inc.
 * 	All Rights Reserved
 *
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	colorSpace.h - definitions for translating from Y/Cr/Cb to RGB
 *		       and back.
 *
 * DESCRIPTION
 *
 * $Header: /usr/local/src/nvrToMIT/RCS/colorSpace.h,v 1.1 1993/12/01 19:13:46 toddb Exp $
 */
#ifndef _COLORSPACE_H_
#define _COLORSPACE_H_
/*
 *	DEFINES
 */

/*
 * Constants for Ycrcb -> RGB conversion
 */
#define YcToRConst	222.922
#define YcToGConst	135.575
#define YcToBConst	276.836
#define YToRGBConst	1.16438
#define CrToRConst	1.59603
#define CbToBConst	2.01723
#define CbToGConst	0.391762
#define CrToGConst	0.812968

#define YCrCbToRed(y,cr,cb)	(- YcToRConst				\
				 + CrToRConst*((int)(cr))		\
				 + YToRGBConst*((int)(y)))
#define YCrCbToGreen(y,cr,cb)	(YcToGConst				\
				 - CbToGConst*((int)(cb))		\
				 - CrToGConst*((int)(cr))		\
				 + YToRGBConst*((int)(y)))
#define YCrCbToBlue(y,cr,cb)	(- YcToBConst				\
				 + CbToBConst*((int)(cb))		\
				 + YToRGBConst*((int)(y)))

#define ClampRgb(value)							\
    ((int)(value) & (~(0xff))						\
	? ((int)(value) < 0 ? 0 : 255)					\
	: (int)(value))

/*
 * Constants for RGB -> Ycrcb conversion
 */
#define RToYConst	0.256784
#define GToYConst	0.504118
#define BToYConst	0.0979215
#define RToCrConst	0.439216
#define GToCrConst	0.367176
#define BToCrConst	0.0720392
#define RToCbConst	0.1484705
#define GToCbConst	0.290745
#define BToCbConst	RToCrConst

#define RGBToY(r,g,b)		(RToYConst*((int)(r))			\
				 + GToYConst*((int)(g))			\
				 + BToYConst*((int)(b)) + 16)
#define RGBToCr(r,g,b)		(RToCrConst*((int)(r))			\
				 - GToCrConst*((int)(g))		\
				 - BToCrConst*((int)(b)) + 128)
#define RGBToCb(r,g,b)		(- RToCbConst*((int)(r))		\
				 - GToCbConst*((int)(g))		\
				 + BToCbConst*((int)(b)) + 128)
#define ClampYuv(value)		ClampRgb((value))
				 
/*
 *	TYPEDEFS
 */
/*
 *	EXTERNS
 */

#endif /* _COLORSPACE_H_ */
