/*
 * (c) Copyright 1992, 1993 North Valley Research, Inc.
 * 	All Rights Reserved
 *
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	<imageIo.h> - external functions listed for imageIo.c
 *
 * DESCRIPTION
 *	internal structures
 *
 * $Header: /usr/local/src/nvrToMIT/RCS/imageIoI.h,v 1.10 1995/10/23 17:43:29 russ Exp $
 */
#ifndef _IMAGEIO_H_
#define _IMAGEIO_H_

/*
 * XXX these shouldn't be here.  They should be functions pulled in
 * through a sub-op in
 * the same way that ImageIoTemplate pulls in the file operations.
 */
extern InternalReasonPtr C3FiltInit(ImageOpPtr, CompositeMemImagePtr);

extern InternalReasonPtr NvrYuvInit(ImageOpPtr, CompositeMemImagePtr);

extern InternalReasonPtr SgiRgbInit(ImageOpPtr, CompositeMemImagePtr);
extern InternalReasonPtr SgiRgbRead(ImageOpPtr,
                            CompositeMemImagePtr, CompositeMemImagePtr);
extern InternalReasonPtr SgiRgbFlush(ImageOpPtr,
                            CompositeMemImagePtr, CompositeMemImagePtr);
extern void SgiRgbFree(ImageOpPtr);

extern InternalReasonPtr AviRgbInit(ImageOpPtr, CompositeMemImagePtr);
extern InternalReasonPtr AviRgbRead(ImageOpPtr,
                            CompositeMemImagePtr, CompositeMemImagePtr);
extern InternalReasonPtr AviRgbFlush(ImageOpPtr,
                            CompositeMemImagePtr, CompositeMemImagePtr);
extern void AviRgbFree(ImageOpPtr);

extern InternalReasonPtr MbStatParse(PipelineNodePtr, StringArgListPtr *);
extern InternalReasonPtr MpegMbStatFlush(ImageOpPtr,
                            CompositeMemImagePtr, CompositeMemImagePtr);
extern InternalReasonPtr ReadMpegMbStats(ImageOpPtr,
                            CompositeMemImagePtr, CompositeMemImagePtr);
extern InternalReasonPtr MpegMbStatInit(ImageOpPtr, CompositeMemImagePtr);

extern InternalReasonPtr JmovieInit(ImageOpPtr, CompositeMemImagePtr);

extern InternalReasonPtr SunVideoInit(ImageOpPtr, CompositeMemImagePtr);

extern InternalReasonPtr SvjInit(ImageOpPtr, CompositeMemImagePtr);

extern InternalReasonPtr AlienInit(ImageOpPtr, CompositeMemImagePtr);
extern InternalReasonPtr AlienRead(ImageOpPtr,
                            CompositeMemImagePtr, CompositeMemImagePtr);
extern InternalReasonPtr AlienWrite(ImageOpPtr,
                            CompositeMemImagePtr, CompositeMemImagePtr);
extern InternalReasonPtr AlienFlush(ImageOpPtr,
                            CompositeMemImagePtr, CompositeMemImagePtr);
extern void AlienFree(ImageOpPtr);

extern InternalReasonPtr HungInit(ImageOpPtr, CompositeMemImagePtr);
extern InternalReasonPtr HungRead(ImageOpPtr,
                            CompositeMemImagePtr, CompositeMemImagePtr);
extern InternalReasonPtr HungWrite(ImageOpPtr,
                            CompositeMemImagePtr, CompositeMemImagePtr);

extern InternalReasonPtr MpegInit(ImageOpPtr, CompositeMemImagePtr);
extern InternalReasonPtr MpegProc(ImageOpPtr,
                            CompositeMemImagePtr, CompositeMemImagePtr);
extern InternalReasonPtr MpegFlush(ImageOpPtr,
                            CompositeMemImagePtr, CompositeMemImagePtr);
extern void MpegFree(ImageOpPtr);

extern InternalReasonPtr PixInit(ImageOpPtr, CompositeMemImagePtr);
extern InternalReasonPtr PixRead(ImageOpPtr,
                              CompositeMemImagePtr, CompositeMemImagePtr);

extern InternalReasonPtr QuickTimeInit(ImageOpPtr, CompositeMemImagePtr);

extern InternalReasonPtr SgiMovieInit(ImageOpPtr, CompositeMemImagePtr);

extern boolean SgiRgbInitHdr(char *buf, int bufSize, void *ptr, char *type);

extern InternalReasonPtr NvrExternInit(ImageOpPtr, CompositeMemImagePtr);
extern InternalReasonPtr GetNvrExternInfo(char *path, ImageFileInfoPtr);

extern void FileIoOpFree(ImageOpPtr);

#endif /* _IMAGEIO_H_ */
