/*
 * (c) Copyright 1992, 1993 North Valley Research, Inc.
 * 	All Rights Reserved
 *
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	<nvrQuickTime.h> - structures to support quicktime on the mac
 *
 * DESCRIPTION
 *	internal structures
 *
 * $Header: /usr/local/src/nvrToMIT/RCS/nvrQuickTime.h,v 1.4 1995/03/10 06:54:50 toddb Exp $
 */
#ifndef _NVRQUICKTIME_H_
#define _NVRQUICKTIME_H_

#include "nvrImageI.h"

#if defined(__MWERKS__) || defined(THINK_C)
#include <Movies.h>
#endif

typedef struct _vTrackStatistics {
    /*
     * Input values
     */
    long targetTrackNum;	/* try for the 'nth video track */
     
    /*
     * output values
     */
    float frameRate;
    long nVideoTracks;
    ColorSpace color;
    InterlaceLayoutType iLayout;/* describes interlacing for the frame */
    SampleType sample;
    long movieDuration;	/* duration of the movie */
    long trackDuration;	/* (computed) duration of the track */
    long trackStart;
    long minDuration;	/* minimum frame duration */
    long maxDuration;	/* maximum frame duration */
    long frameCount;
    long timeScale;
    short width;
    short height;
    short error;	/* error encountered */
} VTrackStatistics, *VTrackStatisticsPtr;

#if !defined(THINK_C) && !defined(__MWERKS__)
#define GetQuickTimeVInfo(path, VTrackStatisticsPtr, movieReturn) \
	NULL /* as no reason */
#endif

WhenDeclaringForMac(
    CExternal InternalReasonPtr GetQuickTimeVInfo(
        char *path,
        VTrackStatisticsPtr,
        Movie *movieReturn
    );
)

#endif /* _NVRQUICKTIME_H_ */

