/*
 * (c) Copyright 1992, 1993 North Valley Research, Inc.
 * 	All Rights Reserved
 *
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	sgilibimage.h - header for sgi rgb files
 *
 * $Header: /usr/local/src/nvrToMIT/RCS/sgilibimage.h,v 1.5 1994/06/18 06:08:14 toddb Exp $
 */
#ifndef	_SGILIBIMAGE_H_
#define	_SGILIBIMAGE_H_

/*
 *	Defines for image files . . . .
 *
 *  			Paul Haeberli - 1984
 *      Look in /usr/people/4Dgifts/iristools/imgtools for example code!
 *
 */

#if 0
#define IMAGIC 	0732
#endif /* 0 */
#define IMAGIC		((short)0x01da)
#define REV_IMAGIC	((short)0xda01)

/* colormap of images */
#define CM_NORMAL		0	/* file contains rows of values which 
					 * are either RGB values (zsize == 3) 
					 * or greyramp values (zsize == 1) */
#define CM_DITHERED		1
#define CM_SCREEN		2	/* file contains data which is a screen
					 * image; getrow returns buffer which 
					 * can be displayed directly with 
					 * writepixels */
#define CM_COLORMAP		3	/* a colormap file */

#define TYPEMASK		0xff00
#define BPPMASK			0x00ff
#define ITYPE_VERBATIM		0x0000
#define ITYPE_RLE		0x0100
#define ISRLE(type)		(((type) & 0xff00) == ITYPE_RLE)
#define ISVERBATIM(type)	(((type) & 0xff00) == ITYPE_VERBATIM)
#define BPP(type)		((type) & BPPMASK)
#define RLE(bpp)		(ITYPE_RLE | (bpp))
#define VERBATIM(bpp)		(ITYPE_VERBATIM | (bpp))
#if 0
#define	IBUFSIZE(pixels)	((pixels+(pixels>>6))<<2)
#else /* 0 */
#define	IBUFSIZE(pixels)	((pixels+(pixels>>6))*sizeof(long))
#endif /* 0 */
#define	RLE_NOP			0x00

#define	ierror(p)		(((p)->flags&_IOERR)!=0)
#define	ifileno(p)		((p)->file)
#define	getpix(p)		(--(p)->cnt>=0 ? *(p)->ptr++ : ifilbuf(p))
#define putpix(p,x)		(--(p)->cnt>=0 \
				    ? ((int)(*(p)->ptr++=(unsigned)(x))) \
				    : iflsbuf(p,(unsigned)(x)))

typedef struct _sgiRgbHeader {
    ULong       imagic:16;              /* stuff saved on disk . . */
    ULong       type:16;
    ULong       dim:16;
    ULong       xsize:16;
    ULong       ysize:16;
    ULong       zsize:16;
    ULong       min:32;
    ULong       max:32;
    ULong       wastebytes:32;
    char        name[80];
    ULong       colormap:32;
} SgiRgbHeader, *SgiRgbHeaderPtr;

typedef struct {
#if 0
    UShort	imagic;		/* stuff saved on disk . . */
    UShort 	type;
    UShort 	dim;
    UShort 	xsize;
    UShort 	ysize;
    UShort 	zsize;
    ULong 	min;
    ULong 	max;
    ULong	wastebytes;	
    char 	name[80];
    ULong	colormap;
#endif /* 0 */
    SgiRgbHeader	hdr;

    long 	file;		/* stuff used in core only */
    UShort 	flags;
    short	dorev;
    short	x;
    short	y;
    short	z;
    short	cnt;
    UShort	*ptr;
    UShort	*base;
    UShort	*tmpbuf;
    ULong	offset;
    ULong	rleend;		/* for rle images */
    ULong	*rowstart;	/* for rle images */
    long	*rowsize;	/* for rle images */
} SgiRgbImage, *SgiRgbImagePtr;

/*
 * SgiRgbImage *iopen(char *file, char *mode, unsigned int type, unsigned int dim,
 * 		unsigned int xsize, unsigned int ysize, unsigned int zsize);
 * SgiRgbImage *fiopen(int f, char *mode, unsigned int type, unsigned int dim,
 * 		unsigned int xsize, unsigned int ysize, unsigned int zsize);
 *
 * ...while iopen and fiopen can take an extended set of parameters, the 
 * last five are optional, so a more correct prototype would be:
 *
 * SgiRgbImage *iopen(char *file, char *mode, ...);
 * SgiRgbImage *fiopen(int f, char *mode, ...);
 * 
 * UShort *ibufalloc(SgiRgbImage *image);
 * int iflush(SgiRgbImage *image);
 * void isetcolormap(SgiRgbImage *image, int colormap);
 * 
 */
CExternal SgiRgbImage *imgopen(
    int,
    char *,
    char *,
    unsigned int,
    unsigned int,
    unsigned int,
    unsigned int,
    unsigned int
);

CExternal int iclose(
    SgiRgbImage *image
);

CExternal int putrow(
    SgiRgbImage *image,
    UShort *buffer,
    unsigned int y,
    unsigned int z
);

CExternal int getrow(
    SgiRgbImage *image,
    UShort *buffer,
    unsigned int y,
    unsigned int z
);

CExternal void cvtimage(
    long *
);

#endif /* _SGILIBIMAGE_H_ */
