/*
 *      (c) Copyright 1992 North Valley Research, Inc.
 *              All Rights Reserved
 *
 *      Confidential -- All proprietary rights reserved.
 *      Licensed Material -- Property of North Valley Research, Inc.
 *
 *      This program is the property of North Valley Research, Inc. or others
 *      from whom North Valley Research has obtained a licensing right, and is
 *      considered by North Valley Research to be confidential.  It is protected
 *      by U.S. copyright law as an unpublished work and is
 *      furnished pursuant to a written license agreement.  It may
 *      not be used, copied or otherwise reproduced, or disclosed to
 *      others except in accordance with the terms and conditions of
 *      that agreement.
 *
 *      NAME
 *              macImageDpyI.h
 *
 *      DESCRIPTION
 *              internal (mac) methods for displaying an image in a window
 *
 *      REVISION
 *              $Header: /usr/local/src/nvrToMIT/RCS/macImageDpyI.h,v 1.1 1995/03/10 07:18:34 toddb Exp $
 */

#ifndef MACIMAGEDPYI_H
#define MACIMAGEDPYI_H

#include "imageDpyI.h"

#include <QuickDraw.h>
#include <QDOffscreen.h>
#include <ToolUtils.h>
#include <Windows.h>

typedef struct _macImageRegion {
    CGrafPtr	win;
    PixMapPtr	pixmap;			/* offscreen pixmap */
    Rect	dstRect;		/* where in the window the image goes */
    RGBColor	white, black;
    CTabHandle	indexClut;
    CTabHandle	directClut;
    int		depth;
    GWorldPtr	gWorld;
    ULong	maxDirectConvertPix;	/* area thresh. for 2-stage convert */
} MacImageRegion, *MacImageRegionPtr;

#endif /* MACIMAGEDPYI_H */
