#!/bin/sh
#
# $Header: /usr/local/src/nvrToMIT/RCS/scaledither.awk,v 1.3 1994/05/11 18:00:54 toddb Exp $
#

awk '
BEGIN {
    yCoeff = 1.16438;
    dither[0]  =  1;    name[0]  = "D00";
    dither[1]  =  6;    name[1]  = "D01";
    dither[2]  = 13;    name[2]  = "D02";
    dither[3]  = 10;    name[3]  = "D03";
    dither[4]  = 12;    name[4]  = "D10";
    dither[5]  = 11;    name[5]  = "D11";
    dither[6]  =  0;    name[6]  = "D12";
    dither[7]  =  7;    name[7]  = "D13";
    dither[8]  =  2;    name[8]  = "D20";
    dither[9]  =  5;    name[9]  = "D21";
    dither[10] = 14;    name[10] = "D22";
    dither[11] =  9;    name[11] = "D23";
    dither[12] = 15;    name[12] = "D30";
    dither[13] =  8;    name[13] = "D31";
    dither[14] =  3;    name[14] = "D32";
    dither[15] =  4;    name[15] = "D33";
    
    rgbNames[0] = "RgbC555"; pixelSteps[0] = 5;
    rgbNames[1] = "RgbC666"; pixelSteps[1] = 6;
    rgbNames[2] = "Rgb555"; pixelSteps[2] = 32;
    rgbNames[3] = "Rgb444"; pixelSteps[3] = 16;
    rgbNames[4] = "Rgb888"; pixelSteps[4] = 64;
    rgbNames[5] = "Rgb232"; pixelSteps[5] = 8;
    rgbNames[6] = "Rgb332"; pixelSteps[6] = 8;

    for (j = 0; j <= 6; j++) {
        prefix = rgbNames[j];
        pixelStep = pixelSteps[j];
        ditherScale = (16.0 / pixelStep) / yCoeff;
        printf("/*\n");
        printf(" * %s: ditherScale = %f = (16/%d) / %f\n", \
            		prefix, ditherScale, pixelStep, yCoeff);
        printf(" */\n");
            
        for (i=0; i <=15; i++) {
            dValue = dither[i] * ditherScale + .5;
            printf("#define %s%s  %2d    ", prefix, name[i], dValue);
            printf("/* %2d * %f */\n", dither[i], ditherScale);
        }
	printf("\n");
	printf("#define Max%sDither\t%sD30\n", rgbNames[j], rgbNames[j]);
	printf("\n");
    }
}' < /dev/null
