/*
 *      (c) Copyright 1992 North Valley Research, Inc.
 *              All Rights Reserved
 *
 *      Confidential -- All proprietary rights reserved.
 *      Licensed Material -- Property of North Valley Research, Inc.
 *
 *      This program is the property of North Valley Research, Inc. or others
 *      from whom North Valley Research has obtained a licensing right, and is
 *      considered by North Valley Research to be confidential.  It is protected
 *      by U.S. copyright law as an unpublished work and is
 *      furnished pursuant to a written license agreement.  It may
 *      not be used, copied or otherwise reproduced, or disclosed to
 *      others except in accordance with the terms and conditions of
 *      that agreement.
 *
 *      NAME
 *              xImageDpyI.h
 *
 *      DESCRIPTION
 *              internal (x) methods for displaying an image in a window
 *
 *      REVISION
 *              $Header: /usr/local/src/nvrToMIT/RCS/xImageDpyI.h,v 1.4 1996/01/14 20:16:28 toddb Exp $
 */

#ifndef XIMAGEDPYI_H
#define XIMAGEDPYI_H

#include "imageDpyI.h"
#include "nvrAlloc.h"
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/extensions/XShm.h>
#include <sys/ipc.h>
#include <sys/shm.h>

typedef struct _xImageRegion {
    PrivImgDpyRegion super;
    struct {
        boolean useShm;
        XShmSegmentInfo *shmInfo;
    } shm;

    struct {
	int xOff;			/* offset into fp for window 0,0 */ 
	int yOff;			/* offset into fp for window 0,0 */ 
	int width;			/* frame buffer width */
	int height;			/* frame buffer height */
    } fb;

    struct {
	boolean fbDirect;		/* bypass X; go to framebuffer */
        Window win;			/* window extracted from widget */
	Display *dpy;			/* dpy extracted from widget */
	GC gc;				/* gc for the current window/depth */
        XImage *image;			/* image structure for current window */
	Visual *visual;			/* visual associate with the window */
        int depth;			/* depth for current window */
	int (*putImage)(Display *dpy, Drawable, GC, XImage *,
		        int src_x, int src_y, int dst_x, int dst_y,
		        unsigned int width, unsigned int height);
    } render;
} XImageRegion, *XImageRegionPtr;

#endif /* XIMAGEDPYI_H */
