/*
 * (c) Copyright 1992, 1993 North Valley Research, Inc.
 * 	All Rights Reserved
 *
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	jpegcompP.h - definitions private to the jpeg compressor/decompressor
 *
 * DESCRIPTION
 *	<overall description of what the header file does>
 *
 * $Header: /usr/local/src/nvrToMIT/RCS/jpegcompP.h,v 1.7 1993/01/13 22:33:06 toddb Exp $
 */
#ifndef _JPEGCOMP_P_H_
#define _JPEGCOMP_P_H_

#include "jpegcomp.h"
#include <stdio.h>

/*
 *	DEFINES
 */
#define STR_NATIVE	"native"
#define STR_FAST_X	"fastX"
#define STR_DIRECT	"direct"

#define STR_CAPTURE	"capture"
#define STR_PLAYBACK	"playback"

#define Initialized(server, mask) (((server)->assigned & (mask)) == (mask))

/*
 *	TYPEDEFS
 */
typedef struct {
    McsServerRec base;		/* base server information */

    union {
	McsJpegComp comp;	/* copy of the compressor parameters */
	McsJpegDecomp decomp;	/* copy of the decompressor parameters */
	McsJpegComp generic;	/* copy of the decompressor parameters */
    } u;
    ULong assigned;		/* values we have record of */
    ULong notFlushed;		/* values not yet set to server */
    TwoWayPipe io;		/* connection *to* the server */
    boolean compressor;		/* true if compressor, else decompressor */
    boolean stopSent;		/* true if explicit stop has been sent */
} McsJpegPriv, *McsJpegPrivPtr;

/*
 *	EXTERNS
 */

extern McsServerClassPtr JpegCompClass;
extern McsServerClassPtr JpegDecompClass;

#endif /* _JPEGCOMP_P_H_ */
