/*
 * (c) Copyright 1992, 1993 North Valley Research, Inc.
 * 	All Rights Reserved
 *
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	mpegcompP.h - top-level include file for server connections
 *
 * DESCRIPTION
 *	This is the the INTERNAL form of the data structures needed to
 *	fork off the filter/compressor program. It is NOT intended for
 *	use for the EXTERNAL interface (use mpegcomp.h for that).
 *
 * $Header: /usr/local/src/nvrToMIT/RCS/mpegcompP.h,v 1.10 1994/04/24 21:55:40 toddb Exp $
 */
#ifndef _MPEGCOMP_P_H_
#define _MPEGCOMP_P_H_

#include "mpegcomp.h"
#include "nvrBitTest.h"
/*
 *	DEFINES
 */

/*
 *	TYPEDEFS
 */
typedef struct {
	McsServerRec	base;		/* base server information */

	MpegCompParams	params;		/* copy of the non-default parameters */
	BitMask		paramMask;	/* bit mask of non-default parameters */
	TwoWayPipe	videoCompressor;
	ULong		terminationMethod;
	char		*outputFile;	/* File needs removing on TERM_IMMED */
	boolean		compressorIsStopped;
} McsMpegCompPriv;

/*
 *	EXTERNS
 */
#endif /* _MPEGCOMP_P_H_ */
