/*
 * (c) Copyright 1992-1995 North Valley Research, Inc.
 * 	All Rights Reserved
 *
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	NvrDisplay.h - public definitions for for nvr display widget
 *
 * $Header: /usr/local/src/nvrToMIT/RCS/NvrDisplay.h,v 1.10 1995/05/08 22:49:21 toddb Exp $
 */
#ifndef _NVRDISPLAY_H_
#define _NVRDISPLAY_H_

#include "nvrTypes.h"
#include "nvrReason.h"

#include <Intrinsic.h>
#include <Xm/Xm.h>

/* New resource definitions */

#define XnvrNexposeCallback     "exposeCallback"
#define XnvrCexposeCallback     "ExposeCallback"
#define XnvrNrealizeCallback    "realizeCallback"
#define XnvrCrealizeCallback    "RealizeCallback"

#define XnvrNhue		"hue"
#define XnvrChue		"Hue"
#define XnvrNmaxHue		"maxHue"
#define XnvrCmaxHue		"MaxHue"
#define XnvrNminHue		"minHue"
#define XnvrCminHue		"MinHue"
#define XnvrNnormalHue		"NormalHue"
#define XnvrCnormalHue		"NormalHue"
#define XnvrNsaturation		"saturation"
#define XnvrCsaturation		"Saturation"
#define XnvrNmaxSaturation	"maxSaturation"
#define XnvrCmaxSaturation	"MaxSaturation"
#define XnvrNminSaturation	"minSaturation"
#define XnvrCminSaturation	"MinSaturation"
#define XnvrNnormalSaturation	"normalSaturation"
#define XnvrCnormalSaturation	"NormalSaturation"
#define XnvrNbrightness		"brightness"
#define XnvrCbrightness		"Brightness"
#define XnvrNmaxBrightness	"maxBrightness"
#define XnvrCmaxBrightness	"MaxBrightness"
#define XnvrNminBrightness	"minBrightness"
#define XnvrCminBrightness	"MinBrightness"
#define XnvrNnormalBrightness	"normalBrightness"
#define XnvrCnormalBrightness	"NormalBrightness"
#define XnvrNcontrast		"contrast"
#define XnvrCcontrast		"Contrast"
#define XnvrNmaxContrast	"maxContrast"
#define XnvrCmaxContrast	"MaxContrast"
#define XnvrNminContrast	"minContrast"
#define XnvrCminContrast	"MinContrast"
#define XnvrNnormalContrast	"normalContrast"
#define XnvrCnormalContrast	"NormalContrast"

#define XnvrNresizeMode		"resizeMode"
#define XnvrCresizeMode		"ResizeMode"
#define XnvrNisEnabled		"isEnabled"
#define XnvrCisEnabled		"IsEnabled"
#define XnvrNisActive		"isActive"
#define XnvrCisActive		"IsActive"
#define XnvrNdisplayMode	"displayMode"
#define XnvrCdisplayMode	"DisplayMode"
#define XnvrNnumberOfPorts	"numberOfPorts"
#define XnvrCnumberOfPorts	"NumberOfPorts"
#define XnvrNportIndex		"portIndx"
#define XnvrCportIndex		"PortIndex"
#define XnvrNportNames		"portNames"
#define XnvrCportNames		"PortNames"
#define XnvrNengineCount	"engineCount"
#define XnvrCengineCount	"EngineCount"
#define XnvrNengine		"engine"
#define XnvrCengine		"Engine"
#define XnvrNconfigCallback	"configCallback"
#define XnvrCConfigCallback	"ConfigCallback"
#define XnvrNreasonCallback	"reasonCallback"
#define XnvrCReasonCallback	"ReasonCallback"
#define XnvrNdisplayType	"displayType"
#define XnvrCDisplayType	"DisplayType"

/*
 * Abstractions of the various widget types
 */
typedef enum {
    /*
     * Masks for various parts of the value
     */
    XnvrDisplayMask	= 0x00f,
    XnvrVendorMask	= 0x0f0,

    /*
     * general types
     */
    XnvrUnknownDpy	= 0x000,
    XnvrHwVideo		= 0x001,
    XnvrHwJpeg		= 0x002,
    XnvrHwMpeg		= 0x003,
    XnvrSoftDisplay	= 0x004,

    /*
     * vendor-specific types
     */
    XnvrSgiVideo	= 0x011,
    XnvrSgiJpeg		= 0x012,
    XnvrSunVideo	= 0x021,
    XnvrPlxVideo	= 0x031,
    XnvrPlxJpeg		= 0x032
} XnvrDisplayType;

/* Default resource Values */

typedef enum {
    XnvrResizeModeScale      = 0,
    XnvrResizeModeScale4to3  = 1,
    XnvrResizeModeClipAndPan = 2,
    XnvrDefaultResizeMode    = XnvrResizeModeScale
} XnvrResizeMode;

#define XnvrDefaultIsActive False
#define XnvrDefaultFullMotion True

extern WidgetClass xnvrDisplayWidgetClass;

typedef struct _XnvrDisplayClassRec	*XnvrDisplayWidgetClass;
typedef struct _XnvrDisplayRec		*XnvrDisplayWidget;

CExternal Widget CreateDisplayWidget(
    char *name,
    Widget parent,
    XnvrDisplayType,
    ArgList args,
    int nArgs,
    InternalReasonPtr *pReason
);

#endif /* _NVRDISPLAY_H_ */
