/*
 * (c) Copyright 1992-1995 North Valley Research, Inc.
 * 	All Rights Reserved
 *
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	NvrDisplayP.h - private defs for nvr display widget
 *
 * $Header: /usr/local/src/nvrToMIT/RCS/NvrDisplayP.h,v 1.9 1995/05/08 22:49:21 toddb Exp $
 */
#ifndef _NvrDisplayP_h_
#define _NvrDisplayP_h_

#include "NvrDisplay.h"
#include <Xm/XmP.h>

/* Types for class methods */

typedef void (*XnvrRenderProc)(XnvrDisplayWidget);
typedef void (*XnvrUpdateDisplayProc)(XnvrDisplayWidget, XnvrRenderProc);
typedef void (*XnvrPanDisplayProc)(XnvrDisplayWidget, XEvent *, XnvrRenderProc);

#define XnvrInheritUpdateDisplay ((XnvrUpdateDisplayProc) _XtInherit)
#define XnvrInheritRenderDisplay ((XnvrRenderProc) _XtInherit)
#define XnvrInheritPanDisplay ((XnvrPanDisplayProc) _XtInherit)

/* The class definition for the NvrDisplay Widget */
typedef struct _XnvrDisplayClassPart
{
    XnvrUpdateDisplayProc updateDisplay;
    XnvrRenderProc        renderDisplay;
    XnvrPanDisplayProc    panDisplay;
    XtPointer	          extension;
} XnvrDisplayClassPart;

typedef struct _XnvrDisplayClassRec
{
    CoreClassPart		core_class;
    XnvrDisplayClassPart	nvrDisplay_class;
} XnvrDisplayClassRec;

extern XnvrDisplayClassRec xnvrDisplayClassRec;

/* Instance record for the NvrDisplay Widget */
typedef struct _XnvrDisplayPart
{
    /* resource variables */
    int type;			/* should be a XnvrDisplayType */
    XtCallbackList exposeCallback;
    XtCallbackList realizeCallback;
    XtCallbackList reasonCallback;
    struct {
	int count;
	int min;
	int cur;
	int norm;
    } hue, sat, bright, contrast;
    int resizeMode;
    int displayMode;		/* mode flag -- startup only */
    Boolean isActive;		/* start or stop video display */
    Boolean isEnabled;		/* whether video engine is running */
    Boolean fullMotion;
    int n_ports;
    int port_index;
    char **portNames;
    int n_engines;
    int engine;
    Visual *visual;

    /* vars for performing the rendering operation */
    int src_x;			/* the location of the current video picture */
    int src_y;
    int src_width;
    int src_height;
    int dest_x;			/* the destination for the video image */
    int dest_y;
    int dest_width;
    int dest_height;

    /* misc internal variables */
    GC renderGC;
    Bool alreadyRedisplayed;
} XnvrDisplayPart;

typedef struct _XnvrDisplayRec
{
    CorePart		core;
    XnvrDisplayPart	nvrDisplay;
} XnvrDisplayRec;

#endif /* _NvrDisplayP_h_ */
