/*
 * (c) Copyright 1992-1995 North Valley Research, Inc.
 * 	All Rights Reserved
 *
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	SgiDisplayP.h - private defs for sgi display
 *
 * $Header: /usr/local/src/nvrToMIT/RCS/SgiDisplayP.h,v 1.2 1995/02/07 21:40:17 toddb Exp $
 */

#ifndef _SgiDisplayP_h_
#define _SgiDisplayP_h_

#include "SgiDisplay.h"
#include "NvrDisplayP.h"

#include <vl/vl.h>

/* The class definition for the SgiDisplay Widget */
typedef struct _XsgiDisplayClassPart
{
    XtPointer extension;
} XsgiDisplayClassPart;

typedef struct _XsgiDisplayClassRec
{
    CoreClassPart	 core_class;
    XnvrDisplayClassPart nvrDisplay_class;
    XsgiDisplayClassPart sgiDisplay_class;
} XsgiDisplayClassRec;

extern XsgiDisplayClassRec xsgiDisplayClassRec;

/* Instance record for the SgiDisplay Widget */
typedef struct _XsgiDisplayPart
{
    /* resource variables */
    XtCallbackList deactivateCBL;   /* callbacks to be called when the widget
				     * is overridden
				     */

    Bool firstRedisplay;
    VLServer svr;
    VLNode src;
    VLNode drn;
    VLPath path;

    /* the size of the incoming video image */
    int xIn;
    int yIn;
    int widthIn;
    int heightIn;
} XsgiDisplayPart;

typedef struct _XsgiDisplayRec
{
    CorePart		core;
    XnvrDisplayPart	nvrDisplay;
    XsgiDisplayPart	sgiDisplay;
} XsgiDisplayRec;

#endif /* _SgiDisplayP_h_ */
