/*
 * (c) Copyright 1992, 1993, 1994 North Valley Research, Inc.
 * 	All Rights Reserved
 *
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	WidgetFile.h - Widget file selection utils
 *
 * $Header: /usr/local/src/nvrToMIT/RCS/WidgetFile.h,v 1.4 1995/06/30 18:36:25 toddb Exp $
 */
#ifndef _WIDGETFILE_H_
#define _WIDGETFILE_H_

#include "nvrTypes.h"
#include <Intrinsic.h>
#include <Xm/FileSB.h>

enum {
    kSelectNewFile      = 0x1,
    kSelectExistingFile = 0x2
};

CExternal void StdFileSearchForFsb(
    Widget fs,
    XmFileSelectionBoxCallbackStruct *cbs, 
    boolean (*fileFilter)(char *path, void *userCriterion),
    void *userCriterion
);

CExternal char *StdGetFsbFile(
    Widget fs,
    int targetTypeMask,		/* ala fileAccess.h */
    Boolean newFile
);

CExternal char *StdSelectFile(
    Widget w,
    char *name,
    char *winTitle,
    int selectMask	/* selected from kSelectNewFile, kSelectExistingFile */
);

#endif /* _WIDGETFILE_H_ */
