/*
 * (c) Copyright 1992-1995 North Valley Research, Inc.
 * 	All Rights Reserved
 *
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	deckPlayerI.h - deck internal structures, declarations
 *
 * $Header: /usr/local/src/nvrToMIT/RCS/deckPlayerI.h,v 1.5 1995/06/19 19:35:54 toddb Exp $
 */
#ifndef _DECKPLAYERI_H_
#define _DECKPLAYERI_H_

#include "PlayerCntl.h"
#include "nvrDeckCntlI.h"

/*
 * used in PlayerClass->magic
 */
#define DeckMagicNameDef	"deck player"

#define MaxPathLength	256

typedef struct _deckPlayerInfo {
    Widget control;			/* deck control dialog */
    Widget stripe;			/* deck striping dialog */
    long playIncrement;         	/* +/- frame increment */
    void (*playerNotify)(PlayerClass, ULong changed);/* notify PlayerClass */
    void (*controlNotify)(PlayerClass, ULong changed); /* notify control dlog */
    void (*stripeNotify)(PlayerClass, ULong changed); /* notify stripe dlog */
    DeckCntlPtr deck;			/* the actual deck */
    int segmentNum;			/* next untitled segment number */
    boolean validating;			/* true if validation running */
    RecordType recordType;		/* internally selected record type */
} DeckPlayerInfo, *DeckPlayerInfoPtr;

extern char *DeckMagicName;

CExternal void DeckPlayerChanged(DeckCntlPtr, void *cbData);
CExternal void PopupDeckControl(PlayerClass player);
CExternal void PopupDeckStriper(Widget w, DeckPlayerInfoPtr deckUI);
CExternal DeckConfigPtr PopupDeckSelectConf(Widget, DeckMedium, ULong ability,
					    InternalReasonPtr *pReason);

#endif /* _DECKPLAYERI_H_ */
