/*
 * Copyright (c) 1992,1993,1994 North Valley Research, Inc.
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	mpeg1vdct.c - block-dct level processing for mpeg video
 *
 * $Header: /usr/local/src/nvrToMIT/RCS/mpeg1vdct.c,v 1.7 1995/08/27 20:20:30 toddb Exp $
 */

#include "mpeg1vdecI.h"
#include "nvrAlloc.h"

InternalReasonPtr
Mpeg1VDctProcess(PacketLayerPtr vdecPub)
{
    Mpeg1VDecPrivPtr vdec = (Mpeg1VDecPrivPtr)vdecPub;
    IdctParamPtr idctp = vdec->slice.idct;

    if ((vdec->cb.select & Mpeg1VDecodeStartMask)
     && idctp->nextMbAddr == 0) {
	vdec->cb.arg.image = &vdec->currentPict->image->pub;
        (*vdec->cb.tokenCb)(&vdec->pub, Mpeg1VDecodeStartCb, &vdec->cb.arg);
    }
    
    (*idctp->inverseDct)(idctp);

    /*
     * See if all processing is done.
     */
    if (idctp->arenaQ == NULL) {
        if (vdec->cb.select & Mpeg1VDecodeEndMask) {
	    vdec->cb.arg.image = &vdec->currentPict->image->pub;
            DebugTask(VMD_DecodeCb,
		Msg("decode %2d\n", vdec->cb.arg.image->frame))
            (*vdec->cb.tokenCb)(&vdec->pub, Mpeg1VDecodeEndCb, &vdec->cb.arg);
	}

        vdec->pub.ops.process = vdec->ops.startCodeProcess;
    }
    
    return(NULL);
}
