/*
 * Copyright (c) 1992,1993,1994 North Valley Research, Inc.
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	mpeg1vsyntax.h - macro and function declaration for syntax checking
 *
 * $Header: /usr/local/src/nvrToMIT/RCS/mpeg1vsyntax.h,v 1.8 1995/10/15 23:54:28 toddb Exp $
 */

#ifndef MPEG1SYNTAX_H
#define MPEG1SYNTAX_H

#ifdef CheckMpeg1VSyntax

CExternal InternalReasonPtr CheckMbAddr(
    Mpeg1VDecPrivPtr,
    int bitLength,
    int inc
);

CExternal InternalReasonPtr CheckPicExtStartCode(Mpeg1VDecPrivPtr, UChar *pSrc);
CExternal InternalReasonPtr CheckGopExtStartCode(Mpeg1VDecPrivPtr, UChar *pSrc);
CExternal InternalReasonPtr CheckSeqExtStartCode(Mpeg1VDecPrivPtr, UChar *pSrc);
CExternal InternalReasonPtr CheckGopHdr(Mpeg1VDecPrivPtr vdec);
CExternal InternalReasonPtr CheckCurPicHeader(Mpeg1VDecPrivPtr vdec);
CExternal InternalReasonPtr CheckSliceAddr(Mpeg1VDecPrivPtr vdec);
CExternal InternalReasonPtr CheckMbType(Mpeg1VDecPrivPtr vdec, int bitLength);
CExternal InternalReasonPtr CheckDctIndex(Mpeg1VDecPrivPtr vdec, int dctIndex);
CExternal InternalReasonPtr CheckSliceQuantizer(Mpeg1VDecPrivPtr vdec);
CExternal InternalReasonPtr CheckMotion(Mpeg1VDecPrivPtr, DctMacroblockPtr);
CExternal InternalReasonPtr CheckEndOfSlice(
    Mpeg1VDecPrivPtr vdec, UChar *pSrc, int nCacheBits);

#else /* CheckMpeg1VSyntax */

#define CheckMbAddr(_vdec, _bitLength, _inc)		NULL
#define CheckSliceAddr(_vdec)				NULL
#define CheckPicExtStartCode(_vdec, _pSrc)		NULL
#define CheckGopExtStartCode(_vdec, _pSrc)		NULL
#define CheckSeqExtStartCode(_vdec, _pSrc)		NULL
#define CheckMbType(_vdec, _bitLength)			NULL
#define CheckDctIndex(_vdec, _dctIndex)			NULL
#define CheckSliceQuantizer(_vdec)			NULL
#define CheckMotion(_vdec, _idctMb)			NULL
#define CheckEndOfSlice(_vdec, _pSrc, _nCacheBits)	NULL
#define CheckGopHdr(_vdec)				NULL
#define CheckCurPicHeader(_vdec)			NULL

#endif /* CheckMpeg1VSyntax */

#endif /* MPEG1SYNTAX_H */
