/*
 *	(c) Copyright 1992,1993,1994 North Valley Research, Inc.
 *		All Rights Reserved
 *
 *	Confidential -- All proprietary rights reserved.
 *	Licensed Material -- Property of North Valley Research, Inc.
 *
 *	This program is the property of North Valley Research, Inc. or others
 *	from whom North Valley Research has obtained a licensing right, and is
 *	considered by North Valley Research to be confidential.  It is protected
 *	by U.S. copyright law as an unpublished work and is
 *	furnished pursuant to a written license agreement.  It may
 *	not be used, copied or otherwise reproduced, or disclosed to
 *	others except in accordance with the terms and conditions of
 *	that agreement.
 *
 *	NAME
 *		mpegtransit.c - transit function for mpeg scheduler
 *
 *	REVISION
 *		$Header: /usr/local/src/nvrToMIT/RCS/mpegtransit.c,v 1.3 1995/11/01 02:34:40 toddb Exp $
 */
#include "mpegschedI.h"

void
MpegSchedPreconfigTransit(MpegSchedPrivPtr msp)
{
    MpegSchedFlushCommands(msp);
    
    if (msp->input.configMask & MSM_Callback) {
        msp->cb.arg.reason =
            BadValueReason("MPEG scheduler not fully configured\n");
        (*msp->cb.cb)(&msp->pub, &msp->cb.arg, MSCB_Reason);
    }
}

void
MpegSchedTransit(MpegSchedPrivPtr msp)
{
    SchedCommand cmd;
    
    if (msp->sched.pending || QueueEmpty(&msp->sched.cmdq))
        return;

    cmd = TailOfQueue(&msp->sched.cmdq, SchedCommand);
    RemoveQueueTail(&msp->sched.cmdq);
    
    switch (cmd) {
    case kPlayFwd:
    case kPlayBak:
    case kFastFwd:
    case kFastBak:
    case kStepFwd:
    case kStepBak:
    case kStop:
    case kSeek:
        break;
    }
}
