/*
 *      (c) Copyright 1992,1993,1994 North Valley Research, Inc.
 *              All Rights Reserved
 *
 *      Confidential -- All proprietary rights reserved.
 *      Licensed Material -- Property of North Valley Research, Inc.
 *
 *      This program is the property of North Valley Research, Inc. or others
 *      from whom North Valley Research has obtained a licensing right, and is
 *      considered by North Valley Research to be confidential.  It is protected
 *      by U.S. copyright law as an unpublished work and is
 *      furnished pursuant to a written license agreement.  It may
 *      not be used, copied or otherwise reproduced, or disclosed to
 *      others except in accordance with the terms and conditions of
 *      that agreement.
 *
 *      NAME
 *              schedStat.h - scheduler statistics definitions
 *
 *      REVISION
 *              $Header: /nvr/share/src/nvr/prod/library/mpegsched/RCS/mpegsched
I.h,v 1.7 1995/12/24 07:04:29 toddb Exp toddb $
 */
#ifndef _SCHEDSTAT_H
#define _SCHEDSTAT_H

#include "nvrTypes.h"

typedef enum {
    SR_record = 1,
    SR_sequence,
    SR_balance
} SRType;

typedef struct _schedRecord {
    SRType type;
    long time;			/* time for this record */
    short pictLate;		/* relative lateness of pictOut, if any */
    UShort pictInCost;		/* cost for picture processing */
    UShort pictOutCost;		/* cost for picture processing */
    UShort auCost;		/* cost for audio processing */
    UChar pictIn;		/* pictures in for this period */
    UChar pictOut;		/* pictures out for this period */
    UChar auIn;			/* audio frames in for this period */
    UChar auOut;		/* audio frames in for this period */
} SchedRecord, *SchedRecordPtr;

typedef struct _schedSequence {
    SRType type;
    UChar channels;
    short width, height;
    float fps;
    float msPerAFrame;
    long sample;
} SchedSequence, *SchedSequencePtr;

typedef struct _schedBalance {
    SRType type;
    long time;			/* time for this record */
    short qSize;		/* number of pictures queued */
    short dropped;		/* # of pictures dropped by balancing */
    float vinWeight;		/* new weighting for video in */
    float videoFrac;		/* allocated cpu frac for video i/o */
    float audioFrac;		/* allocated cpu for audio */
    float targetFps;		/* target video frame rate */
} SchedBalance, *SchedBalancePtr;

typedef union _schedAny {
    SRType type;
    SchedSequence seq;
    SchedRecord rec;
    SchedBalance bal;
} SchedAny, *SchedAnyPtr;

#endif /* _SCHEDSTAT_H */

