/*
 * (c) Copyright 1992, 1993, 1994 North Valley Research, Inc.
 * 	All Rights Reserved
 *
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	fsPacket.h - public interface for file system packet-level transport
 *
 * $Header: /usr/local/src/nvrToMIT/RCS/fsPacket.h,v 1.4 1995/04/04 12:20:55 toddb Exp $
 */
#ifndef _FSPACKET_H_
#define _FSPACKET_H_

#include "nvrPacket.h"

typedef enum {
    FsAllPackets,
    NumFsPacketTypes
} FsPacketType;

typedef struct _fsPacketConf {
    char *file;			/* pathname to open */
    long packetSize;		/* requested packet size */
    void (*warning)(char *fmt, ...);
} FsPacketConf, *FsPacketConfPtr;

/*
 * These are the physical (file system; hence, "fs") layer packet
 * entry points.
 */
CExternal PacketLayerPtr OpenFsPacket(
    FsPacketConfPtr, 
    InternalReasonPtr *
);

#endif /* _FSPACKET_H_ */
