/*
 * (c) Copyright 1992, 1993, 1994 North Valley Research, Inc.
 * 	All Rights Reserved
 *
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	mpeg1PacketI.h - internal headers to describe mpeg system syntax
 *
 * $Header: /usr/local/src/nvrToMIT/RCS/mpeg1PacketI.h,v 1.14 1995/12/29 18:53:56 toddb Exp $
 */
#ifndef _MPEG1PACKETI_H_
#define _MPEG1PACKETI_H_

#include "nvrPacketI.h"
#include "mpeg1Packet.h"

/*************************************************************************
 *
 * The following are used to store the system stream packet state.
 * (this is what goes on the layer->priv pointer)
 *
 *************************************************************************/
typedef enum {
    MT_StartCodeSearch1,	/* looking for a pack start code */
    MT_StartCodeSearchSeek,	/* looking for a pack start code after seek */
    MT_StartCodeSearch2,	/* looking for pack, sys, packet start code */
    MT_StartCodeSearch3,	/* looking for pack or packet start code */
    MT_PackHdr,
    MT_SysHeader,
    MT_StreamId,
    MT_PacketHdr,
    MT_PacketBranch1,		/* decide on stuff, buffer or pts/dts */
    MT_PacketBranch2,		/* decide on buffer or pts/dts */
    MT_PacketBranch3,		/* decide which pts/dts */
    MT_BufferSize,
    MT_Pts,
    MT_PtsDts,
    MT_PacketData
} MpegToken;

typedef struct _mpeg1Priv {
    PacketLayer pub;
    ULong errorCount;		/* number of parsing errors */
    MpegToken curToken;        	/* current token being parsed */
    short tokenOff;            	/* current byte offset into token */
    ULong pos;			/* stream relative position */
    ULong startCode;       	/* current start code */
    BitMask streams;		/* available streams */
    Mpeg1MuxCbInfo cb;
    int nAllocIds;		/* alloc len of cb.packet.idList */
    int curId;                 	/* current id being parsed */
    StreamId idOverflow;	/* used when too many ids appear */
    void (*warning)(char *fmt, ...);
    void (*tokenCb)(PacketLayerPtr, Mpeg1CbType, Mpeg1MuxCbInfoPtr);
    void *cbData;
    ULong cbSelect;		/* selection of (1<<Mpeg1CbType) bits */
    ULong streamPos[ 128 ];	/* positions for each stream */
    long timecode[ 128 ];	/* last known pts for each stream */
    char *tokenSize;		/* copy of a static pointer for speed */
    char **tokenNames;		/* copy of a static pointer for speed */
} Mpeg1Priv, *Mpeg1PrivPtr;

CExternal InternalReasonPtr AllocMpeg1IdList(Mpeg1PrivPtr priv);

#endif /* _MPEG1PACKETI_H_ */
