/* $Header: /usr/local/src/nvrToMIT/RCS/netPacket.h,v 1.1 1995/05/20 13:20:24 russ Exp $ */
/*
 * (c) Copyright 1992, 1993, 1994 North Valley Research, Inc.
 * 	All Rights Reserved
 *
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	netPacket.h - public interface for file system packet-level transport
 *
 * $Header: /usr/local/src/nvrToMIT/RCS/netPacket.h,v 1.1 1995/05/20 13:20:24 russ Exp $
 */
#ifndef _NETPACKET_H_
#define _NETPACKET_H_

#include "nvrPacket.h"

typedef enum {
    NetAllPackets,
    NumNetPacketTypes
} NetPacketType;

typedef struct _netPacketConf {
    char *source;		/* source to open */
    long packetSize;		/* requested packet size */
    void (*warning)(char *fmt, ...);
} NetPacketConf, *NetPacketConfPtr;

/*
 * These are the physical (file system; hence, "net") layer packet
 * entry points.
 */
CExternal PacketLayerPtr OpenNetPacket(
    NetPacketConfPtr, 
    InternalReasonPtr *
);

#endif /* _NETPACKET_H_ */
