/*
 * (c) Copyright 1992, 1993, 1994 North Valley Research, Inc.
 * 	All Rights Reserved
 *
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	nvrPacketI.h - private data structures for packet interface
 *
 * $Header: /usr/local/src/nvrToMIT/RCS/nvrPacketI.h,v 1.9 1995/10/02 04:56:29 toddb Exp $
 */
#ifndef _NVRPACKETI_H_
#define _NVRPACKETI_H_

#include "nvrPacket.h"
#include "nvrBitTest.h"
#include "nvrDebug.h"

typedef enum {
    PD_discard = DBI_Packet,
    PD_queue
} PacketDebugSymbols;

typedef struct _packetInterest PacketInterest;
struct _packetInterest {
    PacketInterestPtr next;	/* must be first; pointer to next in list */
    PacketLayerPtr pLayer;	/* the layer above thats interested */
    BitMask mask;		/* mask of layer-specific interest bits */
}; /* typedef: PacketInterest, *PacketInterestPtr */
    
CExternal PacketDataPtr AllocPacket(
    PacketDataPtr *freeList,
    long dataSize
);

CExternal void RemovePacket(
    PacketDataPtr *queueList,
    PacketDataPtr packet
);

CExternal void QueuePacket(
    PacketDataPtr *queueList,
    PacketDataPtr new
);

CExternal void FreePacketList(
    PacketDataPtr *packetList
);

CExternal PacketLayerPtr AllocPacketLayer(
    PacketLayerType type,
    PacketLayerPtr nextLayer,
    long privSize
);

CExternal InternalReasonPtr DeliverLayersAbove(
    PacketLayerPtr pLayer,
    PacketDataPtr packet
);

CExternal void MarkEofInLayersAbove(
    PacketLayerPtr pLayer,
    boolean eof
);

CExternal InternalReasonPtr RegisterPacketInterest(
    PacketLayerPtr pLayer,
    BitMaskPtr mask
);

CExternal void DiscardQueuedPackets(
    PacketLayerPtr pLayer
);

CExternal ULong InternalPacketSeek(
    PacketLayerPtr pLayer, 
    ULong absOffset
);

CExternal PacketDataPtr AlignPacket(
    PacketDataPtr,
    PacketDataPtr *freeList,
    InternalReasonPtr *
);

#endif /* _NVRPACKETI_H_ */
