/*
 * Copyright (c) 1992, 1993, 1994 North Valley Research, Inc.
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	testPacket.c - tester for packet interface
 *
 * $Header: /usr/local/src/nvrToMIT/RCS/testPacket.c,v 1.1 1995/02/12 19:50:13 toddb Exp $
 */

#include "nvrTypes.h"
#include "nvrDebug.h"
#include "nvrPacket.h"
#include "fsPacket.h"

#ifdef DEBUG_ENABLED

extern FlagNames PacketDebugNames;
extern FlagMacroList PacketDebugMacros;

FlagLabels DebugFlagDesc[] = {
    { &PacketDebugNames, &PacketDebugMacros },
    { NULL },
};

#else /* DEBUG_ENABLED */

FlagLabels DebugFlagDesc[1];

#endif /* DEBUG_ENABLED */

char *ProgramName;

main(int argc, char **argv)
{
    PacketLayerPtr fs;
    FsPacketConf fsConf;
    InternalReasonPtr reason;
    char *input = NULL;

    for (argc--, argv++; argc; argc--, argv++) {
	if (input == NULL)
	    input = *argv;
	else
	    Fatal("input specified twice: %s\n", *argv);
    }

    fsConf.file = input;
    fsConf.forWriting = False;
    fs = OpenFsPacket(&fsConf, &reason);
    if (fs == NULL) {
	ShowReason(Msg, reason);
	exit (0);
    }
    (*fs->close)(fs);
}
