/*
 * (c) Copyright 1992, 1993, 1994 North Valley Research, Inc.
 * 	All Rights Reserved
 *
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	cdPacket.h - public interface for video CD sector parser
 *
 * $Header: /usr/local/src/nvrToMIT/RCS/vcdPacket.h,v 1.3 1995/02/28 04:40:09 toddb Exp $
 */
#ifndef _VCDPACKET_H_
#define _VCDPACKET_H_

#include "nvrPacket.h"

#define CdSectorDataSize       2336
#define CdPacketDataSize       2324

#define VcdNormResVideoId	0xe1
#define VcdHighResVideoId	0xe2
#define VcdNormResVideoId	0xe1

/*
 * These are the cd  subheader bits for CD-i and Video CD
 */
typedef enum {
    CDS_Eof		= 0x80,
    CDS_RealTime	= 0x40,
    CDS_Form		= 0x20,
    CDS_Trigger		= 0x10,
    CDS_Data		= 0x08,
    CDS_Audio		= 0x04,
    CDS_Video		= 0x02,
    CDS_EOR		= 0x01
} CDSubmodeBits;

/*
 * This structure can be overlayed on the packet data to
 * see the structure of the cd sector.
 */
typedef struct _cdSubSector {
    /*
     * These give three identical view of the submode
     */
    union {
	struct {
	    UChar fileNum;
	    UChar chanNum;
	    UChar subMode;
	    UChar codingInfo;
	} s;	/* "s" for "struct" */
	struct {
	    ULong fileNum:8;
	    ULong chanNum:8;
	    ULong eof:1;
	    ULong rt:1;
	    ULong form:1;
	    ULong trigger:1;
	    ULong data:1;
	    ULong audio:1;
	    ULong video:1;
	    ULong eor:1;
	    ULong codingInfo:8;
	} b;	/* "b" for "bits" */
	ULong c; /* "c" for "composite" */
    } subHeader, subHeaderCopy;
    UChar sector[ CdPacketDataSize ];
    UChar edc[ 4 ];
} CdSubSector, *CdSubSectorPtr;

typedef enum {
    CdVideoSector,
    CdAudioSector,
    CdDataSector,
    CdPadSector,
    NumCdSectorTypes
} CdSectorType;

typedef struct _vcdPacketConf {
    void (*sectorCb)(PacketLayerPtr, PacketDataPtr, void *cdxaCbData);
    void *sectorCbData;
    void (*warning)(char *fmt, ...);
} CdPacketConf, *CdPacketConfPtr;

CExternal PacketLayerPtr OpenCdPacket(
    CdPacketConfPtr conf,
    PacketLayerPtr next, 
    InternalReasonPtr *pReason
);

#endif /* _VCDPACKET_H_ */
