/* $Header: /usr/local/src/nvrToMIT/RCS/XPlxProtos.h,v 1.2 1994/08/27 22:51:11 drapeau Exp $ */
/*
 *   Copyright (c) 1994 by
 *   PARALLAX GRAPHICS, INCORPORATED, Santa Clara, California.
 *   All rights reserved
 *
 *   This software is furnished on an as-is basis, and may be used and copied
 *   only with the inclusion of the above copyright notice.
 *
 *   The information in this software is subject to change without notice.
 *   No committment is made as to the usability or reliability of this
 *   software.
 *
 *   Parallax Graphics, Inc.
 *   2500 Condensa Street
 *   Santa Clara, California  95051
 *   Author: George Drapeau
 */
/* $Log: XPlxProtos.h,v $
 * Revision 1.2  1994/08/27  22:51:11  drapeau
 * Repaired an errant function prototype for XPlxVideoInput().
 *
 * Revision 1.1  1994/08/27  05:14:03  drapeau
 * Initial revision
 * */

#ifndef _XPlxProtosHeader_
#define _XPlxProtosHeader_

#if NeedFunctionPrototypes

Bool		XPlxFindMatchingSignal(plx_IO*	plxIO,
				       int	channel,
				       int	standard,
				       int	format,
				       int	instance);

plx_IO*		XPlxQueryConfig(register Display*	dpy,
				Drawable		d,
				GC			gc);

plx_signal*	XPlxQueryVideo(register Display*	dpy,
			       Drawable			d,
			       GC			gc);

void		XPlxVideoOutput(register Display*	dpy,
				Drawable		d,
				GC			gc,
				int			vx,
				int			vy,
				int			x,
				int			y,
				int			w,
				int			h);

void		XPlxVideoScaleOutput(register Display*	dpy,
				     Drawable		d,
				     GC			gc,
				     int		vx,
				     int		vy,
				     int		vw,
				     int		vh,
				     int		x,
				     int		y,
				     int		w,
				     int		h);

void		XPlxVideoTag(register Display*		dpy,
			     Drawable			d,
			     GC				gc,
			     int			type);

void		XPlxVideoInputSelect(register Display*	dpy,
				     Drawable		d,
				     GC			gc,
				     int		channel,
				     int		standard,
				     int		format,
				     int		type);

void		XPlxVideoOutputSelect(register Display*	dpy,
				      Drawable		d,
				      GC		gc,
				      int		channel,
				      int		standard,
				      int		format,
				      int		type);

void		XPlxVideoValueLoad(register Display*	dpy,
				   Drawable		d,
				   GC			gc,
				   int			sat,
				   int			cont,
				   int			hue,
				   int			brit);

void		XPlxVideoValueQuery(register Display*	dpy,
				    Drawable		d,
				    GC			gc,
				    int*		sat,
				    int*		cont,
				    int*		hue,
				    int*		brit);

void		XPlxVideoValueSave(register Display*	dpy,
				   Drawable		d,
				   GC			gc,
				   int			nvselect);

void		XPlxVideoValueRecall(register Display*	dpy,
				     Drawable		d,
				     GC			gc,
				     int		nvselect);

void		XPlxVideoLive(register Display*		dpy,
			      Drawable			d,
			      GC			gc,
			      int			vx,
			      int			vy,
			      int			x,
			      int			y,
			      int			w,
			      int			h);

void		XPlxVideoStill(register Display*	dpy,
			       Drawable			d,
			       GC			gc,
			       int			vx,
			       int			vy,
			       int			x,
			       int			y,
			       int			w,
			       int			h);

void		XPlxVideoScale(register Display*	dpy,
			       Drawable			d,
			       GC			gc,
			       int			vx,
			       int			vy,
			       int			vw,
			       int			vh,
			       int			x,
			       int			y,
			       int			w,
			       int			h);

void		XPlxVideoSqueezeLive(register Display*	dpy,
				     Drawable		d,
				     GC			gc,
				     int		vx,
				     int		vy,
				     int		vw,
				     int		vh,
				     int		x,
				     int		y,
				     int		w,
				     int		h);

void		XPlxVideoSqueezeStill(register Display*	dpy,
				      Drawable		d,
				      GC		gc,
				      int		vx,
				      int		vy,
				      int		vw,
				      int		vh,
				      int		x,
				      int		y,
				      int		w,
				      int		h);

void		XPlxVideoStop(register Display*	dpy,
			      Drawable		d,
			      GC		gc);

void		XPlxVideoPriority(register Display*	dpy,
				  Drawable		d,
				  GC			gc,
				  int			pri);

void		XPlxVideoInput(register Display*	dpy,
			       Drawable			d,
			       GC			gc,
			       int			channel);

void		XPlxScaleCopyArea(register Display*	dpy,
				  Drawable		sd,
				  Drawable		dd,
				  GC			gc,
				  int			sx,
				  int			sy,
				  int			sw,
				  int			sh,
				  int			dx,
				  int			dy,
				  int			dw,
				  int			dh);

void		XPlxSetVideoParameterString(register Display*	dpy,
					    Drawable		d,
					    GC			gc,
					    char*		buf);

int		MakeQTables(unsigned int factor,
			    unsigned char* buf[]);

XPlxCImage*	XPlxCreateCImage(Display*	dpy,
				 char*		data,
				 int		size,
				 unsigned int	width,
				 unsigned int	height);

int		XPlxDestroyCImage(XPlxCImage*	ximage);

XPlxCImage*	XPlxGetCImage(register Display*	dpy,
			      Drawable		d,
			      GC		gc,
			      int		src_x,
			      int		src_y,
			      unsigned int	src_w,
			      unsigned int	src_h,
			      unsigned int	dst_w,
			      unsigned int	dst_h);

void		XPlxPutCImage(register Display*		dpy,
			      Drawable			d,
			      GC			gc,
			      register XPlxCImage*	image,
			      int			src_x,
			      int			src_y,
			      unsigned int		src_w,
			      unsigned int		src_h,
			      int			dst_x,
			      int			dst_y,
			      unsigned int		dst_w,
			      unsigned int		dst_h,
			      int			flag);

void		XPlxPutTable(Display*	dpy,
			     Drawable	d,
			     GC		gc,
			     short*	data,
			     int	size,
			     int	dir);

#include	<X11/extensions/XShm.h>

XPlxCImage*	XPlxShmCreateCImage(register Display*	dpy,
				    char*		data,
				    XShmSegmentInfo*	shminfo,
				    int			size,
				    unsigned int	width,
				    unsigned int	height);

Status		XPlxShmGetCImage(register Display*	dpy,
				 Drawable		d,
				 GC			gc,
				 XPlxCImage*		image,
				 int			src_x,
				 int			src_y,
				 unsigned int		src_w,
				 unsigned int		src_h);

Status		XPlxShmPutCImage(register Display*	dpy,
				 Drawable		d,
				 GC			gc,
				 XPlxCImage*		image,
				 int			src_x,
				 int			src_y,
				 unsigned int		src_w,
				 unsigned int		src_h,
				 int			dst_x,
				 int			dst_y,
				 unsigned int		dst_w,
				 unsigned int		dst_h,
				 int			flag,
				 Bool			send_event);

XShmSegmentInfo*	XPlxGetShmInfo(void);

void			XPlxFreeShmInfo(XShmSegmentInfo* shminfo);
#endif
#endif
