/* $Header: /usr/local/src/nvrToMIT/RCS/MpegDisplayP.h,v 1.10 1994/03/19 19:38:17 toddb Exp $ */

#ifndef _MpegDisplayP_h_
#define _MpegDisplayP_h_

#include "MpegDisplay.h"
#include "VideoDisplayP.h"
#include "viewcmap.h"
#include "nvrImage.h"

/* The class definition for the MpegDisplay Widget */
typedef struct _XnvrMpegDisplayClassPart
{
	int make_compiler_happy;	/* need dummy field */
} XnvrMpegDisplayClassPart;

typedef struct _XnvrMpegDisplayClassRec
{
    CoreClassPart		core_class;
    XnvrVideoDisplayClassPart	videoDisplay_class;
    XnvrMpegDisplayClassPart	mpegDisplay_class;
} XnvrMpegDisplayClassRec;

typedef struct _mpegPerDepth {
    ViewCmapInfo	view;
    int			depth;
    Window		win;
    Boolean		accelerated;	/* true if rendering is accelerated */
} MpegPerDepth, *MpegPerDepthPtr;

extern XnvrMpegDisplayClassRec xnvrMpegDisplayClassRec;

/* Instance record for the MpegDisplay Widget */
typedef struct _XnvrMpegDisplayPart {
    /* resource variables */
    int			gamma;
    Bool		alignWindow;
    Bool		trueColor12Bit;	/* true if true-color 12-bit used */
    Bool		active;		/* if mpeg sequence selected */
    Bool		debug;
    XtCallbackList	config_callback;
    XtPointer		mcs_server;
    RgbDepthType	depthType;
    ULong		availableDepths;

    /* private state */
    Window		decodeWindow;

    /* one for each value of RgbDepthType */
    MpegPerDepth	perDepth[ NRgbDepthTypes ];
} XnvrMpegDisplayPart;

typedef struct _XnvrMpegDisplayRec
{
    CorePart			core;
    XnvrVideoDisplayPart	video;
    XnvrMpegDisplayPart		mpeg;
} XnvrMpegDisplayRec;

#endif /* _MpegDisplayP_h_ */
