
/*
 * (c) Copyright 1992, 1993 North Valley Research, Inc.
 * 	All Rights Reserved
 *
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	MpegViewer.h
 *
 * DESCRIPTION
 *	A subclass of MpegDisplay that adds control functions.
 *
 * $Header: /usr/local/src/nvrToMIT/RCS/MpegViewer.h,v 1.1 1993/04/22 23:35:43 chrisj Exp $
 */
#ifndef _MPEG_VIEWER_H_
#define _MPEG_VIEWER_H_

#include "VideoDisplay.h"
#include "MpegDisplay.h"

/*
 *	DEFINES
 */

    /* New resource definitions */
#define XnvrNconnected		"connected"	/* is this really needed? */
#define XnvrCconnected		"Connected"
#define XnvrNplayState		"playState"
#define XnvrCplayState		"PlayState"
#define XnvrNmpegFile		"mpegFile"	/* a file name */
#define XnvrCmpegFile		"MpegFile"
#define XnvrNmpegStream		"mpegStream"	/* an open file stream */
#define XnvrCmpegStream		"MpegStream"
#define XnvrNframeRate		"frameRate"
#define XnvrCframeRate		"FrameRate"
#define XnvrNcurrentFrame	"currentFrame"
#define XnvrCcurrentFrame	"CurrentFrame"
#define XnvrNfirstFrame		"firstFrame"
#define XnvrCfirstFrame		"FirstFrame"
#define XnvrNlastFrame		"lastFrame"
#define XnvrClastFrame		"LastFrame"
#define XnvrNframeChangeCallback "frameChangeCallback"
#define XnvrCframeChangeCallback "FrameChangeCallback"
#define XnvrNfailureCallback	"failureCallback"
#define XnvrCfailureCallback	"FailureCallback"

	/* how to handle singleForward --> a state request
	 * that settles in still if successful (rather than the
	 * state requested)
	 */
#define XnvrReadyState              0 
#define XnvrPlayingState            2
#define XnvrStillState              3       
#define XnvrStoppedState            4       /* same as ready??? */
#define XnvrSingleForwardState      5
#define XnvrFailedState             99

#define XnvrMpegErrorNone		0
#define XnvrMpegErrorVideoFailed	1
#define XnvrMpegErrorAudioFailed	2

    /* Default resource values */

/*
 *	EXTERNS
 */
extern WidgetClass xnvrMpegViewerWidgetClass;

/*
 *	TYPEDEFS
 */
typedef struct _XnvrMpegViewerClassRec *XnvrMpegViewerWidgetClass;
typedef struct _XnvrMpegViewerRec          *XnvrMpegViewerWidget;

typedef struct
{
    int currentFrame;
} XnvrMpegViewerFrameCallbackStruct, *XnvrMpegViewerFramePtr;

typedef struct
{
    int failureMode;
} XnvrMpegViewerFailureCallbackStruct, *XnvrMpegViewerFailurePtr;


#endif /* _MPEG_VIEWER_H_ */
