/* $Header: /usr/local/src/nvrToMIT/RCS/MvexDisplayP.h,v 1.5 1993/01/05 00:22:30 chrisj Exp $ */

#ifndef _MvexDisplayP_h_
#define _MvexDisplayP_h_

#include "MvexDisplay.h"
#include "VideoDisplayP.h"
#include <MVEXlib.h>

/* The class definition for the MvexDisplay Widget */
typedef struct _XnvrMvexDisplayClassPart
{
    XtPointer extension;
} XnvrMvexDisplayClassPart;

typedef struct _XnvrMvexDisplayClassRec
{
    CoreClassPart	    	core_class;
    XnvrVideoDisplayClassPart	videoDisplay_class;
    XnvrMvexDisplayClassPart	mvexDisplay_class;
} XnvrMvexDisplayClassRec;

extern XnvrMvexDisplayClassRec xnvrMvexDisplayClassRec;

/* Instance record for the MvexDisplay Widget */
typedef struct _XnvrMvexDisplayPart
{
    /* resource variables */
    XEvent *mvexEvent;		/* ptr to an mvex event trapped by the app */
    int priority;		/* priority of video display */
    int overrideMode;

    /* vars stolen from mvex7.c */
    MVEXFraction *hueList;	/* list of possible hues */
    MVEXFraction *satList;
    MVEXFraction *contrastList;
    MVEXFraction *brightList;
    int abilityMask;		/* mask that describes available abilities */

    /* vars stolen from mvex5.c */
    VideoIn vid;
    Atom port;
    MVEXVin *pXvin;
    int mvexBase;

    /* vars for performing the rendering operation */
    VideoIn src;
    char **portNameArray;
    int vin_x;		    /* the size of the incoming video image */
    int vin_y;
    int vin_width;
    int vin_height;


} XnvrMvexDisplayPart;

typedef struct _XnvrMvexDisplayRec
{
    CorePart		    core;
    XnvrVideoDisplayPart    videoDisplay;
    XnvrMvexDisplayPart	    mvexDisplay;
} XnvrMvexDisplayRec;

#endif /* _MvexDisplayP_h_ */
