/* $Header: /usr/local/src/nvrToMIT/RCS/Pixmap3D.c,v 1.1 1992/07/30 23:20:23 chrisj Exp $ */

#include <Xm/Xm.h>
#include "Pixmap3D.h"

void Install3dPixmap(w, topBits, botBits, width, height, resource)
    Widget   w;
    char *topBits, *botBits;
    int width, height;
    char *resource;
{
    Pixmap    topBitmap, bottomBitmap, pix;
    Pixel     topColor, bottomColor, background;
    XGCValues values;
    int n;
    static GC gc = NULL;
    Arg wargs[10];

    /*
    * Create a bitmap from the data.
    */
    n = 0;
    if (strcmp(resource, XmNselectPixmap) == 0) {
	XtSetArg(wargs[n], XmNselectColor, &background);    n++;
    } else if (strcmp(resource, XmNarmPixmap) == 0) {
	XtSetArg(wargs[n], XmNarmColor, &background);       n++;
    } else if (strcmp(resource, XmNlabelPixmap) == 0) {
	XtSetArg(wargs[n], XmNbackground, &background);     n++;
    }
    XtSetArg(wargs[n], XmNtopShadowColor, &topColor);       n++;
    XtSetArg(wargs[n], XmNbottomShadowColor, &bottomColor); n++;
    XtGetValues(w, wargs, n);

    topBitmap = XCreateBitmapFromData(XtDisplay(w),  
			       RootWindowOfScreen(XtScreen(w)),
			       topBits, width, height);
    bottomBitmap = XCreateBitmapFromData(XtDisplay(w),  
			       RootWindowOfScreen(XtScreen(w)),
			       botBits, width, height);
    /* 
    * Create a pixmap of the same depth as the default screen.
    */
    pix = XCreatePixmap(XtDisplay(w), 
		      RootWindowOfScreen(XtScreen(w)),
		      width, height,
		      DefaultDepthOfScreen(XtScreen(w)));
    /*
     * Get the GC.
     */
    if (gc == NULL) {
	gc = XCreateGC(XtDisplay(w), RootWindowOfScreen(XtScreen(w)), 0, NULL);
    }
    
    values.fill_style = FillSolid;
    values.foreground = background;
    XChangeGC(XtDisplay(w), gc, GCFillStyle|GCForeground, &values);
    XFillRectangle(XtDisplay(w), pix, gc, 0, 0, width, height);

    values.stipple = topBitmap;
    values.fill_style = FillStippled;
    values.foreground = topColor;
    XChangeGC(XtDisplay(w), gc, GCFillStyle|GCForeground|GCStipple, &values);
    XFillRectangle(XtDisplay(w), pix, gc, 0, 0, width, height);

    values.stipple = bottomBitmap;
    values.fill_style = FillStippled;
    values.foreground = bottomColor;
    XChangeGC(XtDisplay(w), gc, GCFillStyle|GCForeground|GCStipple, &values);
    XFillRectangle(XtDisplay(w), pix, gc, 0, 0, width, height);

    /*
    * We don't need the bitmap anymore, so free it.
    */
    XFreePixmap(XtDisplay(w), topBitmap);
    XFreePixmap(XtDisplay(w), bottomBitmap);

    /*
     * install the pixmap
     */
    n = 0;
    XtSetArg(wargs[n], resource,     pix);      n++;
    XtSetArg(wargs[n], XmNlabelType, XmPIXMAP); n++;
    XtSetValues(w, wargs, n);

    /*
     * The pixmap (pix) is left floating in space, because it is
     * not clear whether it should be freed.
     */
}


/*
    Install3dPixmap(button, topPlayBack_bits, botPlayBack_bits,
			botPlayBack_width, botPlayBack_height, XmNarmPixmap);
    Install3dPixmap(button, topPlayBack_bits, botPlayBack_bits,
			botPlayBack_width, botPlayBack_height, XmNlabelPixmap);
*/
