/* $Header: /usr/local/src/nvrToMIT/RCS/PlxDisplayP.h,v 1.2 1992/12/07 05:37:18 toddb Exp $ */

#ifndef _PlxDisplayP_h_
#define _PlxDisplayP_h_

#include "PlxDisplay.h"
#include "VideoDisplayP.h"
#include "XPlxExt.h"

/* The class definition for the PlxDisplay Widget */
typedef struct _XnvrPlxDisplayClassPart
{
    XtPointer extension;
} XnvrPlxDisplayClassPart;

typedef struct _XnvrPlxDisplayClassRec
{
    CoreClassPart	    core_class;
    XnvrVideoDisplayClassPart	videoDisplay_class;
    XnvrPlxDisplayClassPart plxDisplay_class;
} XnvrPlxDisplayClassRec;

extern XnvrPlxDisplayClassRec xnvrPlxDisplayClassRec;

/* Instance record for the PlxDisplay Widget */
typedef struct _XnvrPlxDisplayPart
{
    /* resource variables */
    XEvent *plxEvent;	/* ptr to an plx event trapped by the app */
    int priority;	/* priority of video display */
    int overrideMode;
    XtCallbackList deactivateCBL;   /* callbacks to be called when the widget
				     * is overridden
				     */

    /* vars for performing the rendering operation */
    int inputChannel;
    int inputStandard;
    int pixelFormat;
    int pixelType;
    Bool firstRedisplay;

    plx_IO *plxio;
    plx_IO_list *input;	/* chosen input: pointer into plxio */
    char **portNameArray;

    /* the size of the incoming video image */
    int xIn;
    int yIn;
    int widthIn;
    int heightIn;
} XnvrPlxDisplayPart;

typedef struct _XnvrPlxDisplayRec
{
    CorePart		    core;
    XnvrVideoDisplayPart    videoDisplay;
    XnvrPlxDisplayPart	    plxDisplay;
} XnvrPlxDisplayRec;

#endif /* _PlxDisplayP_h_ */
