/* $Header: /usr/local/src/nvrToMIT/RCS/VideoDisplayP.h,v 1.6 1994/02/21 04:01:02 toddb Exp $ */

#ifndef _VideoDisplayP_h_
#define _VideoDisplayP_h_

#include "VideoDisplay.h"
#include <Xm/XmP.h>

/* Types for class methods */

typedef void (*XnvrUpdateDisplayProc)();
#define XnvrInheritUpdateDisplay ((XnvrUpdateDisplayProc) _XtInherit)
#define XnvrInheritRenderDisplay ((XtWidgetProc) _XtInherit)
typedef void (*XnvrPanDisplayProc)();
#define XnvrInheritPanDisplay ((XnvrPanDisplayProc) _XtInherit)

/* The class definition for the VideoDisplay Widget */
typedef struct _XnvrVideoDisplayClassPart
{
    XnvrUpdateDisplayProc updateDisplay;
    XtWidgetProc    renderDisplay;
    XnvrPanDisplayProc panDisplay;
    XtPointer	    extension;
} XnvrVideoDisplayClassPart;

typedef struct _XnvrVideoDisplayClassRec
{
    CoreClassPart	    core_class;
    XnvrVideoDisplayClassPart	videoDisplay_class;
} XnvrVideoDisplayClassRec;

extern XnvrVideoDisplayClassRec xnvrVideoDisplayClassRec;

/* Instance record for the VideoDisplay Widget */
typedef struct _XnvrVideoDisplayPart
{
    /* resource variables */
    XtCallbackList exposeCallback;
    XtCallbackList realizeCallback;
    struct {
	int count;
	int min;
	int current;
	int normal;
    } hue, sat, bright, contrast;
    int resizeMode;
    int displayMode;		/* mode flag -- startup only */
    Boolean isActive;		    /* start or stop video display */
    Boolean fullMotion;
    int n_ports;
    int port_index;
    char **portNames;
    int n_engines;
    int engine;
    Visual *visual;

    /* vars for performing the rendering operation */
    int src_x;		    /* the location of the current video picture */
    int src_y;
    int src_width;
    int src_height;
    int dest_x;		    /* the destination for the video image */
    int dest_y;
    int dest_width;
    int dest_height;

    /* misc internal variables */
    GC renderGC;
    Bool alreadyRedisplayed;

} XnvrVideoDisplayPart;

typedef struct _XnvrVideoDisplayRec
{
    CorePart		core;
    XnvrVideoDisplayPart    videoDisplay;
} XnvrVideoDisplayRec;


#endif /* _VideoDisplayP_h_ */
