// $Header: /usr/local/src/nvrToMIT/RCS/Buffer.C,v 1.2 1994/12/17 12:57:58 russ Exp $

/*
 * $Id: Buffer.C,v 1.2 1994/12/17 12:57:58 russ Exp $
 *
 * Buffer.C
 *
 * Copyright Pencom Software, 1994
 */

#include <Buffer.h>

Buffer::
Buffer()
{	init();
}

void 
Buffer::
init( char* p, size_t s, bufstat_t st, seq_t seq )
{
	memset( (char*)&cb, 0, sizeof( cb ) );
	setptr( p );
	setsize( s );
	setstate( st );
	set_seq( seq );
}

aiocb*
Buffer::
getcb( int fd, off_t offset )
{
	cb.aio_fildes = fd;
	cb.aio_offset = offset;
	return &cb;
}

char*
Buffer::
strstate()
{
	static char* bufstat_str[] = 
		{ "Empty", "Emptying", "Partial", "Full", "Filling" };
	return bufstat_str[state];
}

ostream&
operator<<( ostream& o, Buffer& b ) 
{
	o << "state      = " << b.strstate() << endl
	  << "ptr        = 0x" << hex << (long)b.ptr << dec << endl
	  << "size       = " << b.size << endl
	  << "used       = " << b.used << endl
	  << "seq        = " << b.seq << endl
	  << "cb.fd      = " << b.cb.aio_fildes << endl
	  << "cb.offset  = " << b.cb.aio_offset << endl
	  << "cb.buf 0x  = " << hex << (long)b.cb.aio_buf << dec << endl
	  << "cb.nbytes  = " << b.cb.aio_nbytes << endl
	  << "cb.error   = " << aio_error( &b.cb ) << endl
	  << "cb.return  = " << aio_return( &b.cb ) << endl;

	return o;
	
}

