// $Header: /usr/local/src/nvrToMIT/RCS/Counter.C,v 1.1 1994/05/10 03:01:48 russ Exp $

/*
 * $Id: Counter.C,v 1.1 1994/05/10 03:01:48 russ Exp $
 *
 * Counter.C
 *
 * Copyright Pencom Software, 1994
 */

#include <Counter.h>

Counter::
Counter( char* file, bool_t attach ) : key( -1 ), id( -1 ), tp( NULL )
{
/*
 * create/use a shared memory segment
 */
	key = ftok( file, 0 );
	if( key == -1 )
	{	return;
	}

	id = shmget( key, 1024, IPC_CREAT|0666 );
	if( id == -1 )
	{	return;
	}
/*
 * attach to it if asked
 */
	if( attach )
	{	tp = (char*)shmat( id, 0, 0 );
		if( !tp )
		{	id = -1;
			return;
		}
	}
}

Counter::
~Counter()
{	Logger log( "Counter::~Counter()" );

	if( tp )
	{	if( shmdt( tp ) == -1 )
		{	cout << log << "shmdt() failed, errno=" << ::errno
			     << endl;
		}
	}
}

void
Counter::
remove()
{	Logger log( "Counter::remove()" );

	if( shmctl( id, IPC_RMID ) == -1 )
	{	cout << log << "shmctl() failed, errno=" << ::errno << endl;
	}
}

count_t
Counter::
count()
{
	shmid_ds ds;

	int rc = shmctl( id, IPC_STAT, &ds );
	if( rc == -1 )
	{	return -1;
	}
	
	return ds.shm_nattch;
	
}


