// $Header: /usr/local/src/nvrToMIT/RCS/Scheduler.C,v 1.1 1994/03/10 23:47:09 russ Exp $

/*
 * $Id: Scheduler.C,v 1.1 1994/03/10 23:47:09 russ Exp $
 *
 * Scheduler.C
 *
 * Copyright Pencom Software, 1994
 */

#include <Scheduler.h>

Scheduler::
Scheduler( Feed* feed, count_t nfeeds )
 : feed( feed ), nfeeds( nfeeds), pid( -1 )
{	
}

Scheduler::
~Scheduler()
{	
	if( pid != -1 )
	{	::kill( pid, SIGTERM );
	}
}

void
Scheduler::
release()
{
	Logger log( "Scheduler::release()" );

	if( schedctl( DEADLINE, 0, DL_BLOCK ) == -1 )
	{	cout << log << "schedctl() failed (errno=" << ::errno
		     << ")" << endl;
	}
}

void
Scheduler::
set_speed( speed_t s, Ring* ring )
{
	Logger log( "Scheduler::set_speed()" );

	double buf_rate = (double)s / (double)ring->full_size();
	double interval = 1 / buf_rate;

	sched_deadline dl;
	dl.dl_period = Time( interval );
	dl.dl_alloc = Time( 0, 1000 );
	dl.dl_deadline = Time( 0, 0 );
	dl.dl_flags = 0;
CBR_DEBUG( CBR_DEBUG_CONS_3, 
	cout << log << "speed=" << s << ",new period " << Time( interval ) 
	     << endl;
);
	int rc = schedctl( DEADLINE, 0, &dl );
	if( rc == -1 )
	{	cout << log << "schedctl() failed (errno=" << ::errno
		     << ")" << endl;
	}

}

