// $Header: /usr/local/src/nvrToMIT/RCS/Semaphore.C,v 1.1 1994/03/10 23:47:29 russ Exp $

/*
 * $Id: Semaphore.C,v 1.1 1994/03/10 23:47:29 russ Exp $
 *
 * Semaphore.C
 *
 * Copyright Pencom Software, 1994
 */

#include <Vodoo.h>
#include <Semaphore.h>

Semaphore::
Semaphore( int semval, char* file ) : key( -1 ), id( -1 ), ps(0), vs(0)
{
	Logger log( "Sempahore::Sempahore()" );

#if 0
	cout << log << "semval=" << semval << ",file=0x" << hex << (long)file
	     << dec << endl;
#endif
 

	sop.sem_num = 0;
	sop.sem_flg = SEM_UNDO;

	if( file )
	{	key = ftok( file, 0 );
		if( key == -1 )
		{	cout << log << "ftok() failed, errno=" << ::errno
			     << endl;
			return;
		}
	}
	else
	{	key = IPC_PRIVATE;
	}

	bool_t newsem = FALSE;

	id = semget( key, 1, 0600 );
	if( id == -1 )
	{	id = semget( key, 1, IPC_CREAT|0666 );
		newsem = TRUE;
	}
	if( id == -1 )
	{	cout << log << "semget() failed, errno=" << ::errno << endl;
		return;
	}

	if( ( newsem || !file ) && set( semval ) == -1 )
	{	id = -1;
	}

#if 0
	cout << log << "key=" << key << ",id=" << id << ",semval=" << get()
	     << endl;
#endif

}

Semaphore::
~Semaphore()
{
}

int
Semaphore::
set( int semval )
{	Logger log( "Semaphore::set()" );

	buf.val = semval;
	int rc = semctl( id, 0, SETVAL, buf );
	if( rc == -1 )
	{	cout << log << "semctl() failed, errno=" << ::errno << endl;
	}
	return rc;
	
}

void
Semaphore::
remove()
{	Logger log( "Semaphore::remove" );
	if( semctl( id, 0, IPC_RMID, 0 ) == -1 )
	{	cout << log << "semctl() failed, errno=" << ::errno << endl;
	}
}

int
Semaphore::
get()
{	Logger log( "Semaphore::get()" );

	int rc = semctl( id, 0, GETVAL, &buf );
	if( rc == -1 )
	{	cout << log << "semctl() failed, errno=" << ::errno << endl;
	}
	return rc;
	
}

int
Semaphore::
p()
{
	Logger log( "Semaphore::p()" );

//	cout << log << "semval=" << get() << endl;

	sop.sem_op = -1;

	int rc = semop( id, &sop, 1 );
	if( rc == -1 )
	{	cout << log << "semop() failed, errno=" << ::errno << endl;
	}

#if 0
	int cnt = get();
	if( cnt != 0 )
	{	cout << log << "semval is not 0, semval=" << cnt << ",ps="
		     << ps << endl;
	}
#endif

	ps++;

	return rc;
	
}

int
Semaphore::
v()
{
	Logger log( "Semaphore::v()" );

	int cnt = get();
#if 0
	if( cnt != 0 )
	{	cout << log << "semval is not 0, semval=" << cnt << ",vs="
		     << vs << endl;
	}
#endif

	vs++;

	sop.sem_op = 1;

	int rc = semop( id, &sop, 1 );
	if( rc == -1 )
	{	cout << log << "semop() failed, errno=" << ::errno << endl;
	}
	return rc;
	
}

ostream& 
operator<<( ostream& ostr, Semaphore& s )
{
	ostr << "sem.key    = " << s.key << endl
	     << "sem.id     = " << s.id << endl
	     << "sem.semval = " << s.get() << endl
	     << "sem.ps     = " << s.ps << endl
	     << "sem.vs     = " << s.vs << endl;

	return ostr;
		
}

