// $Header: /usr/local/src/nvrToMIT/RCS/Time.C,v 1.1 1994/05/10 03:01:51 russ Exp $

/*
 * $Id: Time.C,v 1.1 1994/05/10 03:01:51 russ Exp $
 *
 * Time.C
 *
 * Copyright Pencom Software, 1994
 */

#include <Time.h>

void
Time::normalize( Time& x )
{	while( x.usec >= USecPerSec )
	{	x.sec++;
		x.usec -= USecPerSec;
	}
}

Time::Time( time_t sec, time_t usec ) : sec(sec), usec(usec)
{	normalize(*this);
}

Time::Time( double s )
{	sec = (time_t)s;
	usec = (time_t)( USecPerSecD * ( s - sec + USecRounder ) );
	normalize(*this);
}

void
Time::set()
{       struct timeval t;
	gettimeofday( &t, 0 );
	sec = t.tv_sec;
	usec = t.tv_usec;
}

void
Time::set( time_t s, time_t u )
{	sec = s;
	usec = u;
	normalize(*this);
}

Time
Time::operator + ( const Time& y )
{	return Time( sec + y.sec, usec + y.usec );
}

Time&
Time::operator += ( const Time& y )
{	sec += y.sec;
	usec += y.usec;
	normalize( *this );
	return *this;
}

Time
Time::operator - ( const Time& y )
{	assert( (*this) >= y );		// don't allow negative times
	if( usec >= y.usec )
	{	return Time( sec - y.sec, usec - y.usec );
	}
	else
	{	return Time( sec - y.sec - 1, ( USecPerSec + usec ) - y.usec );
	}
}

Time&
Time::operator -= ( const Time& y )
{	assert( (*this) >= y );		// don't allow negative times
	sec -= y.sec;
	if( usec >= y.usec )
	{	usec -= y.usec;
	}
	else
	{	sec -= 1;
		usec = ( USecPerSec + usec ) - y.usec;
	}
	return *this;
}

char*
Time::
cur_time()
{
	set();
	char* ct = ctime( (time_t*)&sec );
	ct[19] = '\0';
	char* year = &ct[20];
	year[4] = '\0';		// remove the \n

	char cur[32];

	ostrstream ost( cur, sizeof( cur ) );
	ost << ct << ":";
	ost.width(6);
	ost.fill( '0' );
	ost << usec;
	ost.width(0);
	ost.fill( ' ' );
	ost << " " << year << ends;

	return cur;

}

ostream& operator << ( ostream& s, Time t )
{	 return s << "sec=" << t.seconds() << ",usec=" << t.useconds();
}


