// $Header: /usr/local/src/nvrToMIT/RCS/VTDprot.C,v 1.1 1994/05/10 03:01:52 russ Exp $

/*
 * $Id: VTDprot.C,v 1.1 1994/05/10 03:01:52 russ Exp $
 *
 * VTDprot.C
 *
 * Copyright Pencom Software, 1994
 */

#include <VTDprot.h>

vtdprot_t*
VTDprot::
send()
{	

	net_msg.type = htonl( host_msg.type );

	switch( host_msg.type )
	{
	case VS_PROT_STATUS:
		net_msg.p.status.status = htonl( host_msg.p.status.status );
		net_msg.p.status.errno = htonl( host_msg.p.status.errno );
		net_msg.p.status.type = htonl( host_msg.p.status.type );
		switch( host_msg.p.status.type )
		{
		case VS_STAT_GENERIC:
			break;
		case VS_STAT_PAUSE:
			net_msg.p.status.data.pause_offset = 
				htonl( host_msg.p.status.data.pause_offset );
			break;
		case VS_STAT_PREVIEW:
			net_msg.p.status.data.preview.len = 
				htonl( host_msg.p.status.data.preview.len );
			break;
		case VS_STAT_CATALOG:
			net_msg.p.status.data.catalog.len = 
				htonl( host_msg.p.status.data.catalog.len );
			break;
		}
		break;	
	case VS_PROT_LOAD:
		net_msg.p.load.port = htonl( host_msg.p.load.port );
		net_msg.p.load.netbufsz = htonl( host_msg.p.load.netbufsz );
		strcpy( host_msg.p.load.file, net_msg.p.load.file );
		break;
	case VS_PROT_PREVIEW:
		net_msg.p.preview.port = htonl( host_msg.p.preview.port );
		net_msg.p.preview.offset = htonl( host_msg.p.preview.offset );
		net_msg.p.preview.len = htonl( host_msg.p.preview.len );
		break;
	case VS_PROT_PLAY:
		net_msg.p.play.port = htonl( host_msg.p.play.port );
		net_msg.p.play.speed = htonl( host_msg.p.play.speed );
		break;
	case VS_PROT_SEEK:
		net_msg.p.seek.port = htonl( host_msg.p.seek.port );
		net_msg.p.seek.offset = htonl( host_msg.p.seek.offset );
		break;
	case VS_PROT_PAUSE:
		net_msg.p.pause.port = htonl( host_msg.p.pause.port );
		break;
	case VS_PROT_FLOW:
		net_msg.p.flow.port = htonl( host_msg.p.flow.port );
		net_msg.p.flow.nbufs = htonl( host_msg.p.flow.nbufs );
		break;
	case VS_PROT_RETRY:
		net_msg.p.retry.port = htonl( host_msg.p.retry.port );
		net_msg.p.retry.seq = htonl( host_msg.p.retry.seq );
		net_msg.p.retry.offset = htonl( host_msg.p.retry.offset );
		break;
	case VS_PROT_EOM:
		net_msg.p.eom.port = htonl( host_msg.p.eom.port );
		break;
	case VS_PROT_EJECT:
		net_msg.p.eject.port = htonl( host_msg.p.eject.port );
		break;
	case VS_PROT_CATALOG:
		break;
	}

	return &net_msg;
}

void
VTDprot::
recv( vtdprot_t& m )
{	
	net_msg = m;

	host_msg.type = ntohl( net_msg.type );

	switch( host_msg.type )
	{
	case VS_PROT_STATUS:
		host_msg.p.status.status = ntohl( net_msg.p.status.status );
		host_msg.p.status.errno = ntohl( net_msg.p.status.errno );
		host_msg.p.status.type = ntohl( net_msg.p.status.type );
		switch( host_msg.p.status.type )
		{
		case VS_STAT_GENERIC:
			break;
		case VS_STAT_PAUSE:
			host_msg.p.status.data.pause_offset = 
				ntohl( net_msg.p.status.data.pause_offset );
			break;
		case VS_STAT_PREVIEW:
			host_msg.p.status.data.preview.len = 
				ntohl( net_msg.p.status.data.preview.len );
			break;
		case VS_STAT_CATALOG:
			host_msg.p.status.data.catalog.len = 
				ntohl( net_msg.p.status.data.catalog.len );
			break;
		}
		break;	
	case VS_PROT_LOAD:
		host_msg.p.load.port = ntohl( net_msg.p.load.port );
		host_msg.p.load.netbufsz = ntohl( net_msg.p.load.netbufsz );
		strcpy( host_msg.p.load.file, net_msg.p.load.file );
		break;
	case VS_PROT_PREVIEW:
		host_msg.p.preview.port = ntohl( net_msg.p.preview.port );
		host_msg.p.preview.offset = ntohl( net_msg.p.preview.offset );
		host_msg.p.preview.len = ntohl( net_msg.p.preview.len );
		break;
	case VS_PROT_PLAY:
		host_msg.p.play.port = ntohl( net_msg.p.play.port );
		host_msg.p.play.speed = ntohl( net_msg.p.play.speed );
		break;
	case VS_PROT_SEEK:
		host_msg.p.seek.port = ntohl( net_msg.p.seek.port );
		host_msg.p.seek.offset = ntohl( net_msg.p.seek.offset );
		break;
	case VS_PROT_PAUSE:
		host_msg.p.pause.port = ntohl( net_msg.p.pause.port );
		break;
	case VS_PROT_FLOW:
		host_msg.p.flow.port = ntohl( net_msg.p.flow.port );
		host_msg.p.flow.nbufs = ntohl( net_msg.p.flow.nbufs );
		break;
	case VS_PROT_RETRY:
		host_msg.p.retry.port = ntohl( net_msg.p.retry.port );
		host_msg.p.retry.seq = ntohl( net_msg.p.retry.seq );
		host_msg.p.retry.offset = ntohl( net_msg.p.retry.offset );
		break;
	case VS_PROT_EOM:
		host_msg.p.eom.port = ntohl( net_msg.p.eom.port );
		break;
	case VS_PROT_EJECT:
		host_msg.p.eject.port = ntohl( net_msg.p.eject.port );
		break;
	}

}

ostream&
operator<<( ostream& ostr, VTDprot& cmd )
{	ostr << vtdprot_type( cmd.get_type() ) << ": ";

	switch( cmd.get_type() )
	{	
	case VS_PROT_STATUS:
		ostr << cmd.get_status() << " errno=" << cmd.get_errno()
		     << " type=";
		switch( cmd.get_status_type() )
		{
		case VS_STAT_GENERIC:
			ostr << "generic";
			break;
		case VS_STAT_PAUSE:
			ostr << "pause pause_offset="
			     << cmd.get_pause_offset();
			break;
		case VS_STAT_PREVIEW:
			ostr << "preview len="
			     << cmd.get_status_preview_len();
			break;
		case VS_STAT_CATALOG:
			ostr << "catalog len="
			     << cmd.get_status_catalog_len();
			break;
		}
		break;	
	case VS_PROT_LOAD:
		ostr << cmd.get_port() << " " << cmd.get_netbufsz() << " " 
		     << cmd.get_file();
		break;
	case VS_PROT_PREVIEW:
		ostr << cmd.get_port() << " " << cmd.get_preview_offset()
		     << " " << cmd.get_preview_len();
		break;
	case VS_PROT_PLAY:
		ostr << cmd.get_port() << " " << cmd.get_speed();
		break;
	case VS_PROT_SEEK:
		ostr << cmd.get_port() << " " << cmd.get_offset();
		break;
	case VS_PROT_PAUSE:
		ostr << cmd.get_port();
		break;
	case VS_PROT_FLOW:
		ostr << cmd.get_port() << " " << cmd.get_nbufs();
		break;
	case VS_PROT_RETRY:
		ostr << cmd.get_port() << " " << cmd.get_seq() << " "
		     << cmd.get_retry_offset();
		break;
	case VS_PROT_EOM:
		ostr << cmd.get_port();
		break;
	case VS_PROT_EJECT:
		ostr << cmd.get_port();
		break;
	}

	ostr << endl;

	return ostr;
}

