/* $Header: /usr/local/src/nvrToMIT/RCS/IFhand.h,v 1.1 1994/05/10 23:29:32 russ Exp $ */

#ifndef __h_IFhand__
#define __h_IFhand__

/*
 * $Id: IFhand.h,v 1.1 1994/05/10 23:29:32 russ Exp $
 *
 * IFhand.h
 *
 * Copyright Pencom Software, 1994
 */

#include <Vodoo.h>
#include <VTDprot.h>
#include <Feed.h>
#include <SchedProd.h>
#include <SchedCons.h>
#include <Counter.h>

class IFhandFeed;

/*
 * The IFhand class is responsible for getting client requests from the TCP
 * channel, parsing them, affecting the appropriate feed and sending back
 * status. 
 *
 * It assumes that it has been started via inetd, meaning it uses stdin
 * as the socket to begin reading from.
 */
class IFhand 
{
public:
	IFhand( char* media_dir, char* cntr_dir, speed_t max_speed, 
		Feed* feed, count_t nfeeds, Logger glog );
	~IFhand();

	virtual perr_t run();
/*
 * TCP message handlers
 */
	virtual int handle_input();
	virtual int do_load( VTDprot& cmd );
	virtual int do_preview( VTDprot& cmd );
	virtual int do_catalog( VTDprot& cmd );
	virtual int do_play( VTDprot& cmd );
	virtual int do_pause( VTDprot& cmd );
	virtual int do_seek( VTDprot& cmd );
	virtual int do_flow( VTDprot& cmd );
	virtual int do_eject( VTDprot& cmd );
	virtual int do_retry( VTDprot& cmd );
	virtual int do_dump( VTDprot& cmd );

	void send_status( int value, int errno = 0, 
			  long type = VS_STAT_GENERIC, offset_t off = -1 );
	void send_status( int type, int value, char* p, size_t len );

	virtual count_t map_port(	// get existing feed for port
		port_t port
	);	
	virtual count_t new_feed(	// get new feed for port
		port_t port
	);	


protected:
	char* media_dir;
	char* cntr_dir;

	int in_sockfd;
	sockaddr_in l_ctrl;
	sockaddr_in r_ctrl;

	Feed* feed;
	count_t nfeeds;

	IFhandFeed* ifeed;
	count_t cur_feed;

	speed_t max_speed;
	Logger glog;

	Counter* cntr;
};

class IFhandFeed
{
public:
	IFhandFeed() : port( -1 ), p( NULL ), c( NULL ) {}
	~IFhandFeed() { delete p; delete c; }

	port_t port;

	SchedProd* p;
	SchedCons* c;

};


#endif
