/* $Header: /usr/local/src/nvrToMIT/RCS/NetHead.h,v 1.1 1994/05/10 23:29:38 russ Exp $ */

#ifndef __h_NetHead__
#define __h_NetHead__

/*
 * $Id: NetHead.h,v 1.1 1994/05/10 23:29:38 russ Exp $
 *
 * NetHead.h
 *
 * Copyright Pencom Software, 1994
 */

struct NetHead_t
{	char id[8];		// should be CBRUDP
	long type;
	long seq;
	long size;
	long offset;
	ulong checksum;
};

/*
 * The NetHead class totaly encapsulates the header tacked onto all the
 * UDP packets sent out by the server.
 */
class NetHead
{	
public:
	enum types { Undefined, Data, EOM };

	NetHead( char* id = "CBRUDP" )
	{	strncpy( nh.id, id,  sizeof( nh.id ) );
		nh.type = Undefined;
		nh.seq = 0;
	}
	NetHead( u_short seq ) { nh.type = Undefined; nh.seq = seq; }

	long get_type() { return ntohl(nh.type); }
	long get_seq() { return ntohl(nh.seq); }
	long get_size() { return ntohl(nh.size); }
	long get_offset() { return ntohl(nh.offset); }
	ulong get_checksum() { return ntohl(nh.checksum); }

	void set_type( long t ) { nh.type = htonl(t); }
	void set_seq( long s ) { nh.seq = htonl(s); }
	void set_size( long s ) { nh.size = htonl(s); }
	void set_offset( long o ) { nh.offset = htonl(o); }
	void set_checksum( ulong c ) { nh.checksum = htonl(c); }

	void* operator()() { return &nh; }
	size_t size() { return sizeof( nh ); }

private:
	struct NetHead_t nh;
};


#endif
