/* $Header: /usr/local/src/nvrToMIT/RCS/SchedCons.h,v 1.1 1994/05/10 23:29:41 russ Exp $ */


#ifndef __h_SchedCons__
#define __h_SchedCons__

/*
 * $Id: SchedCons.h,v 1.1 1994/05/10 23:29:41 russ Exp $
 *
 * SchedCons.h
 *
 * Copyright Pencom Software, 1994
 */

#include <Scheduler.h>
#include <Counter.h>

/*
 * Schedules consumers for each feed.  Consumers take information out of the
 * Ring and send it over the network.  It uses deadline scheduling, schedctl(),
 * to achieve a constant bit rate.
 */
class SchedCons : public Scheduler
{
public:
	SchedCons( char* cntr_dir, speed_t max_speed, Feed* feed, 
		   count_t nfeeds, Logger& log );
	~SchedCons();

	virtual perr_t run();
	virtual void schedule( Feed& f );

	int consume( Feed& f, Buffer* b );

        friend void SchedCons_entry( void* arg );

	int adjust_speed( Feed& f, Ring* ring );
	int consume_buffer( Feed& f, Ring* ring );
	int send_eom( Feed& f );

private:
	speed_t max_speed;
	char* cntr_dir;
	Counter* cntr;

};

#endif
