/* $Header: /usr/local/src/nvrToMIT/RCS/Scheduler.h,v 1.1 1994/05/10 23:29:45 russ Exp $ */

#ifndef __h_Scheduler__
#define __h_Scheduler__

/*
 * $Id: Scheduler.h,v 1.1 1994/05/10 23:29:45 russ Exp $
 *
 * Scheduler.h
 *
 * Copyright Pencom Software, 1994
 */

#include <Vodoo.h>
#include <Stopwatch.h>
#include <Feed.h>

/*
 * An abstract class that defines what a Scheduler looks like.  It's subclasses
 * should define the run() function, 
 */
class Scheduler
{
public:
	Scheduler( Feed* feed, count_t nfeeds );
	~Scheduler();

	virtual perr_t run() = 0;
	virtual void release();
	virtual void set_speed( speed_t s, Ring* ring );

protected:
	Feed* feed;
	count_t nfeeds;
	pid_t pid;

};


#endif
