/* $Header: /usr/local/src/nvrToMIT/RCS/Stopwatch.h,v 1.1 1994/05/10 23:29:49 russ Exp $ */

#ifndef __h_Stopwatch__
#define __h_Stopwatch__

/*
 * $Id: Stopwatch.h,v 1.1 1994/05/10 23:29:49 russ Exp $
 *
 * Stopwatch.h
 *
 * Copyright Pencom Software, 1994
 */

#include <Time.h>

class Stopwatch
{
public:
	enum state { init, running, done };

	Stopwatch() : state( init ) {}
	~Stopwatch() {}

	void clear() { state = init; }
	void start() { start_time.set(); state = running; }
	void stop() { if( state == running ) stop_time.set(); state = done; }
	Time diff() 
	{	Time t;
		Time now;
		switch( state )
		{
		case running:	
			now.set();
			t = now - start_time;
			break;
		case done:
			t = stop_time - start_time;
			break;	
		case init:
			t = Time();
			break;
		}
		return t;
	}
	bool_t started() { return state == running; }
		
private:
	Time start_time;
	Time stop_time;

	Stopwatch::state state;
};

#endif

