/* $Header: /usr/local/src/nvrToMIT/RCS/Time.h,v 1.1 1994/05/10 23:29:51 russ Exp $ */

#ifndef __h_Time__
#define __h_Time__

/*
 * $Id: Time.h,v 1.1 1994/05/10 23:29:51 russ Exp $
 *
 * Time.h
 *
 * Copyright Pencom Software, 1994
 */

#include <Vodoo.h>

const long USecPerSec = 1000000;
const double USecPerSecD = 1000000.0;
const double USecRounder = 0.0000005;
const long MaxMicrosecond = USecPerSec - 1;
const long MaxSecond = LONG_MAX;

class Time
{	time_t sec;
	time_t usec;

public:
	Time() : sec(0), usec(0) {}
	Time( time_t sec, time_t usec );
	Time( double sec );
	Time( const Time& y ) : sec(y.sec), usec(y.usec) {}
	~Time() {}

	void set();
	void set( time_t s, time_t u );

	time_t seconds() const { return sec; }
	time_t useconds() const { return usec; }
	char* cur_time();

	void normalize( Time& x );

	operator double() { return (double)sec + ((double)usec/USecPerSecD); }
	operator timeval()
	{	timeval tv;
		tv.tv_sec = sec;
		tv.tv_usec = usec;
		return tv;
	}

	operator timestruc()
	{	timestruc ts;
		ts.tv_sec = sec;
		ts.tv_nsec = usec * 1000;
		return ts;
	}

	Time operator + ( const Time& y );
	Time operator - ( const Time& y );

	Time& operator += ( const Time& y );
	Time& operator -= ( const Time& y );

	int operator == ( const Time& y ) const 
	{	return  sec == y.sec && usec == y.usec;
	}
	int operator != ( const Time& y ) const 
	{	return  sec != y.sec || usec != y.usec;
	}
	int operator > ( const Time& y ) const 
	{	return  sec > y.sec || 
			sec == y.sec && usec > y.usec;
	}
	int operator >= ( const Time& y ) const 
	{	return  sec > y.sec || 
			sec == y.sec && usec >= y.usec;
	}
	int operator < ( const Time& y ) const 
	{	return  sec < y.sec || 
			sec == y.sec && usec < y.usec;
	}
	int operator <= ( const Time& y ) const 
	{	return  sec < y.sec || 
			sec == y.sec && usec <= y.usec;
	}


};
	ostream& operator << ( ostream& s, Time t );

#endif

