/* $Header: /usr/local/src/nvrToMIT/RCS/VTDprot.h,v 1.1 1994/05/10 23:29:56 russ Exp $ */

#ifndef __h_VTDprot__
#define __h_VTDprot__

/*
 * $Id: VTDprot.h,v 1.1 1994/05/10 23:29:56 russ Exp $
 *
 * VTDprot.h
 *
 * Copyright Pencom Software, 1994
 */

#include <Vodoo.h>
#include <vtdprot.h>

class VTDprot
{
public:
	VTDprot( long t = VS_PROT_UNKNOWN, char* id = VS_TCPID )
	{	strncpy( host_msg.id, id, sizeof( host_msg.id ) );
		strncpy( net_msg.id, id, sizeof( net_msg.id ) );
		host_msg.type = t;
	}
	VTDprot( vtdprot_t& m ) { recv( m ); }
	~VTDprot() {}

	vtdprot_t* send();
	void recv( vtdprot_t& m );

	long get_type() { return host_msg.type; }
	port_t get_port() { return host_msg.p.load.port; }
	char* get_file() { return host_msg.p.load.file; }
	long get_netbufsz() { return host_msg.p.load.netbufsz; }
	speed_t get_speed() { return host_msg.p.play.speed; }
	offset_t get_offset() { return host_msg.p.seek.offset; }
	offset_t get_preview_offset() { return host_msg.p.preview.offset; }
	size_t get_preview_len() { return host_msg.p.preview.len; }
	count_t get_nbufs() { return host_msg.p.flow.nbufs; }
	count_t get_seq() { return host_msg.p.retry.seq; }
	offset_t get_retry_offset() { return host_msg.p.retry.offset; }
	long get_status() { return host_msg.p.status.status; }
	long get_errno() { return host_msg.p.status.errno; }
	long get_status_type() { return host_msg.p.status.type; }
	long get_pause_offset() { return host_msg.p.status.data.pause_offset; }
	long get_status_preview_len() 
	{	return host_msg.p.status.data.preview.len;
	}
	long get_status_catalog_len() 
	{	return host_msg.p.status.data.catalog.len;
	}
	char* get_dump_file() { return host_msg.p.dump.file; }

	void set_nbufs( count_t n ) { host_msg.p.flow.nbufs = n; }
	void set_port( port_t p ) { host_msg.p.retry.port = p; }
	void set_seq( count_t s ) { host_msg.p.retry.seq = s; }
	void set_retry_offset( offset_t o ) { host_msg.p.retry.offset = o; }
	void set_offset( offset_t o ) { host_msg.p.seek.offset = o; }
	void set_status( int s ) { host_msg.p.status.status = s; }
	void set_status_errno( long e ) { host_msg.p.status.errno = e; }
	void set_status_type( long t ) { host_msg.p.status.type = t; }
	void set_status_pause_offset( long o ) 
	{	host_msg.p.status.data.pause_offset = o;
	}
	void set_status_preview_len( long l ) 
	{	host_msg.p.status.data.preview.len = l;
	}
	void set_status_catalog_len( long l ) 
	{	host_msg.p.status.data.catalog.len = l;
	}

	friend ostream& operator<<( ostream& ostr, VTDprot& cmd );

private:
	vtdprot_t net_msg;	// msg in network byte order
	vtdprot_t host_msg;	// msg in host byte order

};


#endif
