/* $Header: /usr/local/src/nvrToMIT/RCS/vtd.h,v 1.1 1994/05/10 23:30:02 russ Exp $ */


#ifndef __h_vtd__
#define __h_vtd__

/*
 * $Id: vtd.h,v 1.1 1994/05/10 23:30:02 russ Exp $
 *
 * vtd.h
 *
 * Copyright Pencom Software, 1994
 */

#include <Vodoo.h>

/*
 * Error values
 */
#define VS_ER_OK	0
#define VS_ER_NOSERV	1	/* check global errno for more detail */
#define VS_ER_NOSOCK	2	/* check global errno for more detail */
#define VS_ER_NOCONN	3	/* check global errno for more detail */
#define VS_ER_NOOPT	4	/* check global errno for more detail */
#define VS_ER_NORECV	5	/* check global errno for more detail */
#define VS_ER_BADSERV	6
#define VS_ER_BADSTAT	7	/* check global errno for more detail */
#define VS_ER_NSUNIT	8	/* check global errno for more detail */
#define VS_ER_NOBIND	9	/* check global errno for more detail */
#define VS_ER_NOSELECT	10	/* check global errno for more detail */
#define VS_ER_NSFILE	11	/* check global errno for more detail */
#define VS_ER_OUT	12	/* check global errno for more detail */
#define VS_ER_BUSY	13	
#define VS_ER_NOTAPE	14	
#define VS_ER_IDLE	15	
#define VS_ER_BADSTATE	16	
#define VS_ER_BADOFF	17	
#define VS_ER_BADSEQ	18	
#define VS_ER_NOMEM	19	
#define VS_ER_NOTREADY	20
#define VS_ER_NOPROC	21
#define VS_ER_INVAL	22
#define VS_ER_INVALCTRL	23
#define VS_ER_INVALSRC	24
#define VS_ER_INVALDST	25
#define VS_ER_NOSEEK	26	
#define VS_ER_NOREAD	27	
#define VS_ER_NOWRITE	28	
#define VS_ER_MAXSPEED	29	
#define VS_ER_LASTERR	30	

#ifdef __cplusplus
extern "C" {
#endif
err_t vsPowerOn( char* hostname, sock_t* decksocket );
err_t vsLoadTape( sock_t decksocket, char* filename, size_t netbufsz, 
		  sock_t* outsocket );
err_t vsPreview( sock_t decksocket, sock_t outsocket, offset_t offset,
		 void* buffer, size_t* length );
err_t vsCatalog( sock_t decksocket, char** buffer, size_t* length );
err_t vsPlay( sock_t decksocket, sock_t outsocket, speed_t speed );
err_t vsSeek( sock_t decksocket, sock_t outsocket, offset_t off );
err_t vsPause( sock_t decksocket, sock_t outsocket, offset_t* off );
err_t vsFlowControl( sock_t decksocket, sock_t outsocket, count_t nbufs );
err_t vsRetryBuffer( sock_t decksocket, sock_t outsocket, count_t seq );
err_t vsEject( sock_t decksocket, sock_t outsocket );
err_t vsEndOfMedia( sock_t decksocket, sock_t outsocket, bool_t* eom );
err_t vsPowerOff( sock_t vs );
char* vsErrorStr( err_t err );
#ifdef __cplusplus
}
#endif

/*
 * Global data filled in by vsPowerOn()
 *
 * Note: it will be reset by each call to vsPowerOn(), so if you're interested
 *       in the contents, and you're making multiple calls to vsPowerOn(),
 *       it's best to make a copy of it.
 */
extern struct servent serv_info;	/* returned from getservbyname() */
extern struct hostent host_info;	/* returned from gethostbyname() */
extern struct sockaddr_in serv_addr;	/* IP server address */

#endif
