/* $Header: /usr/local/src/nvrToMIT/RCS/vtdprot.h,v 1.1 1994/05/10 23:30:04 russ Exp $ */

#ifndef __h_vtdprot__
#define __h_vtdprot__

/*
 * $Id: vtdprot.h,v 1.1 1994/05/10 23:30:04 russ Exp $
 *
 * vtdprot.h
 *
 * Copyright Pencom Software, 1994
 */

#include <Vodoo.h>

#define VS_PROT_FIRST	0
#define VS_PROT_STATUS	1
#define VS_PROT_LOAD	2
#define VS_PROT_PREVIEW	3
#define VS_PROT_PLAY	4
#define VS_PROT_SEEK	5
#define VS_PROT_PAUSE	6
#define VS_PROT_FLOW	7
#define VS_PROT_RETRY	8
#define VS_PROT_EOM	9
#define VS_PROT_EJECT	10
#define VS_PROT_DUMP	11
#define VS_PROT_CATALOG	12
#define VS_PROT_UNKNOWN	13
#define VS_PROT_LAST	14


#define VS_TCPID	"CBRTCP"

#define VS_ADD_ID( buf ) { strncpy( buf.id, VS_TCPID, 8 ); }

struct vtdstatus_t
{	err_t status;
	long errno;
	long type;
#define VS_STAT_GENERIC		0
#define VS_STAT_PAUSE		1
#define VS_STAT_PREVIEW		2
#define VS_STAT_CATALOG		3
	union
	{	offset_t pause_offset;
		struct
		{	long len;
		} preview;
		struct
		{	long len;
		} catalog;
	} data;
};

struct vtdload_t
{	port_t port;
	long netbufsz;
	char file[MAXPATHLEN];
};

struct vtdpreview_t
{	port_t port;
	offset_t offset;
	long len;
};

struct vtdcatalog_t
{	int junk;
};

struct vtdplay_t
{	port_t port;
	speed_t speed;
};

struct vtdseek_t
{	port_t port;
	offset_t offset;
};

struct vtdpause_t
{	port_t port;
};

struct vtdflow_t
{	port_t port;
	count_t nbufs;
};

struct vtdretry_t
{	port_t port;
	count_t seq;
	offset_t offset;
};

struct vtdeom_t
{	port_t port;
};

struct vtdeject_t
{	port_t port;
};

struct vtddump_t
{	char file[MAXPATHLEN];
};

typedef struct vtdprot_t
{	char id[8];	/* should be CBRUDP */
	long type;
	union
	{	struct vtdstatus_t status;
		struct vtdload_t load;
		struct vtdpreview_t preview;
		struct vtdcatalog_t catalog;
		struct vtdplay_t play;
		struct vtdseek_t seek;
		struct vtdpause_t pause;
		struct vtdflow_t flow;
		struct vtdretry_t retry;
		struct vtdeom_t eom;
		struct vtdeject_t eject;
		struct vtddump_t dump;
	} p;
} vtdprot_t;

#ifdef __cplusplus
extern "C" {
#endif
extern size_t vtdprot_sizeof( vtdprot_t* buf );
extern char* vtdprot_type( long type );
#ifdef __cplusplus
}
#endif

#endif
