/* $Header: /usr/local/src/nvrToMIT/RCS/characterize.h,v 1.3 1993/01/22 16:37:07 toddb Exp $ */
#include "types.h"
#include "osio.h"
#include "timer.h"

#define Unroll5(op) op; op; op; op; op;
#define Unroll10(op) Unroll5(op) Unroll5(op)
#define Unroll50(op)	Unroll10(op)				\
			Unroll10(op)				\
			Unroll10(op)				\
			Unroll10(op)				\
			Unroll10(op)
#define Unroll100(op) Unroll10( Unroll10(op) )


#define UnrollIndex10(op, base)					\
    op(base+0); op(base+1); op(base+2); op(base+3);		\
    op(base+4); op(base+5); op(base+6); op(base+7);		\
    op(base+8); op(base+9);

#define UnrollIndex50(op, base)					\
    UnrollIndex10(op, base)					\
    UnrollIndex10(op, base+10)					\
    UnrollIndex10(op, base+20)					\
    UnrollIndex10(op, base+30)					\
    UnrollIndex10(op, base+40)

#define UnrollIndex100(op, base)				\
    UnrollIndex50(op, base+0)					\
    UnrollIndex50(op, base+50)

#define NumCacheMem	(OneMillion*512)	/* 512 million */
#define NumMem		(OneMillion*32)		/* 32 million */
#define NumFAdds	(OneMillion*128)	/* 128 million */
#define NumAdds		(OneMillion*512)	/* 512 million */
#define NumMuls		(OneMillion*128)	/* 128 million */
#define NumDivs		(OneMillion*32)		/* 32 million */
#define OneMillion 	(1000*1000)
#define FourMillion 	(OneMillion*4)
#define ThirtyTwoMillion (OneMillion*32)
#define TenThousand	10000
#define OneThousand	1000
#define OneKilo 	1024
#define OneMega 	(OneKilo*OneKilo)
#define NumCode		(1000)

/* support */
void ShowOpsPerSec();
extern void TimeOp();
extern void HoldFloat();
extern void HoldInt();

/* miscelaneous */
extern long Subroutine();
extern long GetPid();
extern long TimeOfDay();
extern long FrameTimer();
extern long ProfileTimer();

/* floating point */
extern long AddDouble();
extern long AddFloat();
extern long DivDouble();
extern long DivFloat();
extern long MultDouble();
extern long MultFloat();
extern long SubDouble();
extern long SubFloat();

/* integer */
extern long AddInt();
extern long ShiftLL();
extern long SubInt();

/* memory */
extern long LoadByteCache();
extern long LoadByteMem();
extern long StoreByteCache();
extern long StoreByteMem();
extern long LoadShortCache();
extern long LoadShortMem();
extern long StoreShortCache();
extern long StoreShortMem();
extern long LoadLongCache();
extern long LoadLongMem();
extern long StoreLongCache();
extern long StoreLongMem();
extern long LoadDoubleCache();
extern long LoadDoubleMem();
extern long StoreDoubleCache();
extern long StoreDoubleMem();
extern void LoadCode();
extern long RunCode();
extern long SwapRegisterSets1();
extern long SwapRegisterSets2();
extern long SwapRegisterSets3();
extern long SwapRegisterSets4();
extern long SwapRegisterSets5();
extern long SwapRegisterSets6();
extern long SwapRegisterSets7();
extern long SwapRegisterSets8();
extern long SwapRegisterSets9();
