/* $Header: /usr/local/src/nvrToMIT/RCS/memory.c,v 1.2 1992/11/25 18:36:29 toddb Exp $ */
#include "characterize.h"

ULong Memory[ 2 * OneMillion ];

#define NProlog 1
#define NBody	1
#define NEpilog	2

typedef struct {
    long prolog[ NProlog ];
    long body[ NBody ];
    long epilog[ NEpilog ];
    long lastSize;
} FunctionCode;

FunctionCode FuncData = {
    { 0x1000000 },		/* nop */
    { 0x1000000 },		/* nop */
    { 0x81c3e008, 0x1000000 }	/* jmp %o7+0x8; nop */
};

void LoadCode(kbytes)
    long kbytes;
{
    long i, j;
    long bytesUsed = 0;
    ULong *ptr = Memory;

    for (i = 0; i < NProlog; i++)
	*ptr++ = FuncData.prolog[ i ];
    i = (kbytes*1024/sizeof(long))-(NProlog+NEpilog);
    while (i > 0) {
	for (j = 0; j < NBody; j++, i--)
	    *ptr++ = FuncData.body[ j ];
    }
    for (i = 0; i < NEpilog; i++)
	*ptr++ = FuncData.epilog[ i ];
    FuncData.lastSize = (kbytes * 1024) / sizeof(long);
}

long RunCode(nops)
    long nops;
{
    IntFuncPtr code = (IntFuncPtr)Memory;

    while (--nops > 0)
	(*code)();
    return (FuncData.lastSize);
}

long SwapRegisterSets1(nops)
    long nops;
{
    int i, j;

    for (i = nops; i > 0; i -= OneMillion) {
	for (j = OneMillion/100; j > 0; j--) {
	    Unroll100(asm volatile ("save %sp,-112,%sp; restore"))
	}
    }
    return(2);
}

long SwapRegisterSets2(nops)
    long nops;
{
    int i, j;

    for (i = nops; i > 0; i -= OneMillion) {
	for (j = OneMillion/100; j > 0; j--) {
	    Unroll100(asm ("save %sp,-112,%sp");
		      asm ("save %sp,-112,%sp");
		      asm ("restore");
		      asm ("restore");
	    )
	}
    }
    return(4);
}

long SwapRegisterSets3(nops)
    long nops;
{
    int i, j;

    for (i = nops; i > 0; i -= OneMillion) {
	for (j = OneMillion/100; j > 0; j--) {
	    Unroll100(asm ("save %sp,-112,%sp");
		      asm ("save %sp,-112,%sp");
		      asm ("save %sp,-112,%sp");
		      asm ("restore");
		      asm ("restore");
		      asm ("restore");
	    )
	}
    }
    return(6);
}

long SwapRegisterSets4(nops)
    long nops;
{
    int i, j;

    for (i = nops; i > 0; i -= OneMillion) {
	for (j = OneMillion/100; j > 0; j--) {
	    Unroll100(asm ("save %sp,-112,%sp");
		      asm ("save %sp,-112,%sp");
		      asm ("save %sp,-112,%sp");
		      asm ("save %sp,-112,%sp");
		      asm ("restore");
		      asm ("restore");
		      asm ("restore");
		      asm ("restore");
	    )
	}
    }
    return(8);
}

long SwapRegisterSets5(nops)
    long nops;
{
    int i, j;

    for (i = nops; i > 0; i -= OneMillion) {
	for (j = OneMillion/100; j > 0; j--) {
	    Unroll100(asm ("save %sp,-112,%sp");
		      asm ("save %sp,-112,%sp");
		      asm ("save %sp,-112,%sp");
		      asm ("save %sp,-112,%sp");
		      asm ("save %sp,-112,%sp");
		      asm ("restore");
		      asm ("restore");
		      asm ("restore");
		      asm ("restore");
		      asm ("restore");
	    )
	}
    }
    return(10);
}

long SwapRegisterSets6(nops)
    long nops;
{
    int i, j;

    for (i = nops; i > 0; i -= OneMillion) {
	for (j = OneMillion/100; j > 0; j--) {
	    Unroll100(asm ("save %sp,-112,%sp");
		      asm ("save %sp,-112,%sp");
		      asm ("save %sp,-112,%sp");
		      asm ("save %sp,-112,%sp");
		      asm ("save %sp,-112,%sp");
		      asm ("save %sp,-112,%sp");
		      asm ("restore");
		      asm ("restore");
		      asm ("restore");
		      asm ("restore");
		      asm ("restore");
		      asm ("restore");
	    )
	}
    }
    return(12);
}

long SwapRegisterSets7(nops)
    long nops;
{
    int i, j;

    for (i = nops; i > 0; i -= OneMillion) {
	for (j = OneMillion/100; j > 0; j--) {
	    Unroll100(asm ("save %sp,-112,%sp");
		      asm ("save %sp,-112,%sp");
		      asm ("save %sp,-112,%sp");
		      asm ("save %sp,-112,%sp");
		      asm ("save %sp,-112,%sp");
		      asm ("save %sp,-112,%sp");
		      asm ("save %sp,-112,%sp");
		      asm ("restore");
		      asm ("restore");
		      asm ("restore");
		      asm ("restore");
		      asm ("restore");
		      asm ("restore");
		      asm ("restore");
	    )
	}
    }
    return(14);
}

long SwapRegisterSets8(nops)
    long nops;
{
    int i, j;

    for (i = nops; i > 0; i -= OneMillion) {
	for (j = OneMillion/100; j > 0; j--) {
	    Unroll100(asm ("save %sp,-112,%sp");
		      asm ("save %sp,-112,%sp");
		      asm ("save %sp,-112,%sp");
		      asm ("save %sp,-112,%sp");
		      asm ("save %sp,-112,%sp");
		      asm ("save %sp,-112,%sp");
		      asm ("save %sp,-112,%sp");
		      asm ("save %sp,-112,%sp");
		      asm ("restore");
		      asm ("restore");
		      asm ("restore");
		      asm ("restore");
		      asm ("restore");
		      asm ("restore");
		      asm ("restore");
		      asm ("restore");
	    )
	}
    }
    return(16);
}

long SwapRegisterSets9(nops)
    long nops;
{
    int i, j;

    for (i = nops; i > 0; i -= OneMillion) {
	for (j = OneMillion/100; j > 0; j--) {
	    Unroll100(asm ("save %sp,-112,%sp");
		      asm ("save %sp,-112,%sp");
		      asm ("save %sp,-112,%sp");
		      asm ("save %sp,-112,%sp");
		      asm ("save %sp,-112,%sp");
		      asm ("save %sp,-112,%sp");
		      asm ("save %sp,-112,%sp");
		      asm ("save %sp,-112,%sp");
		      asm ("save %sp,-112,%sp");
		      asm ("restore");
		      asm ("restore");
		      asm ("restore");
		      asm ("restore");
		      asm ("restore");
		      asm ("restore");
		      asm ("restore");
		      asm ("restore");
		      asm ("restore");
	    )
	}
    }
    return(18);
}

long StoreDoubleMem(nops)
    long nops;
{
  int i, j;
  OctWord val;
  OctWord *ptr;

  for (i = nops; i > 0; i -= OneMillion) {
    ptr = (OctWord *)Memory;
    for (j = OneMillion/100; j > 0; j--) {
      ptr[0]=val; ptr[1]=val; ptr[2]=val; ptr[3]=val; ptr[4]=val;
      ptr[5]=val; ptr[6]=val; ptr[7]=val; ptr[8]=val; ptr[9]=val;
      ptr[10]=val; ptr[11]=val; ptr[12]=val; ptr[13]=val; ptr[14]=val;
      ptr[15]=val; ptr[16]=val; ptr[17]=val; ptr[18]=val; ptr[19]=val;
      ptr[20]=val; ptr[21]=val; ptr[22]=val; ptr[23]=val; ptr[24]=val;
      ptr[25]=val; ptr[26]=val; ptr[27]=val; ptr[28]=val; ptr[29]=val;
      ptr[30]=val; ptr[31]=val; ptr[32]=val; ptr[33]=val; ptr[34]=val;
      ptr[35]=val; ptr[36]=val; ptr[37]=val; ptr[38]=val; ptr[39]=val;
      ptr[40]=val; ptr[41]=val; ptr[42]=val; ptr[43]=val; ptr[44]=val;
      ptr[45]=val; ptr[46]=val; ptr[47]=val; ptr[48]=val; ptr[49]=val;
      ptr[50]=val; ptr[51]=val; ptr[52]=val; ptr[53]=val; ptr[54]=val;
      ptr[55]=val; ptr[56]=val; ptr[57]=val; ptr[58]=val; ptr[59]=val;
      ptr[60]=val; ptr[61]=val; ptr[62]=val; ptr[63]=val; ptr[64]=val;
      ptr[65]=val; ptr[66]=val; ptr[67]=val; ptr[68]=val; ptr[69]=val;
      ptr[70]=val; ptr[71]=val; ptr[72]=val; ptr[73]=val; ptr[74]=val;
      ptr[75]=val; ptr[76]=val; ptr[77]=val; ptr[78]=val; ptr[79]=val;
      ptr[80]=val; ptr[81]=val; ptr[82]=val; ptr[83]=val; ptr[84]=val;
      ptr[85]=val; ptr[86]=val; ptr[87]=val; ptr[88]=val; ptr[89]=val;
      ptr[90]=val; ptr[91]=val; ptr[92]=val; ptr[93]=val; ptr[94]=val;
      ptr[95]=val; ptr[96]=val; ptr[97]=val; ptr[98]=val; ptr[99]=val;
      ptr += 100;
    }
  }
  return (1);
}

long StoreDoubleCache(nops)
    long nops;
{
    int i;
    OctWord val;
    OctWord *ptr = (OctWord *)Memory;

    for (i = nops; i > 0; i -= 100) {
        Unroll100(
	    asm volatile ("std %0,[%1]" : "=r" (val) : "r" (ptr));
	)
    }
    return (1);
}

long LoadDoubleMem(nops)
    long nops;
{
    int i, j;
    OctWord i1, i2;
    OctWord *ptr;

    for (i = nops; i > 0; i -= OneMillion) {
	ptr = (OctWord *)Memory;
	for (j = OneMillion/100; j > 0; j--) {
#           include "ldd.inc"
	    ptr += 100;
	}
    }
    return (1);
}

long LoadDoubleCache(nops)
    long nops;
{
    int i;
    OctWord i1, i2;
    OctWord *ptr = (OctWord *)Memory;

    for (i = nops; i > 0; i -= 100) {
        Unroll50(
	    asm volatile ("ld [%1],%0" : "=r" (i1) : "r" (ptr));
	    asm volatile ("ld [%1],%0" : "=r" (i2) : "r" (ptr))
	)
    }
    return (1);
}

long StoreLongMem(nops)
    long nops;
{
  int i, j;
  long i1, i2;
  ULong *ptr;

#define storePtr(i)	ptr[i] = i1

    for (i = nops; i > 0; i -= OneMillion) {
	ptr = Memory;
	for (j = OneMillion/100; j > 0; j--) {
	    UnrollIndex100(storePtr, 0)
	    ptr += 100;
	}
    }
  return (1);

#undef storePtr
}

long StoreLongCache(nops)
    long nops;
{
    int i;
    long i1, i2;
    long *ptr = Memory;

    for (i = nops; i > 0; i -= 100) {
        Unroll50(
	    asm volatile ("st %0,[%1]" : "=r" (i1) : "r" (ptr));
	    asm volatile ("st %0,[%1]" : "=r" (i2) : "r" (ptr))
	)
    }
    return (1);
}

long LoadLongMem(nops)
    long nops;
{
    int i, j;
    long i1, i2;
    long *ptr;

    for (i = nops; i > 0; i -= OneMillion) {
	ptr = Memory;
	for (j = OneMillion/100; j > 0; j--) {
#           include "ld.inc"
	    ptr += 100;
	}
    }
    return (1);
}

long LoadLongCache(nops)
    long nops;
{
    int i;
    long i1, i2;
    volatile long *ptr = Memory;

    for (i = nops; i > 0; i -= 100) {
	Unroll50(i1 = ptr[0]; i2 = ptr[0])
    }
    return (1);
}

long StoreShortMem(nops)
    long nops;
{
    int i, j;
    UShort i1, i2;
    UShort *ptr;

#define storePtr(i)	ptr[i] = i1

    for (i = nops; i > 0; i -= OneMillion) {
	ptr = (UShort *)Memory;
	for (j = OneMillion/100; j > 0; j--) {
	    UnrollIndex100(storePtr, 0)
	    ptr += 100;
	}
    }
  return (1);

#undef storePtr
}

long StoreShortCache(nops)
    long nops;
{
    int i;
    UShort i1, i2;
    volatile UShort *ptr = (UShort *)Memory;

    for (i = nops; i > 0; i -= 100) {
	Unroll50(*ptr = i1; *ptr = i2)
    }
    return (1);
}

long LoadShortMem(nops)
    long nops;
{
    int i, j;
    UShort i1, i2;
    volatile UShort *ptr;

#define storePtr(i)	ptr[i] = i1

    for (i = nops; i > 0; i -= OneMillion) {
	ptr = (UShort *)Memory;
	for (j = OneMillion/100; j > 0; j--) {
	    UnrollIndex100(storePtr, 0)
	    ptr += 100;
	}
    }
  return (1);

#undef storePtr
}

long LoadShortCache(nops)
    long nops;
{
    int i;
    UShort i1, i2;
    volatile UShort *ptr = (UShort *)Memory;

    for (i = nops; i > 0; i -= 100) {
	Unroll50( i1 = ptr[0]; i2 = ptr[0] )
    }
    return (1);
}

long StoreByteMem(nops)
    long nops;
{
  int i, j;
  UChar i1, i2;
  UChar *ptr;

#define storePtr(i)	ptr[i] = i1

    for (i = nops; i > 0; i -= OneMillion) {
	ptr = (UChar *)Memory;
	for (j = OneMillion/100; j > 0; j--) {
	    UnrollIndex100(storePtr, 0)
	    ptr += 100;
	}
    }
  return (1);

#undef storePtr
}

long StoreByteCache(nops)
    long nops;
{
    int i;
    UChar i1, i2;
    volatile UChar *ptr = (UChar *)Memory;

    for (i = nops; i > 0; i -= 100) {
	Unroll50(*ptr = i1; *ptr = i2)
    }
    return (1);
}

long LoadByteMem(nops)
    long nops;
{
    int i, j;
    UChar i1, i2;
    volatile UChar *ptr;

#define loadPtr(i)	i1 = ptr[i];

    for (i = nops; i > 0; i -= OneMillion) {
	ptr = (UChar *)Memory;
	for (j = OneMillion/100; j > 0; j--) {
	    UnrollIndex100(loadPtr, 0)
	    ptr += 100;
	}
    }
    return (1);

#undef loadPtr
}

long LoadByteCache(nops)
    long nops;
{
    int i;
    UChar i1, i2;
    volatile UChar *ptr = (UChar *)Memory;

    for (i = nops; i > 0; i -= 100) {
	Unroll50( i1 = ptr[0]; i2 = ptr[0] )
    }
    return (1);
}
