/* @(#)$Header: /u5/alt/tools/src/cscope/RCS/constants.h,v 1.3 1991/10/29 18:05:37 marvinw Exp $ */
/*	Copyright (c) 1984, 1985, 1986, 1987 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

/*	cscope - interactive C symbol cross-reference
 *
 *	preprocessor constant definitions
 */

#define ctrl(x)	(x & 037)	/* control character macro */

/* fast string equality tests (avoids most strcmp() calls) */
#define	strequal(s1, s2)	(*(s1) == *(s2) && strcmp(s1, s2) == 0)
#define	strnotequal(s1, s2)	(*(s1) != *(s2) || strcmp(s1, s2) != 0)

/* set the mark character for searching the cross-reference file */
#define	setmark(c)	(blockmark = c, block[blocklen] = blockmark)

/* get the next character in the cross-reference */
/* note that blockp is assumed not to be null */
#define	getrefchar()	(*(++blockp + 1) == '\0' ? (blockp = readblock()) : 0, *blockp)

#define	ESC	'\033'		/* escape character */
#define	MSGLEN	80		/* displayed message length */
#define	NUMLEN	5		/* line number length */
#define	PATHLEN	250		/* file pathname length */
#define	PATLEN	80		/* symbol pattern length */
#define	REFFILE	"cscope.out"	/* cross-reference output file */
#define	NAMEFILE "cscope.files"	/* default list-of-files file */
#define	READ	4		/* access(2) parameter */
#define	WRITE	2		/* access(2) parameter */

/* scanner constants */
#define	SYMBOLMAX	100	/* maximum symbols in a source line */
#define	LINEMAX		1000	/* maximum source line length */
#define TOKENMAX	30	/* maximum non-string token length */
#undef	YYLMAX		
#define YYLMAX		LINEMAX + TOKENMAX	/* scanner line buffer size */

/* cross-reference file mark characters (only significant after a tab char) */
#define	DEFINE	'#'
#define FCNCALL	'`'
#define FCNDEF	'$'
#define	INCLUDE	'~'
#define NEWFILE	'@'

/* other scanner token types */
#define LEX_EOF	0
#define	IDENT	2
#define	KEYWORD	3
#define	NEWLINE	4

/* screen lines */
#define	FLDLINE	(LINES - FIELDS - 1)	/* first input field line */
#define	MSGLINE	0			/* message line */
#define	PRLINE	(LINES - 1)		/* input prompt line */
#define REFLINE	3			/* first displayed reference line */

/* input fields (value matches field order on screen) */
#define	SYMBOL		0
#define DEFINITION	1
#define	CALLEDBY	2
#define	CALLING		3
#define	STRING		4
#define	CHANGE		5
#define	REGEXP		6
#define FILENAME	7
#define INCLUDES	8
#define	FIELDS		9

#if BSD || UNIXPC
#define TERMINFO	0	/* no terminfo curses */
#else
#define TERMINFO	1
#endif

#if !TERMINFO
#define	KEY_BREAK	0400	/* easier to define than to add #if around the use */
#define	KEY_ENTER	0401
#define	KEY_BACKSPACE	0402

#ifndef cbreak
#define cbreak()	crmode()			/* name change */
#endif

#if UNIXPC
#define	erasechar()	(_tty.c_cc[VERASE])		/* equivalent */
#define	killchar()	(_tty.c_cc[VKILL])		/* equivalent */
#else
#ifndef erasechar
#define	erasechar()	(_tty.sg_erase)			/* equivalent */
#endif
#ifndef killchar
#define	killchar()	(_tty.sg_kill)			/* equivalent */
#endif
#endif
#endif
