/*	Copyright (c) 1984, 1985, 1986, 1987 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

/*	cscope - interactive C symbol cross-reference
 *
 *	display help
 */

/*
 * $Header: /u5/alt/tools/src/cscope/RCS/help.c,v 1.3 1989/11/21 17:04:01 kimr Exp $
 *
 * $Log: help.c,v $
 * Revision 1.3  1989/11/21  17:04:01  kimr
 * Made to page with window size and updated contents.
 *
 * Revision 1.2  89/07/21  18:08:40  kimr
 * Changed "edit all lines" to "edit all files containing displayed lines".
 * 
 *
 */

#include "global.h"

static int linesdisplayed;

/* 
 * helpstr should be called once for each line to be displayed so it
 * can keep track of the linecount without having to scan for newlines.
 */

void helpstr(str)
    char *str;
{   
    addstr(str);
    /* 
     * If strlen(str) > COLS increment linecount to account for wrap 
     * Throw new page if we get within 3 of the bottom, since we don't
     * know whether a third-to-last line would wrap or not.
     */
    linesdisplayed += (strlen(str) - 3)/COLS; /* also account for "\n\r" */
    if (++linesdisplayed >= (LINES - 3)) {
	if (linesdisplayed == (LINES - 3)) {
	    addch('\n'); /* make prompt appear on last line */
	}
	linesdisplayed = 0;
	addstr("\nType any character to continue: ");
	refresh();
	mygetch();
	clear();
    }
}

void
help()
{
	linesdisplayed = 0;
	if (changing == NO) {
		if (mouse == YES) {
		helpstr("Point with the mouse and click button 1 to move to the desired input field,\n\r");
		helpstr("type the pattern to search for, and then press the RETURN key.\n\r");
		helpstr("If the search is successful, you can edit the file containing a displayed line\n\r");
		helpstr("by pointing with the mouse and clicking button 1.\n\r");
		helpstr("\nYou can either use the button 2 menu or these single-character commands:\n\r");
		helpstr("\n\r");
		}
		else {
		helpstr("Use the TAB, ^N, and ^P keys to move to the desired input field,\n\r");
		helpstr("type the pattern to search for, and then press the RETURN key.\n\r");
		helpstr("If the search is successful, you can use these single-character commands:\n\r");
		helpstr("\n\r");
		helpstr("1-9         Edit the file containing the displayed line.\n\r");
		}
		helpstr("space bar   Display next lines.\n\r");
		helpstr("+           Display next lines.\n\r");
		helpstr("-           Display previous lines.\n\r");
		helpstr("^E          Edit all files containing displayed lines.\n\r");
		helpstr(">           Append all lines to a file.\n\r");
		if (mouse == NO) {
		helpstr("\n\r");
		helpstr("At any time you can use these single-character commands:\n\r");
		helpstr("\n\r");
		}
		helpstr(".           Search with the last pattern typed.\n\r");
		helpstr("!           Start an interactive shell (type ^D to return to cscope).\n\r");
		helpstr("?           Display this list of commands.\n\r");
		helpstr("ESC         Cancel current input or text change operation.\n\r");
		helpstr("^A          Toggle function name abbreviation.\n\r");
		helpstr("^C          Cancel search.\n\r");
		helpstr("^D          Exit cscope.\n\r");
		helpstr("^F          Toggle file name expansion.\n\r");
		helpstr("^L          Redraw the screen.\n\r");
		helpstr("^R          Rebuild the cross-reference.\n\r"); 
		helpstr("^T          Toggle display of return types for function definitions.\n\r");
		helpstr("\n\r");
		helpstr("Note: If the first character of the pattern you want to search for matches\n\r");
		helpstr("a command, type a \\ character first.\n\r");
	}
	else {
		if (mouse == YES) {
		helpstr("Point with the mouse and click button 1 to mark or unmark the line to be\n\r");
		helpstr("changed.  You can also use the button 2 menu or these single-character\n\r");
		helpstr("commands:\n\r");
		helpstr("\n\r");
		}
		else {
		helpstr("When changing text, you can use these single-character commands:\n\r");
		helpstr("\n\r");
		helpstr("1-9         Mark or unmark the line to be changed.\n\r");
		}
		helpstr("*           Mark or unmark all displayed lines to be changed.\n\r");
		helpstr("space bar   Display next lines.\n\r");
		helpstr("+           Display next lines.\n\r");
		helpstr("-           Display previous lines.\n\r");
		helpstr("a           Mark or unmark all lines to be changed.\n\r");
		helpstr("^D          Change the marked lines and exit.\n\r");
		helpstr("ESC         Exit without changing the marked lines.\n\r");
		helpstr("!           Start an interactive shell (type ^D to return to cscope).\n\r");
		helpstr("^L          Redraw the screen.\n\r");
		helpstr("?           Display this list of commands.\n\r");
	}
}
