#ifndef LINT
#ifdef RCS_ID
static char *rcsid = "@(#)$Header: /u5/alt/tools/src/cscope/RCS/lookup.c,v 1.4 1991/10/29 18:06:24 marvinw Exp $";
#endif /* RCS_ID */
#endif /* LINT */
/*	Copyright (c) 1984, 1985, 1986, 1987 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

/*	cscope - interactive C symbol cross-reference
 *
 *	keyword look-up routine for the C symbol scanner
 */

#include "global.h"

/* this table is also used for keyword text compression */
/* note:some keywords are deleted so the compressed char for "while" is < ' ' */

/* 10/25/89 (KLR) In order to parse function definitions in classes, I had to
 * add "class" as a keyword.  It turns out that the table is zero-origin,
 * so TAB and NL were in the wrong slots; double mapped to NL.  I put in
 * class before TAB and commented out "double".  These changes require
 * updating the file format version to "9".
 */

struct	keystruct keyword[] = {
	"#define",	' ',	NULL,	/* must be the 1st table entry */
	"#include",	' ',	NULL,	/* must be the 2nd table entry */
/*	"auto",		' ',	NULL,	*/
	"break",	'\0',	NULL,	/* rarely in cross-reference */
	"case",		' ',	NULL,
	"char",		' ',	NULL,
	"class",	' ',	NULL,
	"continue",	'\0',	NULL,	/* rarely in cross-reference */
	"default",	'\0',	NULL,	/* rarely in cross-reference */
	"do",		'\0',	NULL,
	"\t",		'\0',	NULL,	/* must be the 10th table entry */
	"\n",		'\0',	NULL,	/* must be the 11th table entry */
/*	"double",	' ',	NULL,  */
	"else",		' ',	NULL,
	"enum",		' ',	NULL,
	"extern",	' ',	NULL,
	"float",	' ',	NULL,
	"for",		'(',	NULL,
/*	"fortran",	' ',	NULL,	*/
	"goto",		' ',	NULL,
	"if",		'(',	NULL,
	"int",		' ',	NULL,
	"long",		' ',	NULL,
	"register",	' ',	NULL,
	"return",	'\0',	NULL,
	"short",	' ',	NULL,
	"sizeof",	'\0',	NULL,
	"static",	' ',	NULL,
	"struct",	' ',	NULL,
	"switch",	'(',	NULL,
	"typedef",	' ',	NULL,
	"union",	' ',	NULL,
	"unsigned",	' ',	NULL,
	"void",		' ',	NULL,
	"while",	'(',	NULL,
};
#define KEYWORDS	(sizeof(keyword) / sizeof(struct keystruct))

#define HASHSIZE	(KEYWORDS * 2 + 1)

static	struct	keystruct *hashtab[HASHSIZE]; /* pointer table */

/* put the keywords into the symbol table */
void
init_symtab()
{
	register int	i;
	
	for (i = 0; i < KEYWORDS; ++i) {
		hashlink(&keyword[i]);
	}
}

/* see if this identifier is a keyword */
int
lookup(ident)
register char	*ident;
{
	register struct	keystruct *p;
	
	/* look up the identifier in the keyword table */
	for (p = hashtab[hash(ident)]; p != NULL; p = p->next) {
		if (strequal(ident, p->text)) {
			if (compress == YES) {
				ident[0] = p - keyword;	/* compress the keyword */
			}
			return(KEYWORD);
		}
	}
	/* this is an identifier */
	return(IDENT);
}

/* link to hash table */
static	int
hashlink(p)
register struct	keystruct *p;
{
	register int	hashval;
	
	hashval = hash(p->text);
	p->next = hashtab[hashval];
	hashtab[hashval] = p;
}

/* form hash value for string */
static	int
hash(s)
register char	*s;
{
	register int	hashval;
	
	for (hashval = 0; *s != '\0'; )
		hashval += *s++;
	return(hashval % HASHSIZE);
}
