/*	Copyright (c) 1984, 1985, 1986, 1987 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

/* vpinit - initialize vpdirs or update vpdirs based on currentdir */

#include <stdio.h>	/* stderr */
/*
 * $Header: /u5/alt/tools/src/cscope/RCS/vpinit.c,v 1.2 1989/07/18 17:25:58 kimr Exp $
 *
 * $Log: vpinit.c,v $
 * Revision 1.2  1989/07/18  17:25:58  kimr
 * Made a pass at cleaning up lint errors and added RCS headers.
 *
 *
 */

#include "vp.h"

char	**vpdirs;	/* directories (including current) in view path */
int	vpndirs;	/* number of directories in view path */

extern	char	*argv0;	/* command name (must be set in main function) */

vpinit(currentdir)
char	*currentdir;
{
	char	buf[MAXPATH + 1];
	char	*suffix;		/* path from view path node */
	char	*getenv(), *getwd(), *mymalloc(), *strcat(), *strcpy(), *stralloc();
	void	free();
	
	/* if an existing directory list is to be updated, free it */
	if (currentdir != NULL && vpndirs > 0) {
		register int	i;

		for (i = 0; i < vpndirs; ++i) {
			free(vpdirs[i]);
		}
		free((char *) vpdirs);
		vpndirs = 0;
	}
	/* if the directory list is empty */
	if (vpndirs == 0) {
		register int	i;
		register char	*s, *vpath;
		
		/* check for a view path */
		if ((vpath = getenv("VPATH")) != NULL) {
		
			/* if not given, get the current directory name */
			if (currentdir == NULL && (currentdir = getwd(buf)) == NULL) {
				fprintf(stderr, "%s: warning: cannot get current directory name\n", argv0);
				return;
			}
			/* see if this directory is in the first view path node */
			for (i = 0; vpath[i] == currentdir[i] && vpath[i] != '\0'; ++i) {
				;
			}
			if ((vpath[i] != ':' && vpath[i] != '\0') ||
			    (currentdir[i] != '/' && currentdir[i] != '\0')) {
				return;
			}
			suffix = &currentdir[i];

			/* count the nodes in the view path */
			vpndirs = 1;
			for (i = 0; vpath[i] != '\0'; ++i) {
				if (vpath[i] == ':') {
					++vpndirs;
				}
			}
			/* create the source directory list */
			vpdirs = (char **) mymalloc(vpndirs * sizeof(char *));
			
			/* don't change VPATH in environment */
			vpath = stralloc(vpath);
			
			/* split the view path into nodes */
			for (i = 0, s = vpath; *s != '\0'; ++i) {
				vpdirs[i] = s;
				while (*s != '\0' && *++s != ':') {
					if (*s == '\n') {
						*s = '\0';
					}
				}
				if (*s != '\0') {
					*s++ = '\0';
				}
			}
			/* convert the view path nodes to directories */
			for (i = 0; i < vpndirs; ++i) {
				s = mymalloc((unsigned) (strlen(vpdirs[i]) + 
					strlen(suffix) + 1));
				(void) strcpy(s, vpdirs[i]);
				(void) strcat(s, suffix);
				vpdirs[i] = s;
			}
			free(vpath);
		}
	}
}
