/*
 * Copyright (c) 1992, 1993, 1994 North Valley Research, Inc.
 * Confidential -- All proprietary rights reserved.
 * Licensed Material -- Property of North Valley Research, Inc.
 *
 * This program is the property of North Valley Research, Inc. or others
 * from whom North Valley Research has obtained a licensing right, and is
 * considered by North Valley Research to be confidential.  It is protected
 * by U.S. copyright law as an unpublished work and is
 * furnished pursuant to a written license agreement.  It may
 * not be used, copied or otherwise reproduced, or disclosed to
 * others except in accordance with the terms and conditions of
 * that agreement.
 *
 * NAME
 *	testlm.c - test license manager functionality
 *
 * $Header: /usr/local/src/nvrToMIT/RCS/testlm.c,v 1.4 1994/06/30 23:06:07 toddb Exp $
 */
#include "NvrLmFeatures.h"
#include "nvrAlloc.h"

char *ProgramName;
LmConfig LmConfigData;

/* ARGSUSED */
static void
LicenseExceptionCB(int condition,
                   char *feature)
{
    NvrLicenseError(condition, &LmConfigData, True);
}

main(int argc, char **argv)
{
    int nFeatures;
    int code, i;
    boolean exitAfterLic = False;

    ProgramName = argv[0];

    LmConfigData.features = (FeatureName *)
	SecureAlloc(sizeof(FeatureName) * argc);
    LmConfigData.doHeartbeat = True;
    LmConfigData.shared = False;
    LmConfigData.exceptionCB = LicenseExceptionCB;

    nFeatures = 0;
    for (i = 1; i < argc; i++) {
	if (strcmp(argv[i], "-share") == 0)
	    LmConfigData.shared = True;
	else if (strcmp(argv[i], "-exit") == 0)
	    exitAfterLic = True;
	else {
	    strcpy(LmConfigData.features[ nFeatures ], argv[i]);
	    nFeatures++;
	}
    }
    LmConfigData.features[ nFeatures ][0] = '\0';
    if (nFeatures == 0)
	Fatal("Usage: %s [-share] feature [feature...]\n");

    if (LmConfigData.shared)
	ProgMsg("sharing licenses...\n");
    code = NvrGetLicense(&LmConfigData);

    if (code < 0) {
	NvrLicenseError(code, &LmConfigData, False);
	Fatal("can't get license\n");	/* this tests the Fatal handler func */
    }

    ProgMsg("got %s\n", LmConfigData.featureUsed);
    if (! exitAfterLic) {
	for (;;)
	    pause();
    }
    NvrLmExit(0);
}
