/* $Header: /usr/local/src/nvrToMIT/RCS/rlocks.c,v 1.4 1995/04/12 22:53:31 russ Exp $ */
#include	<stdio.h>
#include	<sys/types.h>
#include	<sys/stat.h>
#include	<sys/time.h>
#include	<ctype.h>

#define	FALSE	0
#define	TRUE	1

char	*locked();
char	*findrcsfile();
char	*strrchr();
FILE	*popen();

main(argc, argv)
	int	argc;
	char	**argv;
{
	int	args = FALSE;
	int	locks = 0;

	for (argc--, argv++; argc; argc--, argv++)
	{
		args = TRUE;
		if (isdirectory(*argv))
			locks += peruse(*argv);
		else
			locks += examine(*argv);
	}
	if (!args)
		locks += peruse(".");
	exit(locks == 0);
}

peruse(directory)
	char	*directory;
{
	FILE	*pfd;
	char	buf[ BUFSIZ ];
	int	locks = 0;

	sprintf(buf, "find %s -type f -name '*,v' -print", directory);

	if ((pfd = popen(buf, "r")) == NULL)
		log_fatal("cannot run \"%s\"\n", buf);

	while (fgets(buf, BUFSIZ, pfd))
	{
		buf[ strlen(buf) - 1 ] = '\0';
		locks += examine(buf);
	}
	return(locks);
}

examine(path)
	char	*path;
{
	char	*revfile,
		*p,
		*locker,
		buf[ BUFSIZ ];
	FILE	*fd;

	revfile = findrcsfile(path);

	if ((fd = fopen(revfile, "r")) == NULL)
		return(FALSE);

	while (fgets(buf, BUFSIZ, fd))
	{
		if (! lockline(buf))
			continue;
		if (locker = locked(buf, fd))
			displaylock(locker, path, revfile);
		break;
	}
	fclose(fd);
	return(locker != NULL);
}

char *findrcsfile(path)
	char	*path;
{
	static char	buf[ BUFSIZ ];
	char	*p;
			
	if (suffix(path, ",v"))
		return(path);

	p = strrchr(path, '/');

	/*
	 * First check the same directory
	 */
	if (p == NULL)
		sprintf(buf, "%s,v", path);
	else
	{
		*p++ = '\0';
		sprintf(buf, "%s/%s,v", path, p);
		*(p-1) = '/';
	}
	if (exists(buf))
		return(buf);

	/*
	 * Then check the RCS subdirectory.
	 */
	if (p == NULL)
		sprintf(buf, "RCS/%s,v", path);
	else
	{
		*p++ = '\0';
		sprintf(buf, "%s/RCS/%s,v", path, p);
		*(p-1) = '/';
	}

	if (exists(buf))
		return(buf);
	return(NULL);
}

lockline(line)
	char	*line;
{
	if (strncmp(line, "locks", 5) != 0)
		return(FALSE);
	return(TRUE);
}
	
char *locked(line, fd)
	char    *line;
	FILE *fd;
{
	char	*locker = NULL;
	char	*pline = line;

	if (! lockline(pline))
		return(FALSE);

	for (pline+=5; *pline == ' ' || *pline == '\t'; pline++)
		;

	if (*pline == ';')
		return(FALSE);
	if (*pline == '\n') {
		if (fgets(pline = line, BUFSIZ, fd) == NULL)
			return FALSE;
		while (*pline == ' ' || *pline == '\t')
			pline++;
	}
	locker = pline;
	while (isalnum(*pline))
		pline++;
	*pline = '\0';
	return(locker);
}

displaylock(locker, path, revfile)
	char	*locker,
		*path,
		*revfile;
{
	char	*pathtoshow;
	static int	firsttime = TRUE;
	struct tm	*date;
	int	time;

	if (path == revfile || exists(path))
		pathtoshow = path;
	else
		pathtoshow = revfile;
		
	if (firsttime)
	{
		printf("%-10s %13s   %s\n", "user", "when locked", "file");
		firsttime = FALSE;
	}
	time = modtime(revfile);
	date = localtime( &time );
	printf("%-10s %2d/%.2d/%.2d %2d:%.2d  %s\n",
		locker,
		date->tm_mon+1, date->tm_mday, date->tm_year,
		date->tm_hour, date->tm_min,
		pathtoshow);
}

log_fatal(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9)
{
	extern int	errno;

	if (errno)
		perror("rlocks");
	fprintf(stderr, x0,x1,x2,x3,x4,x5,x6,x7,x8,x9);
	exit(1);
}

suffix(path, end)
	char	*path,
		*end;
{
	char	*p = path + strlen(path) - strlen(end);

	return(strcmp(p, end) == 0);
}


struct stat	statb;
char	lastpath[ BUFSIZ ];

getstat(path)
	char	*path;
{
	if (strcmp(lastpath, path) == 0)
		return(TRUE);
	if (stat(path, &statb) == -1)
		return(FALSE);
	strcpy(lastpath, path);
	return(TRUE);
}

isdirectory(path)
	char	*path;
{
	if (! getstat(path))
		return (FALSE);

	if ((statb.st_mode & S_IFMT) == S_IFDIR)
		return(TRUE);
	return(FALSE);
}

exists(path)
	char    *path;
{
	return( getstat(path) );
}

modtime(path)
	char    *path;
{
	if (! getstat(path))
		return (-1);

	return(statb.st_mtime);
}
