/*
 * Copyright 1990 by Tektronix, Inc., Beaverton, Oregon, and
 * the Massachusetts Institute of Technology, Cambridge, Massachusetts.
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the names of Tektronix or M.I.T. not be used in
 * advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.  Tektronix and M.I.T. make no
 * representations about the suitability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 *
 * TEKTRONIX AND M.I.T. DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
 * IN NO EVENT SHALL TEKTRONIX OR M.I.T. BE LIABLE FOR ANY SPECIAL, INDIRECT
 * OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
 * USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *
 * $Header: /usr/local/src/nvrToMIT/RCS/minivas.h,v 1.2 1991/10/09 18:32:10 bobe Exp $
 */

/*
 * Definitions for command
 */
#define MINIVAS_RECORD_VIFC	0x50	/* setup VIFC recording */
#define MINIVAS_RECORD_TC	0x58	/* setup SMPTE timecode recording */
#define	MINIVAS_GRAB_VIFC	0x47	/* setup VIFC frame grabbing */
#define	MINIVAS_GRAB_TC		0x67	/* setup SMPTE timecode grabbing */
#define MINIVAS_FIELD_1_SEARCH	0x5f	/* Set field-1 search */
#define MINIVAS_FIELD_2_SEARCH	0x5f	/* Set field-2 search */
#define MINIVAS_SEARCH_FRAME	0x46	/* SEARCH to Frame code */
#define MINIVAS_SEARCH_TCODE	0x54	/* SEARCH to Time code */
#define MINIVAS_PLAY_FRAMES	0x66	/* Play (start frame to stop frame) */
#define MINIVAS_PLAY_TCODES	0x74	/* Play (start TCode to stop TCode) */
#define MINIVAS_PLAY		0x2B	/* Play continuously */
#define MINIVAS_STOP		0x20	/* STOP */
#define MINIVAS_STILL		0x2D	/* STILL */
#define MINIVAS_REC		0x52	/* REC */
#define	MINIVAS_GRAB		0x52	/* GRAB (yes it is the same a REC) */
#define MINIVAS_PREBLACK	0x73	/* PREBLACK with VIFC FRAME CODE */
#define MINIVAS_EE		0x2F	/* Cue the tape for recording */
#define	MINIVAS_FRAME_CHANGE	0x4E	/* Change nbr frames per record/grab */
#define MINIVAS_GETTC		0x63	/* Ask minivas to return time code */

#define	MINIVAS_INITIALIZE	0x49	/* Initialize minivas */
#define	MINIVAS_IDENTIFY	0x3f	/* Identify VTR type last programmed */
#define	MINIVAS_IFSWITCH	0x56	/* Set the VTR type */

/*
 * VTR identification codes
 */

#define	MINIVAS_AMPEX_VPR3	0x4133	/* Ampex VPR-3 (NTSC/PAL) */
#define	MINIVAS_AMPEX_VPR6	0x4136	/* Ampex VPR-6 (NTSC/PAL) */
#define	MINIVAS_AMPEX_VPR80	0x4138	/* Ampex VPR-80 (NTSC/PAL) */
#define	MINIVAS_AMPEX_VPR80TC	0x4154	/* Ampex VPR-80 with SMPTE TC option */
#define	MINIVAS_AMPEX_CVR40	0x5342	/* Ampex CVR-40 (NTSC/PAL) */
#define	MINIVAS_AMPEX_CVR75	0x5350	/* Ampex CVR-75 (NTSC/PAL) */
#define	MINIVAS_JVC_CR850	0x4A55	/* JVC series CR850 NTSC */
#define	MINIVAS_JVC_PR900	0x4A55	/* JVC series PR900 E PAL */
#define	MINIVAS_JVC_BRS811U	0x4A56	/* JVC BRS811U */
#define	MINIVAS_ABEKAS_A60	0x4142	/* Abekas A60 video disk */
#define	MINIVAS_PAN_AU650TC	0x5035	/* Panasonic AU650 MII NTSC TC mode */
#define	MINIVAS_PAN_AU650	0x5036	/* Panasonic AU650 MII NTSC */
#define	MINIVAS_PAN_AG7500	0x5053	/* Panasonic AG7500 SuperVHS NTSC */
#define	MINIVAS_SONY_BVW40	0x5342	/* Sony BVW40 (NTSC/PAL) */
#define	MINIVAS_SONY_BVW75	0x5350	/* Sony BVW75 (NTSC/PAL) */
#define	MINIVAS_SONY_BVU800	0x5355	/* Sony BVU800 (NTSC) */
#define	MINIVAS_SONY_BVU800TC	0x5355	/* Sony BVU800 (NTSC) with TC option */
#define	MINIVAS_SONY_BVU950	0x5347	/* Sony BVU950 (NTSC/PAL) */
#define	MINIVAS_SONY_BVU950TC	0x5348	/* Sony BVU950 (NTSC/PAL) w/ TC option */
#define	MINIVAS_SONY_VO5850	0x5335	/* Sony VO-5850 (NTSC) */
#define	MINIVAS_SONY_VO5850P	0x5335	/* Sony VO-5850 P (PAL) */
#define	MINIVAS_SONY_BVH2000	0x5343	/* Sony BVH-2000 Series (NTSC/PAL) */
#define	MINIVAS_SONY_BVH2500	0x5344	/* Sony BVH-2500 (NTSC/PAL) */
#define	MINIVAS_SONY_VBH3000	0x5346	/* Sony BVW40 (NTSC/PAL) */
#define	MINIVAS_SONY_LVR5000	0x534C	/* Sony LVR5000 WORM optical disk */
#define	MINIVAS_SONY_DVR1000	0x5342	/* Sony DVR 1000 */
#define	MINIVAS_SONY_DVR10	0x5353	/* Sony DVR 10 */
#define	MINIVAS_SONY_VO9850	0x534D	/* Sony VO 9850 */
#define	MINIVAS_SONY_VO9850TC	0x534E	/* Sony V0 9850 with timecodes */

#define MINIVAS_NUM_0		0x30	/* NUMeral 0 */
#define MINIVAS_NUM_1		0x31	/* NUMeral 1 */
#define MINIVAS_NUM_2		0x32	/* NUMeral 2 */
#define MINIVAS_NUM_3		0x33	/* NUMeral 3 */
#define MINIVAS_NUM_4		0x34	/* NUMeral 4 */
#define MINIVAS_NUM_5		0x35	/* NUMeral 5 */
#define MINIVAS_NUM_6		0x36	/* NUMeral 6 */
#define MINIVAS_NUM_7		0x37	/* NUMeral 7 */
#define MINIVAS_NUM_8		0x38	/* NUMeral 8 */
#define MINIVAS_NUM_9		0x39	/* NUMeral 9 */

#define MINIVAS_ENTER		0x3A	/* ENTER */
#define MINIVAS_CE		0x3B	/* Clear Entry */
/*
 * Fastest transport motion commands
 */
#define MINIVAS_REWIND		0x3C	/* Rewind */
#define MINIVAS_FAST_FORWARD	0x3E	/* Fast Forward */
/*
 * Var speeds
 */
#define MINIVAS_SET_SPEED	0x2A	/* Set slow forward or reverse speed */
#define MINIVAS_SLOW_FORWARD	0x29	/* variable slow forward */
#define MINIVAS_SLOW_REVERSE	0x28	/* variable slow reverse */
#define MINIVAS_VAR_F_SHUTTLE	0x6B	/* shuttle forward at set speed */
#define MINIVAS_VAR_R_SHUTTLE	0x6A	/* shuttle reverse at set speed */
/*
 * Fixed speeds.
 */
#define MINIVAS_FORWARD_STEP	0x7D	/* 1/30 play speed */
#define MINIVAS_REVERSE_STEP	0x7B	/* 1/30 play speed */

#define MINIVAS_SHUTTLE_FORWARD 0x5D	/* 5X play speed */
#define MINIVAS_SHUTTLE_REVERSE 0x5B	/* 5X play speed */


#define MINIVAS_SEARCH_MARK	0x4D	/* SEARCH to MARK */
#define MINIVAS_SET_MARK	0x6D	/* SET MARK */

#define MINIVAS_WHERE_FRAME	0x43	/* Get the current point in frame */
#define MINIVAS_WHERE_TCODE	0x63	/* Get the current point in time code */
 
/*
 * Alert characters, response for the commands.
 */

#define MINIVAS_A_Q		0x3F	/* Not valid data entry */
#define MINIVAS_A_B		0x42	/* No VIFC in tape */
#define MINIVAS_A_D		0x44	/* Recording done */
#define MINIVAS_A_E		0x45	/* After programming done */
#define MINIVAS_A_F		0x46	/* Search frame found */
#define MINIVAS_A_I		0x49	/* After Init or Interface switch */
#define MINIVAS_A_K		0x4B	/* Too far to search */
#define MINIVAS_A_M		0x4D	/* Preroll failed */
#define MINIVAS_A_P		0x50	/* ready to program */
#define MINIVAS_A_R		0x52	/* Ready for RECORD command */
#define MINIVAS_A_S		0x53	/* Preblack finished */
#define MINIVAS_A_V		0x56	/* No sync from input video */
#define MINIVAS_A_X		0x58	/* At before record cut in */
#define MINIVAS_A_Y		0x59	/* At before record cut out */
#define MINIVAS_A_Z		0x5A	/* At before record cut out */
#define MINIVAS_A_U		0x55	/* Write protect error */
#define	MINIVAS_A_H		0x48	/* Ready to accept grab timecode */
